'''Wrapper for rtgeom.h

Generated with:
ctypesgen.py -lrt /home/kanzure/local/brlcad/brlcad/include/rtgeom.h -o rtgeom.py

Do not modify this file.
'''

__docformat__ =  'restructuredtext'

# Begin preamble

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, 'c_int64'):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types

class c_void(Structure):
    # c_void_p is a buggy return type, converting to int, so
    # POINTER(None) == c_void_p is actually written as
    # POINTER(c_void), so it can be treated as a real pointer.
    _fields_ = [('dummy', c_int)]

def POINTER(obj):
    p = ctypes.POINTER(obj)

    # Convert None to a real NULL pointer to work around bugs
    # in how ctypes handles None on 64-bit platforms
    if not isinstance(p.from_param, classmethod):
        def from_param(cls, x):
            if x is None:
                return cls()
            else:
                return x
        p.from_param = classmethod(from_param)

    return p

class UserString:
    def __init__(self, seq):
        if isinstance(seq, basestring):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq)
    def __str__(self): return str(self.data)
    def __repr__(self): return repr(self.data)
    def __int__(self): return int(self.data)
    def __long__(self): return long(self.data)
    def __float__(self): return float(self.data)
    def __complex__(self): return complex(self.data)
    def __hash__(self): return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)
    def __contains__(self, char):
        return char in self.data

    def __len__(self): return len(self.data)
    def __getitem__(self, index): return self.__class__(self.data[index])
    def __getslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, basestring):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other))
    def __radd__(self, other):
        if isinstance(other, basestring):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other) + self.data)
    def __mul__(self, n):
        return self.__class__(self.data*n)
    __rmul__ = __mul__
    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self): return self.__class__(self.data.capitalize())
    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))
    def count(self, sub, start=0, end=sys.maxint):
        return self.data.count(sub, start, end)
    def decode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())
    def encode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())
    def endswith(self, suffix, start=0, end=sys.maxint):
        return self.data.endswith(suffix, start, end)
    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))
    def find(self, sub, start=0, end=sys.maxint):
        return self.data.find(sub, start, end)
    def index(self, sub, start=0, end=sys.maxint):
        return self.data.index(sub, start, end)
    def isalpha(self): return self.data.isalpha()
    def isalnum(self): return self.data.isalnum()
    def isdecimal(self): return self.data.isdecimal()
    def isdigit(self): return self.data.isdigit()
    def islower(self): return self.data.islower()
    def isnumeric(self): return self.data.isnumeric()
    def isspace(self): return self.data.isspace()
    def istitle(self): return self.data.istitle()
    def isupper(self): return self.data.isupper()
    def join(self, seq): return self.data.join(seq)
    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))
    def lower(self): return self.__class__(self.data.lower())
    def lstrip(self, chars=None): return self.__class__(self.data.lstrip(chars))
    def partition(self, sep):
        return self.data.partition(sep)
    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))
    def rfind(self, sub, start=0, end=sys.maxint):
        return self.data.rfind(sub, start, end)
    def rindex(self, sub, start=0, end=sys.maxint):
        return self.data.rindex(sub, start, end)
    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))
    def rpartition(self, sep):
        return self.data.rpartition(sep)
    def rstrip(self, chars=None): return self.__class__(self.data.rstrip(chars))
    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)
    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)
    def splitlines(self, keepends=0): return self.data.splitlines(keepends)
    def startswith(self, prefix, start=0, end=sys.maxint):
        return self.data.startswith(prefix, start, end)
    def strip(self, chars=None): return self.__class__(self.data.strip(chars))
    def swapcase(self): return self.__class__(self.data.swapcase())
    def title(self): return self.__class__(self.data.title())
    def translate(self, *args):
        return self.__class__(self.data.translate(*args))
    def upper(self): return self.__class__(self.data.upper())
    def zfill(self, width): return self.__class__(self.data.zfill(width))

class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""
    def __init__(self, string=""):
        self.data = string
    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")
    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + sub + self.data[index+1:]
    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + self.data[index+1:]
    def __setslice__(self, start, end, sub):
        start = max(start, 0); end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start]+sub.data+self.data[end:]
        elif isinstance(sub, basestring):
            self.data = self.data[:start]+sub+self.data[end:]
        else:
            self.data =  self.data[:start]+str(sub)+self.data[end:]
    def __delslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]
    def immutable(self):
        return UserString(self.data)
    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, basestring):
            self.data += other
        else:
            self.data += str(other)
        return self
    def __imul__(self, n):
        self.data *= n
        return self

class String(MutableString, Union):

    _fields_ = [('raw', POINTER(c_char)),
                ('data', c_char_p)]

    def __init__(self, obj=""):
        if isinstance(obj, (str, unicode, UserString)):
            self.data = str(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj)

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)
    from_param = classmethod(from_param)

def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)

# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if (hasattr(type, "_type_") and isinstance(type._type_, str)
        and type._type_ != "P"):
        return type
    else:
        return c_void_p

# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self,func,restype,argtypes):
        self.func=func
        self.func.restype=restype
        self.argtypes=argtypes
    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func
    def __call__(self,*args):
        fixed_args=[]
        i=0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i+=1
        return self.func(*fixed_args+list(args[i:]))

# End preamble

_libs = {}
_libdirs = []

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import platform
import ctypes
import ctypes.util

def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []

class LibraryLoader(object):
    def __init__(self):
        self.other_dirs=[]

    def load_library(self,libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            if os.path.exists(path):
                return self.load(path)

        raise ImportError("%s not found." % libname)

    def load(self,path):
        """Given a path to a library, load it."""
        try:
            # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
            # of the default RTLD_LOCAL.  Without this, you end up with
            # libraries not being loadable, resulting in "Symbol not found"
            # errors
            if sys.platform == 'darwin':
                return ctypes.CDLL(path, ctypes.RTLD_GLOBAL)
            else:
                return ctypes.cdll.LoadLibrary(path)
        except OSError,e:
            raise ImportError(e)

    def getpaths(self,libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname
        else:
            # FIXME / TODO return '.' and os.path.dirname(__file__)
            for path in self.getplatformpaths(libname):
                yield path

            path = ctypes.util.find_library(libname)
            if path: yield path

    def getplatformpaths(self, libname):
        return []

# Darwin (Mac OS X)

class DarwinLibraryLoader(LibraryLoader):
    name_formats = ["lib%s.dylib", "lib%s.so", "lib%s.bundle", "%s.dylib",
                "%s.so", "%s.bundle", "%s"]

    def getplatformpaths(self,libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir,name)

    def getdirs(self,libname):
        '''Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        '''

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser('~/lib'),
                                          '/usr/local/lib', '/usr/lib']

        dirs = []

        if '/' in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        dirs.extend(self.other_dirs)
        dirs.append(".")
        dirs.append(os.path.dirname(__file__))

        if hasattr(sys, 'frozen') and sys.frozen == 'macosx_app':
            dirs.append(os.path.join(
                os.environ['RESOURCEPATH'],
                '..',
                'Frameworks'))

        dirs.extend(dyld_fallback_library_path)

        return dirs

# Posix

class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = []
        for name in ("LD_LIBRARY_PATH",
                     "SHLIB_PATH", # HPUX
                     "LIBPATH", # OS/2, AIX
                     "LIBRARY_PATH", # BE/OS
                    ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))
        directories.extend(self.other_dirs)
        directories.append(".")
        directories.append(os.path.dirname(__file__))

        try: directories.extend([dir.strip() for dir in open('/etc/ld.so.conf')])
        except IOError: pass

        unix_lib_dirs_list = ['/lib', '/usr/lib', '/lib64', '/usr/lib64']
        if sys.platform.startswith('linux'):
            # Try and support multiarch work in Ubuntu
            # https://wiki.ubuntu.com/MultiarchSpec
            bitage = platform.architecture()[0]
            if bitage.startswith('32'):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ['/lib/i386-linux-gnu', '/usr/lib/i386-linux-gnu']
            elif bitage.startswith('64'):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ['/lib/x86_64-linux-gnu', '/usr/lib/x86_64-linux-gnu']
            else:
                # guess...
                unix_lib_dirs_list += glob.glob('/lib/*linux-gnu')
        directories.extend(unix_lib_dirs_list)

        cache = {}
        lib_re = re.compile(r'lib(.*)\.s[ol]')
        ext_re = re.compile(r'\.s[ol]$')
        for dir in directories:
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    if file not in cache:
                        cache[file] = path

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        if library not in cache:
                            cache[library] = path
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname)
        if result: yield result

        path = ctypes.util.find_library(libname)
        if path: yield os.path.join("/lib",path)

# Windows

class _WindowsLibrary(object):
    def __init__(self, path):
        self.cdll = ctypes.cdll.LoadLibrary(path)
        self.windll = ctypes.windll.LoadLibrary(path)

    def __getattr__(self, name):
        try: return getattr(self.cdll,name)
        except AttributeError:
            try: return getattr(self.windll,name)
            except AttributeError:
                raise

class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll"]

    def load_library(self, libname):
        try:
            result = LibraryLoader.load_library(self, libname)
        except ImportError:
            result = None
            if os.path.sep not in libname:
                for name in self.name_formats:
                    try:
                        result = getattr(ctypes.cdll, name % libname)
                        if result:
                            break
                    except WindowsError:
                        result = None
            if result is None:
                try:
                    result = getattr(ctypes.cdll, libname)
                except WindowsError:
                    result = None
            if result is None:
                raise ImportError("%s not found." % libname)
        return result

    def load(self, path):
        return _WindowsLibrary(path)

    def getplatformpaths(self, libname):
        if os.path.sep not in libname:
            for name in self.name_formats:
                dll_in_current_dir = os.path.abspath(name % libname)
                if os.path.exists(dll_in_current_dir):
                    yield dll_in_current_dir
                path = ctypes.util.find_library(name % libname)
                if path:
                    yield path

# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin":   DarwinLibraryLoader,
    "cygwin":   WindowsLibraryLoader,
    "win32":    WindowsLibraryLoader
}

loader = loaderclass.get(sys.platform, PosixLibraryLoader)()

def add_library_search_dirs(other_dirs):
    loader.other_dirs = other_dirs

load_library = loader.load_library

del loaderclass

# End loader

add_library_search_dirs([])

# Begin libraries

_libs["rt"] = load_library("rt")

# 1 libraries
# End libraries

# No modules

__time_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 148

time_t = __time_t # /usr/include/time.h: 75

genptr_t = POINTER(None) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 400

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 912
class struct_bu_list(Structure):
    pass

struct_bu_list.__slots__ = [
    'magic',
    'forw',
    'back',
]
struct_bu_list._fields_ = [
    ('magic', c_uint32),
    ('forw', POINTER(struct_bu_list)),
    ('back', POINTER(struct_bu_list)),
]

fastf_t = c_double # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1281

bitv_t = c_ubyte # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1391

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1437
class struct_bu_bitv(Structure):
    pass

struct_bu_bitv.__slots__ = [
    'l',
    'nbits',
    'bits',
]
struct_bu_bitv._fields_ = [
    ('l', struct_bu_list),
    ('nbits', c_size_t),
    ('bits', bitv_t * 2),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1807
class struct_bu_mapped_file(Structure):
    pass

struct_bu_mapped_file.__slots__ = [
    'l',
    'name',
    'buf',
    'buflen',
    'is_mapped',
    'appl',
    'apbuf',
    'apbuflen',
    'modtime',
    'uses',
    'dont_restat',
]
struct_bu_mapped_file._fields_ = [
    ('l', struct_bu_list),
    ('name', String),
    ('buf', genptr_t),
    ('buflen', c_size_t),
    ('is_mapped', c_int),
    ('appl', String),
    ('apbuf', genptr_t),
    ('apbuflen', c_size_t),
    ('modtime', time_t),
    ('uses', c_int),
    ('dont_restat', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2026
class struct_bu_vls(Structure):
    pass

struct_bu_vls.__slots__ = [
    'vls_magic',
    'vls_str',
    'vls_offset',
    'vls_len',
    'vls_max',
]
struct_bu_vls._fields_ = [
    ('vls_magic', c_uint32),
    ('vls_str', String),
    ('vls_offset', c_size_t),
    ('vls_len', c_size_t),
    ('vls_max', c_size_t),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2385
class struct_bu_color(Structure):
    pass

struct_bu_color.__slots__ = [
    'buc_magic',
    'buc_rgb',
]
struct_bu_color._fields_ = [
    ('buc_magic', c_uint32),
    ('buc_rgb', fastf_t * 3),
]

vect2d_t = fastf_t * 2 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 222

point2d_t = fastf_t * 2 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 228

vect_t = fastf_t * 3 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 234

point_t = fastf_t * 3 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 240

mat_t = fastf_t * (4 * 4) # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 255

plane_t = fastf_t * 4 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 305

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 159
class struct_knot_vector(Structure):
    pass

struct_knot_vector.__slots__ = [
    'magic',
    'k_size',
    'knots',
]
struct_knot_vector._fields_ = [
    ('magic', c_uint32),
    ('k_size', c_int),
    ('knots', POINTER(fastf_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 281
class struct_face_g_snurb(Structure):
    pass

struct_face_g_snurb.__slots__ = [
    'l',
    'f_hd',
    'order',
    'u',
    'v',
    's_size',
    'pt_type',
    'ctl_points',
    'dir',
    'min_pt',
    'max_pt',
    'index',
]
struct_face_g_snurb._fields_ = [
    ('l', struct_bu_list),
    ('f_hd', struct_bu_list),
    ('order', c_int * 2),
    ('u', struct_knot_vector),
    ('v', struct_knot_vector),
    ('s_size', c_int * 2),
    ('pt_type', c_int),
    ('ctl_points', POINTER(fastf_t)),
    ('dir', c_int),
    ('min_pt', point_t),
    ('max_pt', point_t),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/brep.h: 68
class struct__on_brep_placeholder(Structure):
    pass

struct__on_brep_placeholder.__slots__ = [
    'dummy',
]
struct__on_brep_placeholder._fields_ = [
    ('dummy', c_int),
]

ON_Brep = struct__on_brep_placeholder # /home/kanzure/local/brlcad/brlcad/include/brep.h: 68

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 52
class struct_rt_tor_internal(Structure):
    pass

struct_rt_tor_internal.__slots__ = [
    'magic',
    'v',
    'h',
    'r_h',
    'r_a',
    'a',
    'b',
    'r_b',
]
struct_rt_tor_internal._fields_ = [
    ('magic', c_uint32),
    ('v', point_t),
    ('h', vect_t),
    ('r_h', fastf_t),
    ('r_a', fastf_t),
    ('a', vect_t),
    ('b', vect_t),
    ('r_b', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 68
class struct_rt_tgc_internal(Structure):
    pass

struct_rt_tgc_internal.__slots__ = [
    'magic',
    'v',
    'h',
    'a',
    'b',
    'c',
    'd',
]
struct_rt_tgc_internal._fields_ = [
    ('magic', c_uint32),
    ('v', point_t),
    ('h', vect_t),
    ('a', vect_t),
    ('b', vect_t),
    ('c', vect_t),
    ('d', vect_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 82
class struct_rt_ell_internal(Structure):
    pass

struct_rt_ell_internal.__slots__ = [
    'magic',
    'v',
    'a',
    'b',
    'c',
]
struct_rt_ell_internal._fields_ = [
    ('magic', c_uint32),
    ('v', point_t),
    ('a', vect_t),
    ('b', vect_t),
    ('c', vect_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 94
class struct_rt_superell_internal(Structure):
    pass

struct_rt_superell_internal.__slots__ = [
    'magic',
    'v',
    'a',
    'b',
    'c',
    'n',
    'e',
]
struct_rt_superell_internal._fields_ = [
    ('magic', c_uint32),
    ('v', point_t),
    ('a', vect_t),
    ('b', vect_t),
    ('c', vect_t),
    ('n', c_double),
    ('e', c_double),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 136
class struct_rt_metaball_internal(Structure):
    pass

struct_rt_metaball_internal.__slots__ = [
    'magic',
    'method',
    'threshold',
    'initstep',
    'finalstep',
    'metaball_ctrl_head',
]
struct_rt_metaball_internal._fields_ = [
    ('magic', c_uint32),
    ('method', c_int),
    ('threshold', fastf_t),
    ('initstep', fastf_t),
    ('finalstep', fastf_t),
    ('metaball_ctrl_head', struct_bu_list),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 156
class struct_rt_arb_internal(Structure):
    pass

struct_rt_arb_internal.__slots__ = [
    'magic',
    'pt',
]
struct_rt_arb_internal._fields_ = [
    ('magic', c_uint32),
    ('pt', point_t * 8),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 165
class struct_rt_ars_internal(Structure):
    pass

struct_rt_ars_internal.__slots__ = [
    'magic',
    'ncurves',
    'pts_per_curve',
    'curves',
]
struct_rt_ars_internal._fields_ = [
    ('magic', c_uint32),
    ('ncurves', c_size_t),
    ('pts_per_curve', c_size_t),
    ('curves', POINTER(POINTER(fastf_t))),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 176
class struct_rt_half_internal(Structure):
    pass

struct_rt_half_internal.__slots__ = [
    'magic',
    'eqn',
]
struct_rt_half_internal._fields_ = [
    ('magic', c_uint32),
    ('eqn', plane_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 185
class struct_rt_grip_internal(Structure):
    pass

struct_rt_grip_internal.__slots__ = [
    'magic',
    'center',
    'normal',
    'mag',
]
struct_rt_grip_internal._fields_ = [
    ('magic', c_uint32),
    ('center', point_t),
    ('normal', vect_t),
    ('mag', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 200
class struct_rt_pg_face_internal(Structure):
    pass

struct_rt_pg_face_internal.__slots__ = [
    'npts',
    'verts',
    'norms',
]
struct_rt_pg_face_internal._fields_ = [
    ('npts', c_size_t),
    ('verts', POINTER(fastf_t)),
    ('norms', POINTER(fastf_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 197
class struct_rt_pg_internal(Structure):
    pass

struct_rt_pg_internal.__slots__ = [
    'magic',
    'npoly',
    'poly',
    'max_npts',
]
struct_rt_pg_internal._fields_ = [
    ('magic', c_uint32),
    ('npoly', c_size_t),
    ('poly', POINTER(struct_rt_pg_face_internal)),
    ('max_npts', c_size_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 211
class struct_rt_nurb_internal(Structure):
    pass

struct_rt_nurb_internal.__slots__ = [
    'magic',
    'nsrf',
    'srfs',
]
struct_rt_nurb_internal._fields_ = [
    ('magic', c_uint32),
    ('nsrf', c_int),
    ('srfs', POINTER(POINTER(struct_face_g_snurb))),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 226
class struct_rt_brep_internal(Structure):
    pass

struct_rt_brep_internal.__slots__ = [
    'magic',
    'brep',
]
struct_rt_brep_internal._fields_ = [
    ('magic', c_uint32),
    ('brep', POINTER(ON_Brep)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 249
class struct_rt_ebm_internal(Structure):
    pass

struct_rt_ebm_internal.__slots__ = [
    'magic',
    'file',
    'xdim',
    'ydim',
    'tallness',
    'mat',
    'mp',
]
struct_rt_ebm_internal._fields_ = [
    ('magic', c_uint32),
    ('file', c_char * 256),
    ('xdim', c_uint32),
    ('ydim', c_uint32),
    ('tallness', fastf_t),
    ('mat', mat_t),
    ('mp', POINTER(struct_bu_mapped_file)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 268
class struct_rt_vol_internal(Structure):
    pass

struct_rt_vol_internal.__slots__ = [
    'magic',
    'file',
    'xdim',
    'ydim',
    'zdim',
    'lo',
    'hi',
    'cellsize',
    'mat',
    'map',
]
struct_rt_vol_internal._fields_ = [
    ('magic', c_uint32),
    ('file', c_char * 128),
    ('xdim', c_uint32),
    ('ydim', c_uint32),
    ('zdim', c_uint32),
    ('lo', c_uint32),
    ('hi', c_uint32),
    ('cellsize', vect_t),
    ('mat', mat_t),
    ('map', POINTER(c_ubyte)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 289
class struct_rt_hf_internal(Structure):
    pass

struct_rt_hf_internal.__slots__ = [
    'magic',
    'cfile',
    'dfile',
    'fmt',
    'w',
    'n',
    'shorts',
    'file2mm',
    'v',
    'x',
    'y',
    'xlen',
    'ylen',
    'zscale',
    'mp',
]
struct_rt_hf_internal._fields_ = [
    ('magic', c_uint32),
    ('cfile', c_char * 128),
    ('dfile', c_char * 128),
    ('fmt', c_char * 8),
    ('w', c_uint32),
    ('n', c_uint32),
    ('shorts', c_uint32),
    ('file2mm', fastf_t),
    ('v', vect_t),
    ('x', vect_t),
    ('y', vect_t),
    ('xlen', fastf_t),
    ('ylen', fastf_t),
    ('zscale', fastf_t),
    ('mp', POINTER(struct_bu_mapped_file)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 316
class struct_rt_arbn_internal(Structure):
    pass

struct_rt_arbn_internal.__slots__ = [
    'magic',
    'neqn',
    'eqn',
]
struct_rt_arbn_internal._fields_ = [
    ('magic', c_uint32),
    ('neqn', c_size_t),
    ('eqn', POINTER(plane_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 326
class struct_rt_pipe_internal(Structure):
    pass

struct_rt_pipe_internal.__slots__ = [
    'pipe_magic',
    'pipe_segs_head',
    'pipe_count',
]
struct_rt_pipe_internal._fields_ = [
    ('pipe_magic', c_uint32),
    ('pipe_segs_head', struct_bu_list),
    ('pipe_count', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 337
class struct_rt_part_internal(Structure):
    pass

struct_rt_part_internal.__slots__ = [
    'part_magic',
    'part_V',
    'part_H',
    'part_vrad',
    'part_hrad',
    'part_type',
]
struct_rt_part_internal._fields_ = [
    ('part_magic', c_uint32),
    ('part_V', point_t),
    ('part_H', vect_t),
    ('part_vrad', fastf_t),
    ('part_hrad', fastf_t),
    ('part_type', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 355
class struct_rt_rpc_internal(Structure):
    pass

struct_rt_rpc_internal.__slots__ = [
    'rpc_magic',
    'rpc_V',
    'rpc_H',
    'rpc_B',
    'rpc_r',
]
struct_rt_rpc_internal._fields_ = [
    ('rpc_magic', c_uint32),
    ('rpc_V', point_t),
    ('rpc_H', vect_t),
    ('rpc_B', vect_t),
    ('rpc_r', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 367
class struct_rt_rhc_internal(Structure):
    pass

struct_rt_rhc_internal.__slots__ = [
    'rhc_magic',
    'rhc_V',
    'rhc_H',
    'rhc_B',
    'rhc_r',
    'rhc_c',
]
struct_rt_rhc_internal._fields_ = [
    ('rhc_magic', c_uint32),
    ('rhc_V', point_t),
    ('rhc_H', vect_t),
    ('rhc_B', vect_t),
    ('rhc_r', fastf_t),
    ('rhc_c', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 380
class struct_rt_epa_internal(Structure):
    pass

struct_rt_epa_internal.__slots__ = [
    'epa_magic',
    'epa_V',
    'epa_H',
    'epa_Au',
    'epa_r1',
    'epa_r2',
]
struct_rt_epa_internal._fields_ = [
    ('epa_magic', c_uint32),
    ('epa_V', point_t),
    ('epa_H', vect_t),
    ('epa_Au', vect_t),
    ('epa_r1', fastf_t),
    ('epa_r2', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 393
class struct_rt_ehy_internal(Structure):
    pass

struct_rt_ehy_internal.__slots__ = [
    'ehy_magic',
    'ehy_V',
    'ehy_H',
    'ehy_Au',
    'ehy_r1',
    'ehy_r2',
    'ehy_c',
]
struct_rt_ehy_internal._fields_ = [
    ('ehy_magic', c_uint32),
    ('ehy_V', point_t),
    ('ehy_H', vect_t),
    ('ehy_Au', vect_t),
    ('ehy_r1', fastf_t),
    ('ehy_r2', fastf_t),
    ('ehy_c', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 407
class struct_rt_hyp_internal(Structure):
    pass

struct_rt_hyp_internal.__slots__ = [
    'hyp_magic',
    'hyp_Vi',
    'hyp_Hi',
    'hyp_A',
    'hyp_b',
    'hyp_bnr',
]
struct_rt_hyp_internal._fields_ = [
    ('hyp_magic', c_uint32),
    ('hyp_Vi', point_t),
    ('hyp_Hi', vect_t),
    ('hyp_A', vect_t),
    ('hyp_b', fastf_t),
    ('hyp_bnr', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 421
class struct_rt_eto_internal(Structure):
    pass

struct_rt_eto_internal.__slots__ = [
    'eto_magic',
    'eto_V',
    'eto_N',
    'eto_C',
    'eto_r',
    'eto_rd',
]
struct_rt_eto_internal._fields_ = [
    ('eto_magic', c_uint32),
    ('eto_V', point_t),
    ('eto_N', vect_t),
    ('eto_C', vect_t),
    ('eto_r', fastf_t),
    ('eto_rd', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 457
class struct_rt_db_internal(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 435
class struct_rt_dsp_internal(Structure):
    pass

struct_rt_dsp_internal.__slots__ = [
    'magic',
    'dsp_name',
    'dsp_xcnt',
    'dsp_ycnt',
    'dsp_smooth',
    'dsp_cuttype',
    'dsp_mtos',
    'dsp_stom',
    'dsp_buf',
    'dsp_mp',
    'dsp_bip',
    'dsp_datasrc',
]
struct_rt_dsp_internal._fields_ = [
    ('magic', c_uint32),
    ('dsp_name', struct_bu_vls),
    ('dsp_xcnt', c_uint32),
    ('dsp_ycnt', c_uint32),
    ('dsp_smooth', c_ushort),
    ('dsp_cuttype', c_ubyte),
    ('dsp_mtos', mat_t),
    ('dsp_stom', mat_t),
    ('dsp_buf', POINTER(c_ushort)),
    ('dsp_mp', POINTER(struct_bu_mapped_file)),
    ('dsp_bip', POINTER(struct_rt_db_internal)),
    ('dsp_datasrc', c_char),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 473
class struct_rt_curve(Structure):
    pass

struct_rt_curve.__slots__ = [
    'count',
    'reverse',
    'segment',
]
struct_rt_curve._fields_ = [
    ('count', c_size_t),
    ('reverse', POINTER(c_int)),
    ('segment', POINTER(genptr_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 487
class struct_line_seg(Structure):
    pass

struct_line_seg.__slots__ = [
    'magic',
    'start',
    'end',
]
struct_line_seg._fields_ = [
    ('magic', c_uint32),
    ('start', c_int),
    ('end', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 494
class struct_carc_seg(Structure):
    pass

struct_carc_seg.__slots__ = [
    'magic',
    'start',
    'end',
    'radius',
    'center_is_left',
    'orientation',
    'center',
]
struct_carc_seg._fields_ = [
    ('magic', c_uint32),
    ('start', c_int),
    ('end', c_int),
    ('radius', fastf_t),
    ('center_is_left', c_int),
    ('orientation', c_int),
    ('center', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 508
class struct_nurb_seg(Structure):
    pass

struct_nurb_seg.__slots__ = [
    'magic',
    'order',
    'pt_type',
    'k',
    'c_size',
    'ctl_points',
    'weights',
]
struct_nurb_seg._fields_ = [
    ('magic', c_uint32),
    ('order', c_int),
    ('pt_type', c_int),
    ('k', struct_knot_vector),
    ('c_size', c_int),
    ('ctl_points', POINTER(c_int)),
    ('weights', POINTER(fastf_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 520
class struct_bezier_seg(Structure):
    pass

struct_bezier_seg.__slots__ = [
    'magic',
    'degree',
    'ctl_points',
]
struct_bezier_seg._fields_ = [
    ('magic', c_uint32),
    ('degree', c_int),
    ('ctl_points', POINTER(c_int)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 529
class struct_rt_sketch_internal(Structure):
    pass

struct_rt_sketch_internal.__slots__ = [
    'magic',
    'V',
    'u_vec',
    'v_vec',
    'vert_count',
    'verts',
    'curve',
]
struct_rt_sketch_internal._fields_ = [
    ('magic', c_uint32),
    ('V', point_t),
    ('u_vec', vect_t),
    ('v_vec', vect_t),
    ('vert_count', c_size_t),
    ('verts', POINTER(point2d_t)),
    ('curve', struct_rt_curve),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 559
class struct_db_i(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 551
class struct_rt_submodel_internal(Structure):
    pass

struct_rt_submodel_internal.__slots__ = [
    'magic',
    'file',
    'treetop',
    'meth',
    'root2leaf',
    'dbip',
]
struct_rt_submodel_internal._fields_ = [
    ('magic', c_uint32),
    ('file', struct_bu_vls),
    ('treetop', struct_bu_vls),
    ('meth', c_int),
    ('root2leaf', mat_t),
    ('dbip', POINTER(struct_db_i)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 567
class struct_rt_extrude_internal(Structure):
    pass

struct_rt_extrude_internal.__slots__ = [
    'magic',
    'V',
    'h',
    'u_vec',
    'v_vec',
    'keypoint',
    'sketch_name',
    'skt',
]
struct_rt_extrude_internal._fields_ = [
    ('magic', c_uint32),
    ('V', point_t),
    ('h', vect_t),
    ('u_vec', vect_t),
    ('v_vec', vect_t),
    ('keypoint', c_int),
    ('sketch_name', String),
    ('skt', POINTER(struct_rt_sketch_internal)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 589
class struct_rt_revolve_internal(Structure):
    pass

struct_rt_revolve_internal.__slots__ = [
    'magic',
    'v3d',
    'axis3d',
    'v2d',
    'axis2d',
    'r',
    'ang',
    'sketch_name',
    'skt',
]
struct_rt_revolve_internal._fields_ = [
    ('magic', c_uint32),
    ('v3d', point_t),
    ('axis3d', vect_t),
    ('v2d', point2d_t),
    ('axis2d', vect2d_t),
    ('r', vect_t),
    ('ang', fastf_t),
    ('sketch_name', struct_bu_vls),
    ('skt', POINTER(struct_rt_sketch_internal)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 610
class struct_rt_cline_internal(Structure):
    pass

struct_rt_cline_internal.__slots__ = [
    'magic',
    'v',
    'h',
    'radius',
    'thickness',
]
struct_rt_cline_internal._fields_ = [
    ('magic', c_uint32),
    ('v', point_t),
    ('h', vect_t),
    ('radius', fastf_t),
    ('thickness', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 624
class struct_rt_bot_internal(Structure):
    pass

struct_rt_bot_internal.__slots__ = [
    'magic',
    'mode',
    'orientation',
    'bot_flags',
    'num_vertices',
    'num_faces',
    'faces',
    'vertices',
    'thickness',
    'face_mode',
    'num_normals',
    'normals',
    'num_face_normals',
    'face_normals',
    'tie',
]
struct_rt_bot_internal._fields_ = [
    ('magic', c_uint32),
    ('mode', c_ubyte),
    ('orientation', c_ubyte),
    ('bot_flags', c_ubyte),
    ('num_vertices', c_size_t),
    ('num_faces', c_size_t),
    ('faces', POINTER(c_int)),
    ('vertices', POINTER(fastf_t)),
    ('thickness', POINTER(fastf_t)),
    ('face_mode', POINTER(struct_bu_bitv)),
    ('num_normals', c_size_t),
    ('normals', POINTER(fastf_t)),
    ('num_face_normals', c_size_t),
    ('face_normals', POINTER(c_int)),
    ('tie', POINTER(None)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 669
class struct_rt_bot_list(Structure):
    pass

struct_rt_bot_list.__slots__ = [
    'l',
    'bot',
]
struct_rt_bot_list._fields_ = [
    ('l', struct_bu_list),
    ('bot', POINTER(struct_rt_bot_internal)),
]

enum_anon_45 = c_int # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_PNT = 0 # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_COL = (0 + 1) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_SCA = (0 + 2) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_NRM = (0 + 4) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_COL_SCA = ((0 + 1) + 2) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_COL_NRM = ((0 + 1) + 4) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_SCA_NRM = ((0 + 2) + 4) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

RT_PNT_TYPE_COL_SCA_NRM = (((0 + 1) + 2) + 4) # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

rt_pnt_type = enum_anon_45 # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 731

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 733
class struct_pnt(Structure):
    pass

struct_pnt.__slots__ = [
    'l',
    'v',
]
struct_pnt._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 737
class struct_pnt_color(Structure):
    pass

struct_pnt_color.__slots__ = [
    'l',
    'v',
    'c',
]
struct_pnt_color._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('c', struct_bu_color),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 742
class struct_pnt_scale(Structure):
    pass

struct_pnt_scale.__slots__ = [
    'l',
    'v',
    's',
]
struct_pnt_scale._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('s', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 747
class struct_pnt_normal(Structure):
    pass

struct_pnt_normal.__slots__ = [
    'l',
    'v',
    'n',
]
struct_pnt_normal._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('n', vect_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 752
class struct_pnt_color_scale(Structure):
    pass

struct_pnt_color_scale.__slots__ = [
    'l',
    'v',
    'c',
    's',
]
struct_pnt_color_scale._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('c', struct_bu_color),
    ('s', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 758
class struct_pnt_color_normal(Structure):
    pass

struct_pnt_color_normal.__slots__ = [
    'l',
    'v',
    'c',
    'n',
]
struct_pnt_color_normal._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('c', struct_bu_color),
    ('n', vect_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 764
class struct_pnt_scale_normal(Structure):
    pass

struct_pnt_scale_normal.__slots__ = [
    'l',
    'v',
    's',
    'n',
]
struct_pnt_scale_normal._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('s', fastf_t),
    ('n', vect_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 770
class struct_pnt_color_scale_normal(Structure):
    pass

struct_pnt_color_scale_normal.__slots__ = [
    'l',
    'v',
    'c',
    's',
    'n',
]
struct_pnt_color_scale_normal._fields_ = [
    ('l', struct_bu_list),
    ('v', point_t),
    ('c', struct_bu_color),
    ('s', fastf_t),
    ('n', vect_t),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 779
class struct_rt_pnts_internal(Structure):
    pass

struct_rt_pnts_internal.__slots__ = [
    'magic',
    'scale',
    'type',
    'count',
    'point',
]
struct_rt_pnts_internal._fields_ = [
    ('magic', c_uint32),
    ('scale', c_double),
    ('type', rt_pnt_type),
    ('count', c_ulong),
    ('point', POINTER(None)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 796
class struct_rt_annotation_internal(Structure):
    pass

struct_rt_annotation_internal.__slots__ = [
    'magic',
    'V',
    'h',
    'u_vec',
    'v_vec',
    'view_aligned',
    'label',
    'skt',
]
struct_rt_annotation_internal._fields_ = [
    ('magic', c_uint32),
    ('V', point_t),
    ('h', vect_t),
    ('u_vec', vect_t),
    ('v_vec', vect_t),
    ('view_aligned', c_int),
    ('label', struct_bu_vls),
    ('skt', POINTER(struct_rt_sketch_internal)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 815
class struct_rt_hrt_internal(Structure):
    pass

struct_rt_hrt_internal.__slots__ = [
    'hrt_magic',
    'v',
    'xdir',
    'ydir',
    'zdir',
    'd',
]
struct_rt_hrt_internal._fields_ = [
    ('hrt_magic', c_uint32),
    ('v', point_t),
    ('xdir', vect_t),
    ('ydir', vect_t),
    ('zdir', vect_t),
    ('d', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 102
try:
    RT_BREP_INTERNAL_MAGIC = 1112687952
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 47
try:
    NAMELEN = 16
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 139
try:
    METABALL_METABALL = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 140
try:
    METABALL_ISOPOTENTIAL = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 141
try:
    METABALL_BLOB = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 234
def RT_BREP_TEST_MAGIC(_p):
    return (_p and ((_p[0]) == RT_BREP_INTERNAL_MAGIC))

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 248
try:
    RT_EBM_NAME_LEN = 256
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 267
try:
    RT_VOL_NAME_LEN = 128
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 348
try:
    RT_PARTICLE_TYPE_SPHERE = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 349
try:
    RT_PARTICLE_TYPE_CYLINDER = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 350
try:
    RT_PARTICLE_TYPE_CONE = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 434
try:
    DSP_NAME_LEN = 128
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 446
try:
    DSP_CUT_DIR_ADAPT = 'a'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 447
try:
    DSP_CUT_DIR_llUR = 'l'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 448
try:
    DSP_CUT_DIR_ULlr = 'L'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 458
try:
    RT_DSP_SRC_V4_FILE = '4'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 459
try:
    RT_DSP_SRC_FILE = 'f'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 460
try:
    RT_DSP_SRC_OBJ = 'o'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 528
try:
    SKETCH_NAME_LEN = 16
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 676
try:
    RT_BOT_UNORIENTED = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 677
try:
    RT_BOT_CCW = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 678
try:
    RT_BOT_CW = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 681
try:
    RT_BOT_SURFACE = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 682
try:
    RT_BOT_SOLID = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 689
try:
    RT_BOT_PLATE = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 695
try:
    RT_BOT_PLATE_NOCOS = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 698
try:
    RT_BOT_HAS_SURFACE_NORMALS = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 699
try:
    RT_BOT_USE_NORMALS = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 700
try:
    RT_BOT_USE_FLOATS = 4
except:
    pass

rt_tor_internal = struct_rt_tor_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 52

rt_tgc_internal = struct_rt_tgc_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 68

rt_ell_internal = struct_rt_ell_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 82

rt_superell_internal = struct_rt_superell_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 94

rt_metaball_internal = struct_rt_metaball_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 136

rt_arb_internal = struct_rt_arb_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 156

rt_ars_internal = struct_rt_ars_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 165

rt_half_internal = struct_rt_half_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 176

rt_grip_internal = struct_rt_grip_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 185

rt_pg_face_internal = struct_rt_pg_face_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 200

rt_pg_internal = struct_rt_pg_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 197

rt_nurb_internal = struct_rt_nurb_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 211

rt_brep_internal = struct_rt_brep_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 226

rt_ebm_internal = struct_rt_ebm_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 249

rt_vol_internal = struct_rt_vol_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 268

rt_hf_internal = struct_rt_hf_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 289

rt_arbn_internal = struct_rt_arbn_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 316

rt_pipe_internal = struct_rt_pipe_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 326

rt_part_internal = struct_rt_part_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 337

rt_rpc_internal = struct_rt_rpc_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 355

rt_rhc_internal = struct_rt_rhc_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 367

rt_epa_internal = struct_rt_epa_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 380

rt_ehy_internal = struct_rt_ehy_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 393

rt_hyp_internal = struct_rt_hyp_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 407

rt_eto_internal = struct_rt_eto_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 421

rt_db_internal = struct_rt_db_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 457

rt_dsp_internal = struct_rt_dsp_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 435

rt_curve = struct_rt_curve # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 473

line_seg = struct_line_seg # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 487

carc_seg = struct_carc_seg # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 494

nurb_seg = struct_nurb_seg # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 508

bezier_seg = struct_bezier_seg # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 520

rt_sketch_internal = struct_rt_sketch_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 529

db_i = struct_db_i # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 559

rt_submodel_internal = struct_rt_submodel_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 551

rt_extrude_internal = struct_rt_extrude_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 567

rt_revolve_internal = struct_rt_revolve_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 589

rt_cline_internal = struct_rt_cline_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 610

rt_bot_internal = struct_rt_bot_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 624

rt_bot_list = struct_rt_bot_list # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 669

pnt = struct_pnt # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 733

pnt_color = struct_pnt_color # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 737

pnt_scale = struct_pnt_scale # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 742

pnt_normal = struct_pnt_normal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 747

pnt_color_scale = struct_pnt_color_scale # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 752

pnt_color_normal = struct_pnt_color_normal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 758

pnt_scale_normal = struct_pnt_scale_normal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 764

pnt_color_scale_normal = struct_pnt_color_scale_normal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 770

rt_pnts_internal = struct_rt_pnts_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 779

rt_annotation_internal = struct_rt_annotation_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 796

rt_hrt_internal = struct_rt_hrt_internal # /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 815

# No inserted files

