'''Wrapper for wdb.h

Generated with:
ctypesgen.py -l/usr/brlcad/lib/libwdb.so -mbu /home/kanzure/local/brlcad/brlcad/include/wdb.h -o wdb.py

Do not modify this file.
'''

__docformat__ =  'restructuredtext'

# Begin preamble

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, 'c_int64'):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types

class c_void(Structure):
    # c_void_p is a buggy return type, converting to int, so
    # POINTER(None) == c_void_p is actually written as
    # POINTER(c_void), so it can be treated as a real pointer.
    _fields_ = [('dummy', c_int)]

def POINTER(obj):
    p = ctypes.POINTER(obj)

    # Convert None to a real NULL pointer to work around bugs
    # in how ctypes handles None on 64-bit platforms
    if not isinstance(p.from_param, classmethod):
        def from_param(cls, x):
            if x is None:
                return cls()
            else:
                return x
        p.from_param = classmethod(from_param)

    return p

class UserString:
    def __init__(self, seq):
        if isinstance(seq, basestring):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq)
    def __str__(self): return str(self.data)
    def __repr__(self): return repr(self.data)
    def __int__(self): return int(self.data)
    def __long__(self): return long(self.data)
    def __float__(self): return float(self.data)
    def __complex__(self): return complex(self.data)
    def __hash__(self): return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)
    def __contains__(self, char):
        return char in self.data

    def __len__(self): return len(self.data)
    def __getitem__(self, index): return self.__class__(self.data[index])
    def __getslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, basestring):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other))
    def __radd__(self, other):
        if isinstance(other, basestring):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other) + self.data)
    def __mul__(self, n):
        return self.__class__(self.data*n)
    __rmul__ = __mul__
    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self): return self.__class__(self.data.capitalize())
    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))
    def count(self, sub, start=0, end=sys.maxint):
        return self.data.count(sub, start, end)
    def decode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())
    def encode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())
    def endswith(self, suffix, start=0, end=sys.maxint):
        return self.data.endswith(suffix, start, end)
    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))
    def find(self, sub, start=0, end=sys.maxint):
        return self.data.find(sub, start, end)
    def index(self, sub, start=0, end=sys.maxint):
        return self.data.index(sub, start, end)
    def isalpha(self): return self.data.isalpha()
    def isalnum(self): return self.data.isalnum()
    def isdecimal(self): return self.data.isdecimal()
    def isdigit(self): return self.data.isdigit()
    def islower(self): return self.data.islower()
    def isnumeric(self): return self.data.isnumeric()
    def isspace(self): return self.data.isspace()
    def istitle(self): return self.data.istitle()
    def isupper(self): return self.data.isupper()
    def join(self, seq): return self.data.join(seq)
    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))
    def lower(self): return self.__class__(self.data.lower())
    def lstrip(self, chars=None): return self.__class__(self.data.lstrip(chars))
    def partition(self, sep):
        return self.data.partition(sep)
    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))
    def rfind(self, sub, start=0, end=sys.maxint):
        return self.data.rfind(sub, start, end)
    def rindex(self, sub, start=0, end=sys.maxint):
        return self.data.rindex(sub, start, end)
    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))
    def rpartition(self, sep):
        return self.data.rpartition(sep)
    def rstrip(self, chars=None): return self.__class__(self.data.rstrip(chars))
    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)
    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)
    def splitlines(self, keepends=0): return self.data.splitlines(keepends)
    def startswith(self, prefix, start=0, end=sys.maxint):
        return self.data.startswith(prefix, start, end)
    def strip(self, chars=None): return self.__class__(self.data.strip(chars))
    def swapcase(self): return self.__class__(self.data.swapcase())
    def title(self): return self.__class__(self.data.title())
    def translate(self, *args):
        return self.__class__(self.data.translate(*args))
    def upper(self): return self.__class__(self.data.upper())
    def zfill(self, width): return self.__class__(self.data.zfill(width))

class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""
    def __init__(self, string=""):
        self.data = string
    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")
    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + sub + self.data[index+1:]
    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + self.data[index+1:]
    def __setslice__(self, start, end, sub):
        start = max(start, 0); end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start]+sub.data+self.data[end:]
        elif isinstance(sub, basestring):
            self.data = self.data[:start]+sub+self.data[end:]
        else:
            self.data =  self.data[:start]+str(sub)+self.data[end:]
    def __delslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]
    def immutable(self):
        return UserString(self.data)
    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, basestring):
            self.data += other
        else:
            self.data += str(other)
        return self
    def __imul__(self, n):
        self.data *= n
        return self

class String(MutableString, Union):

    _fields_ = [('raw', POINTER(c_char)),
                ('data', c_char_p)]

    def __init__(self, obj=""):
        if isinstance(obj, (str, unicode, UserString)):
            self.data = str(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj)

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)
    from_param = classmethod(from_param)

def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)

# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if (hasattr(type, "_type_") and isinstance(type._type_, str)
        and type._type_ != "P"):
        return type
    else:
        return c_void_p

# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self,func,restype,argtypes):
        self.func=func
        self.func.restype=restype
        self.argtypes=argtypes
    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func
    def __call__(self,*args):
        fixed_args=[]
        i=0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i+=1
        return self.func(*fixed_args+list(args[i:]))

# End preamble

_libs = {}
_libdirs = []

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import platform
import ctypes
import ctypes.util

def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []

class LibraryLoader(object):
    def __init__(self):
        self.other_dirs=[]

    def load_library(self,libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            if os.path.exists(path):
                return self.load(path)

        raise ImportError("%s not found." % libname)

    def load(self,path):
        """Given a path to a library, load it."""
        try:
            # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
            # of the default RTLD_LOCAL.  Without this, you end up with
            # libraries not being loadable, resulting in "Symbol not found"
            # errors
            if sys.platform == 'darwin':
                return ctypes.CDLL(path, ctypes.RTLD_GLOBAL)
            else:
                return ctypes.cdll.LoadLibrary(path)
        except OSError,e:
            raise ImportError(e)

    def getpaths(self,libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname
        else:
            # FIXME / TODO return '.' and os.path.dirname(__file__)
            for path in self.getplatformpaths(libname):
                yield path

            path = ctypes.util.find_library(libname)
            if path: yield path

    def getplatformpaths(self, libname):
        return []

# Darwin (Mac OS X)

class DarwinLibraryLoader(LibraryLoader):
    name_formats = ["lib%s.dylib", "lib%s.so", "lib%s.bundle", "%s.dylib",
                "%s.so", "%s.bundle", "%s"]

    def getplatformpaths(self,libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir,name)

    def getdirs(self,libname):
        '''Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        '''

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser('~/lib'),
                                          '/usr/local/lib', '/usr/lib']

        dirs = []

        if '/' in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        dirs.extend(self.other_dirs)
        dirs.append(".")
        dirs.append(os.path.dirname(__file__))

        if hasattr(sys, 'frozen') and sys.frozen == 'macosx_app':
            dirs.append(os.path.join(
                os.environ['RESOURCEPATH'],
                '..',
                'Frameworks'))

        dirs.extend(dyld_fallback_library_path)

        return dirs

# Posix

class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = []
        for name in ("LD_LIBRARY_PATH",
                     "SHLIB_PATH", # HPUX
                     "LIBPATH", # OS/2, AIX
                     "LIBRARY_PATH", # BE/OS
                    ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))
        directories.extend(self.other_dirs)
        directories.append(".")
        directories.append(os.path.dirname(__file__))

        try: directories.extend([dir.strip() for dir in open('/etc/ld.so.conf')])
        except IOError: pass

        unix_lib_dirs_list = ['/lib', '/usr/lib', '/lib64', '/usr/lib64']
        if sys.platform.startswith('linux'):
            # Try and support multiarch work in Ubuntu
            # https://wiki.ubuntu.com/MultiarchSpec
            bitage = platform.architecture()[0]
            if bitage.startswith('32'):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ['/lib/i386-linux-gnu', '/usr/lib/i386-linux-gnu']
            elif bitage.startswith('64'):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ['/lib/x86_64-linux-gnu', '/usr/lib/x86_64-linux-gnu']
            else:
                # guess...
                unix_lib_dirs_list += glob.glob('/lib/*linux-gnu')
        directories.extend(unix_lib_dirs_list)

        cache = {}
        lib_re = re.compile(r'lib(.*)\.s[ol]')
        ext_re = re.compile(r'\.s[ol]$')
        for dir in directories:
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    if file not in cache:
                        cache[file] = path

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        if library not in cache:
                            cache[library] = path
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname)
        if result: yield result

        path = ctypes.util.find_library(libname)
        if path: yield os.path.join("/lib",path)

# Windows

class _WindowsLibrary(object):
    def __init__(self, path):
        self.cdll = ctypes.cdll.LoadLibrary(path)
        self.windll = ctypes.windll.LoadLibrary(path)

    def __getattr__(self, name):
        try: return getattr(self.cdll,name)
        except AttributeError:
            try: return getattr(self.windll,name)
            except AttributeError:
                raise

class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll"]

    def load_library(self, libname):
        try:
            result = LibraryLoader.load_library(self, libname)
        except ImportError:
            result = None
            if os.path.sep not in libname:
                for name in self.name_formats:
                    try:
                        result = getattr(ctypes.cdll, name % libname)
                        if result:
                            break
                    except WindowsError:
                        result = None
            if result is None:
                try:
                    result = getattr(ctypes.cdll, libname)
                except WindowsError:
                    result = None
            if result is None:
                raise ImportError("%s not found." % libname)
        return result

    def load(self, path):
        return _WindowsLibrary(path)

    def getplatformpaths(self, libname):
        if os.path.sep not in libname:
            for name in self.name_formats:
                dll_in_current_dir = os.path.abspath(name % libname)
                if os.path.exists(dll_in_current_dir):
                    yield dll_in_current_dir
                path = ctypes.util.find_library(name % libname)
                if path:
                    yield path

# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin":   DarwinLibraryLoader,
    "cygwin":   WindowsLibraryLoader,
    "win32":    WindowsLibraryLoader
}

loader = loaderclass.get(sys.platform, PosixLibraryLoader)()

def add_library_search_dirs(other_dirs):
    loader.other_dirs = other_dirs

load_library = loader.load_library

del loaderclass

# End loader

add_library_search_dirs([])

# Begin libraries

_libs["/usr/brlcad/lib/libwdb.so"] = load_library("/usr/brlcad/lib/libwdb.so")

# 1 libraries
# End libraries

# Begin modules

from bu import *

# 1 modules
# End modules

__off_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 140

__off64_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 141

__time_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 148

off_t = __off_t # /usr/include/x86_64-linux-gnu/sys/types.h: 86

time_t = __time_t # /usr/include/time.h: 75

# /usr/include/libio.h: 246
class struct__IO_FILE(Structure):
    pass

FILE = struct__IO_FILE # /usr/include/stdio.h: 48

_IO_lock_t = None # /usr/include/libio.h: 155

# /usr/include/libio.h: 161
class struct__IO_marker(Structure):
    pass

struct__IO_marker.__slots__ = [
    '_next',
    '_sbuf',
    '_pos',
]
struct__IO_marker._fields_ = [
    ('_next', POINTER(struct__IO_marker)),
    ('_sbuf', POINTER(struct__IO_FILE)),
    ('_pos', c_int),
]

struct__IO_FILE.__slots__ = [
    '_flags',
    '_IO_read_ptr',
    '_IO_read_end',
    '_IO_read_base',
    '_IO_write_base',
    '_IO_write_ptr',
    '_IO_write_end',
    '_IO_buf_base',
    '_IO_buf_end',
    '_IO_save_base',
    '_IO_backup_base',
    '_IO_save_end',
    '_markers',
    '_chain',
    '_fileno',
    '_flags2',
    '_old_offset',
    '_cur_column',
    '_vtable_offset',
    '_shortbuf',
    '_lock',
    '_offset',
    '__pad1',
    '__pad2',
    '__pad3',
    '__pad4',
    '__pad5',
    '_mode',
    '_unused2',
]
struct__IO_FILE._fields_ = [
    ('_flags', c_int),
    ('_IO_read_ptr', String),
    ('_IO_read_end', String),
    ('_IO_read_base', String),
    ('_IO_write_base', String),
    ('_IO_write_ptr', String),
    ('_IO_write_end', String),
    ('_IO_buf_base', String),
    ('_IO_buf_end', String),
    ('_IO_save_base', String),
    ('_IO_backup_base', String),
    ('_IO_save_end', String),
    ('_markers', POINTER(struct__IO_marker)),
    ('_chain', POINTER(struct__IO_FILE)),
    ('_fileno', c_int),
    ('_flags2', c_int),
    ('_old_offset', __off_t),
    ('_cur_column', c_ushort),
    ('_vtable_offset', c_char),
    ('_shortbuf', c_char * 1),
    ('_lock', POINTER(_IO_lock_t)),
    ('_offset', __off64_t),
    ('__pad1', POINTER(None)),
    ('__pad2', POINTER(None)),
    ('__pad3', POINTER(None)),
    ('__pad4', POINTER(None)),
    ('__pad5', c_size_t),
    ('_mode', c_int),
    ('_unused2', c_char * (((15 * sizeof(c_int)) - (4 * sizeof(POINTER(None)))) - sizeof(c_size_t))),
]

# /usr/include/tcl/tcl.h: 478
class struct_Tcl_Interp(Structure):
    pass

struct_Tcl_Interp.__slots__ = [
    'result',
    'freeProc',
    'errorLine',
]
struct_Tcl_Interp._fields_ = [
    ('result', String),
    ('freeProc', CFUNCTYPE(UNCHECKED(None), String)),
    ('errorLine', c_int),
]

Tcl_Interp = struct_Tcl_Interp # /usr/include/tcl/tcl.h: 478

genptr_t = POINTER(None) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 400

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 912
class struct_bu_list(Structure):
    pass

struct_bu_list.__slots__ = [
    'magic',
    'forw',
    'back',
]
struct_bu_list._fields_ = [
    ('magic', c_uint32),
    ('forw', POINTER(struct_bu_list)),
    ('back', POINTER(struct_bu_list)),
]

fastf_t = c_double # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1281

bitv_t = c_ubyte # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1391

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1437
class struct_bu_bitv(Structure):
    pass

struct_bu_bitv.__slots__ = [
    'l',
    'nbits',
    'bits',
]
struct_bu_bitv._fields_ = [
    ('l', struct_bu_list),
    ('nbits', c_size_t),
    ('bits', bitv_t * 2),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1607
class struct_bu_hist(Structure):
    pass

struct_bu_hist.__slots__ = [
    'magic',
    'hg_min',
    'hg_max',
    'hg_clumpsize',
    'hg_nsamples',
    'hg_nbins',
    'hg_bins',
]
struct_bu_hist._fields_ = [
    ('magic', c_uint32),
    ('hg_min', fastf_t),
    ('hg_max', fastf_t),
    ('hg_clumpsize', fastf_t),
    ('hg_nsamples', c_long),
    ('hg_nbins', c_long),
    ('hg_bins', POINTER(c_long)),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1691
class struct_bu_ptbl(Structure):
    pass

struct_bu_ptbl.__slots__ = [
    'l',
    'end',
    'blen',
    'buffer',
]
struct_bu_ptbl._fields_ = [
    ('l', struct_bu_list),
    ('end', off_t),
    ('blen', c_size_t),
    ('buffer', POINTER(POINTER(c_long))),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1807
class struct_bu_mapped_file(Structure):
    pass

struct_bu_mapped_file.__slots__ = [
    'l',
    'name',
    'buf',
    'buflen',
    'is_mapped',
    'appl',
    'apbuf',
    'apbuflen',
    'modtime',
    'uses',
    'dont_restat',
]
struct_bu_mapped_file._fields_ = [
    ('l', struct_bu_list),
    ('name', String),
    ('buf', genptr_t),
    ('buflen', c_size_t),
    ('is_mapped', c_int),
    ('appl', String),
    ('apbuf', genptr_t),
    ('apbuflen', c_size_t),
    ('modtime', time_t),
    ('uses', c_int),
    ('dont_restat', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1914
class struct_bu_attribute_value_pair(Structure):
    pass

struct_bu_attribute_value_pair.__slots__ = [
    'name',
    'value',
]
struct_bu_attribute_value_pair._fields_ = [
    ('name', String),
    ('value', String),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1932
class struct_bu_attribute_value_set(Structure):
    pass

struct_bu_attribute_value_set.__slots__ = [
    'magic',
    'count',
    'max',
    'readonly_min',
    'readonly_max',
    'avp',
]
struct_bu_attribute_value_set._fields_ = [
    ('magic', c_uint32),
    ('count', c_uint),
    ('max', c_uint),
    ('readonly_min', genptr_t),
    ('readonly_max', genptr_t),
    ('avp', POINTER(struct_bu_attribute_value_pair)),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2026
class struct_bu_vls(Structure):
    pass

struct_bu_vls.__slots__ = [
    'vls_magic',
    'vls_str',
    'vls_offset',
    'vls_len',
    'vls_max',
]
struct_bu_vls._fields_ = [
    ('vls_magic', c_uint32),
    ('vls_str', String),
    ('vls_offset', c_size_t),
    ('vls_len', c_size_t),
    ('vls_max', c_size_t),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2278
class struct_bu_structparse(Structure):
    pass

struct_bu_structparse.__slots__ = [
    'sp_fmt',
    'sp_count',
    'sp_name',
    'sp_offset',
    'sp_hook',
    'sp_desc',
    'sp_default',
]
struct_bu_structparse._fields_ = [
    ('sp_fmt', c_char * 4),
    ('sp_count', c_size_t),
    ('sp_name', String),
    ('sp_offset', c_size_t),
    ('sp_hook', CFUNCTYPE(UNCHECKED(None), )),
    ('sp_desc', String),
    ('sp_default', POINTER(None)),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2335
class struct_bu_external(Structure):
    pass

struct_bu_external.__slots__ = [
    'ext_magic',
    'ext_nbytes',
    'ext_buf',
]
struct_bu_external._fields_ = [
    ('ext_magic', c_uint32),
    ('ext_nbytes', c_size_t),
    ('ext_buf', POINTER(c_uint8)),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2620
class struct_bu_observer(Structure):
    pass

struct_bu_observer.__slots__ = [
    'l',
    'observer',
    'cmd',
]
struct_bu_observer._fields_ = [
    ('l', struct_bu_list),
    ('observer', struct_bu_vls),
    ('cmd', struct_bu_vls),
]

point2d_t = fastf_t * 2 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 228

vect_t = fastf_t * 3 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 234

point_t = fastf_t * 3 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 240

mat_t = fastf_t * (4 * 4) # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 255

matp_t = POINTER(fastf_t) # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 258

plane_t = fastf_t * 4 # /home/kanzure/local/brlcad/brlcad/include/vmath.h: 305

# /home/kanzure/local/brlcad/brlcad/include/bn.h: 105
class struct_bn_tol(Structure):
    pass

struct_bn_tol.__slots__ = [
    'magic',
    'dist',
    'dist_sq',
    'perp',
    'para',
]
struct_bn_tol._fields_ = [
    ('magic', c_uint32),
    ('dist', c_double),
    ('dist_sq', c_double),
    ('perp', c_double),
    ('para', c_double),
]

# /home/kanzure/local/brlcad/brlcad/include/bn.h: 3560
class struct_bn_table(Structure):
    pass

struct_bn_table.__slots__ = [
    'magic',
    'nx',
    'x',
]
struct_bn_table._fields_ = [
    ('magic', c_uint32),
    ('nx', c_size_t),
    ('x', fastf_t * 1),
]

# /home/kanzure/local/brlcad/brlcad/include/bn.h: 3587
class struct_bn_tabdata(Structure):
    pass

struct_bn_tabdata.__slots__ = [
    'magic',
    'ny',
    'table',
    'y',
]
struct_bn_tabdata._fields_ = [
    ('magic', c_uint32),
    ('ny', c_size_t),
    ('table', POINTER(struct_bn_table)),
    ('y', fastf_t * 1),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 159
class struct_knot_vector(Structure):
    pass

struct_knot_vector.__slots__ = [
    'magic',
    'k_size',
    'knots',
]
struct_knot_vector._fields_ = [
    ('magic', c_uint32),
    ('k_size', c_int),
    ('knots', POINTER(fastf_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 188
class struct_model(Structure):
    pass

struct_model.__slots__ = [
    'magic',
    'r_hd',
    'manifolds',
    'index',
    'maxindex',
]
struct_model._fields_ = [
    ('magic', c_uint32),
    ('r_hd', struct_bu_list),
    ('manifolds', String),
    ('index', c_long),
    ('maxindex', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 207
class struct_nmgregion_a(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 199
class struct_nmgregion(Structure):
    pass

struct_nmgregion.__slots__ = [
    'l',
    'm_p',
    'ra_p',
    's_hd',
    'index',
]
struct_nmgregion._fields_ = [
    ('l', struct_bu_list),
    ('m_p', POINTER(struct_model)),
    ('ra_p', POINTER(struct_nmgregion_a)),
    ('s_hd', struct_bu_list),
    ('index', c_long),
]

struct_nmgregion_a.__slots__ = [
    'magic',
    'min_pt',
    'max_pt',
    'index',
]
struct_nmgregion_a._fields_ = [
    ('magic', c_uint32),
    ('min_pt', point_t),
    ('max_pt', point_t),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 245
class struct_shell_a(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 501
class struct_vertexuse(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 233
class struct_shell(Structure):
    pass

struct_shell.__slots__ = [
    'l',
    'r_p',
    'sa_p',
    'fu_hd',
    'lu_hd',
    'eu_hd',
    'vu_p',
    'index',
]
struct_shell._fields_ = [
    ('l', struct_bu_list),
    ('r_p', POINTER(struct_nmgregion)),
    ('sa_p', POINTER(struct_shell_a)),
    ('fu_hd', struct_bu_list),
    ('lu_hd', struct_bu_list),
    ('eu_hd', struct_bu_list),
    ('vu_p', POINTER(struct_vertexuse)),
    ('index', c_long),
]

struct_shell_a.__slots__ = [
    'magic',
    'min_pt',
    'max_pt',
    'index',
]
struct_shell_a._fields_ = [
    ('magic', c_uint32),
    ('min_pt', point_t),
    ('max_pt', point_t),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 302
class struct_faceuse(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 274
class struct_face_g_plane(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 281
class struct_face_g_snurb(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 261
class union_anon_39(Union):
    pass

union_anon_39.__slots__ = [
    'magic_p',
    'plane_p',
    'snurb_p',
]
union_anon_39._fields_ = [
    ('magic_p', POINTER(c_uint32)),
    ('plane_p', POINTER(struct_face_g_plane)),
    ('snurb_p', POINTER(struct_face_g_snurb)),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 258
class struct_face(Structure):
    pass

struct_face.__slots__ = [
    'l',
    'fu_p',
    'g',
    'flip',
    'min_pt',
    'max_pt',
    'index',
]
struct_face._fields_ = [
    ('l', struct_bu_list),
    ('fu_p', POINTER(struct_faceuse)),
    ('g', union_anon_39),
    ('flip', c_int),
    ('min_pt', point_t),
    ('max_pt', point_t),
    ('index', c_long),
]

struct_face_g_plane.__slots__ = [
    'magic',
    'f_hd',
    'N',
    'index',
]
struct_face_g_plane._fields_ = [
    ('magic', c_uint32),
    ('f_hd', struct_bu_list),
    ('N', plane_t),
    ('index', c_long),
]

struct_face_g_snurb.__slots__ = [
    'l',
    'f_hd',
    'order',
    'u',
    'v',
    's_size',
    'pt_type',
    'ctl_points',
    'dir',
    'min_pt',
    'max_pt',
    'index',
]
struct_face_g_snurb._fields_ = [
    ('l', struct_bu_list),
    ('f_hd', struct_bu_list),
    ('order', c_int * 2),
    ('u', struct_knot_vector),
    ('v', struct_knot_vector),
    ('s_size', c_int * 2),
    ('pt_type', c_int),
    ('ctl_points', POINTER(fastf_t)),
    ('dir', c_int),
    ('min_pt', point_t),
    ('max_pt', point_t),
    ('index', c_long),
]

struct_faceuse.__slots__ = [
    'l',
    's_p',
    'fumate_p',
    'orientation',
    'outside',
    'f_p',
    'lu_hd',
    'index',
]
struct_faceuse._fields_ = [
    ('l', struct_bu_list),
    ('s_p', POINTER(struct_shell)),
    ('fumate_p', POINTER(struct_faceuse)),
    ('orientation', c_int),
    ('outside', c_int),
    ('f_p', POINTER(struct_face)),
    ('lu_hd', struct_bu_list),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 384
class struct_loopuse(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 377
class struct_loop_g(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 370
class struct_loop(Structure):
    pass

struct_loop.__slots__ = [
    'magic',
    'lu_p',
    'lg_p',
    'index',
]
struct_loop._fields_ = [
    ('magic', c_uint32),
    ('lu_p', POINTER(struct_loopuse)),
    ('lg_p', POINTER(struct_loop_g)),
    ('index', c_long),
]

struct_loop_g.__slots__ = [
    'magic',
    'min_pt',
    'max_pt',
    'index',
]
struct_loop_g._fields_ = [
    ('magic', c_uint32),
    ('min_pt', point_t),
    ('max_pt', point_t),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 386
class union_anon_40(Union):
    pass

union_anon_40.__slots__ = [
    'fu_p',
    's_p',
    'magic_p',
]
union_anon_40._fields_ = [
    ('fu_p', POINTER(struct_faceuse)),
    ('s_p', POINTER(struct_shell)),
    ('magic_p', POINTER(c_uint32)),
]

struct_loopuse.__slots__ = [
    'l',
    'up',
    'lumate_p',
    'orientation',
    'l_p',
    'down_hd',
    'index',
]
struct_loopuse._fields_ = [
    ('l', struct_bu_list),
    ('up', union_anon_40),
    ('lumate_p', POINTER(struct_loopuse)),
    ('orientation', c_int),
    ('l_p', POINTER(struct_loop)),
    ('down_hd', struct_bu_list),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 458
class struct_edgeuse(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 418
class struct_edge(Structure):
    pass

struct_edge.__slots__ = [
    'magic',
    'eu_p',
    'is_real',
    'index',
]
struct_edge._fields_ = [
    ('magic', c_uint32),
    ('eu_p', POINTER(struct_edgeuse)),
    ('is_real', c_long),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 430
class struct_edge_g_lseg(Structure):
    pass

struct_edge_g_lseg.__slots__ = [
    'l',
    'eu_hd2',
    'e_pt',
    'e_dir',
    'index',
]
struct_edge_g_lseg._fields_ = [
    ('l', struct_bu_list),
    ('eu_hd2', struct_bu_list),
    ('e_pt', point_t),
    ('e_dir', vect_t),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 446
class struct_edge_g_cnurb(Structure):
    pass

struct_edge_g_cnurb.__slots__ = [
    'l',
    'eu_hd2',
    'order',
    'k',
    'c_size',
    'pt_type',
    'ctl_points',
    'index',
]
struct_edge_g_cnurb._fields_ = [
    ('l', struct_bu_list),
    ('eu_hd2', struct_bu_list),
    ('order', c_int),
    ('k', struct_knot_vector),
    ('c_size', c_int),
    ('pt_type', c_int),
    ('ctl_points', POINTER(fastf_t)),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 461
class union_anon_41(Union):
    pass

union_anon_41.__slots__ = [
    'lu_p',
    's_p',
    'magic_p',
]
union_anon_41._fields_ = [
    ('lu_p', POINTER(struct_loopuse)),
    ('s_p', POINTER(struct_shell)),
    ('magic_p', POINTER(c_uint32)),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 471
class union_anon_42(Union):
    pass

union_anon_42.__slots__ = [
    'magic_p',
    'lseg_p',
    'cnurb_p',
]
union_anon_42._fields_ = [
    ('magic_p', POINTER(c_uint32)),
    ('lseg_p', POINTER(struct_edge_g_lseg)),
    ('cnurb_p', POINTER(struct_edge_g_cnurb)),
]

struct_edgeuse.__slots__ = [
    'l',
    'l2',
    'up',
    'eumate_p',
    'radial_p',
    'e_p',
    'orientation',
    'vu_p',
    'g',
    'index',
]
struct_edgeuse._fields_ = [
    ('l', struct_bu_list),
    ('l2', struct_bu_list),
    ('up', union_anon_41),
    ('eumate_p', POINTER(struct_edgeuse)),
    ('radial_p', POINTER(struct_edgeuse)),
    ('e_p', POINTER(struct_edge)),
    ('orientation', c_int),
    ('vu_p', POINTER(struct_vertexuse)),
    ('g', union_anon_42),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 495
class struct_vertex_g(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 488
class struct_vertex(Structure):
    pass

struct_vertex.__slots__ = [
    'magic',
    'vu_hd',
    'vg_p',
    'index',
]
struct_vertex._fields_ = [
    ('magic', c_uint32),
    ('vu_hd', struct_bu_list),
    ('vg_p', POINTER(struct_vertex_g)),
    ('index', c_long),
]

struct_vertex_g.__slots__ = [
    'magic',
    'coord',
    'index',
]
struct_vertex_g._fields_ = [
    ('magic', c_uint32),
    ('coord', point_t),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 503
class union_anon_43(Union):
    pass

union_anon_43.__slots__ = [
    's_p',
    'lu_p',
    'eu_p',
    'magic_p',
]
union_anon_43._fields_ = [
    ('s_p', POINTER(struct_shell)),
    ('lu_p', POINTER(struct_loopuse)),
    ('eu_p', POINTER(struct_edgeuse)),
    ('magic_p', POINTER(c_uint32)),
]

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 518
class struct_vertexuse_a_plane(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 524
class struct_vertexuse_a_cnurb(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/nmg.h: 510
class union_anon_44(Union):
    pass

union_anon_44.__slots__ = [
    'magic_p',
    'plane_p',
    'cnurb_p',
]
union_anon_44._fields_ = [
    ('magic_p', POINTER(c_uint32)),
    ('plane_p', POINTER(struct_vertexuse_a_plane)),
    ('cnurb_p', POINTER(struct_vertexuse_a_cnurb)),
]

struct_vertexuse.__slots__ = [
    'l',
    'up',
    'v_p',
    'a',
    'index',
]
struct_vertexuse._fields_ = [
    ('l', struct_bu_list),
    ('up', union_anon_43),
    ('v_p', POINTER(struct_vertex)),
    ('a', union_anon_44),
    ('index', c_long),
]

struct_vertexuse_a_plane.__slots__ = [
    'magic',
    'N',
    'index',
]
struct_vertexuse_a_plane._fields_ = [
    ('magic', c_uint32),
    ('N', vect_t),
    ('index', c_long),
]

struct_vertexuse_a_cnurb.__slots__ = [
    'magic',
    'param',
    'index',
]
struct_vertexuse_a_cnurb._fields_ = [
    ('magic', c_uint32),
    ('param', fastf_t * 3),
    ('index', c_long),
]

# /home/kanzure/local/brlcad/brlcad/include/pc.h: 82
class union_anon_45(Union):
    pass

union_anon_45.__slots__ = [
    'expression',
    'ptr',
]
union_anon_45._fields_ = [
    ('expression', struct_bu_vls),
    ('ptr', POINTER(None)),
]

# /home/kanzure/local/brlcad/brlcad/include/pc.h: 74
class struct_pc_param(Structure):
    pass

struct_pc_param.__slots__ = [
    'l',
    'name',
    'ctype',
    'dtype',
    'data',
]
struct_pc_param._fields_ = [
    ('l', struct_bu_list),
    ('name', struct_bu_vls),
    ('ctype', c_int),
    ('dtype', c_int),
    ('data', union_anon_45),
]

# /home/kanzure/local/brlcad/brlcad/include/pc.h: 88
class struct_pc_constraint_fp(Structure):
    pass

struct_pc_constraint_fp.__slots__ = [
    'nargs',
    'dimension',
    'fp',
]
struct_pc_constraint_fp._fields_ = [
    ('nargs', c_int),
    ('dimension', c_int),
    ('fp', CFUNCTYPE(UNCHECKED(c_int), POINTER(POINTER(c_double)))),
]

# /home/kanzure/local/brlcad/brlcad/include/pc.h: 98
class union_anon_46(Union):
    pass

union_anon_46.__slots__ = [
    'expression',
    'cf',
]
union_anon_46._fields_ = [
    ('expression', struct_bu_vls),
    ('cf', struct_pc_constraint_fp),
]

# /home/kanzure/local/brlcad/brlcad/include/pc.h: 94
class struct_pc_constrnt(Structure):
    pass

struct_pc_constrnt.__slots__ = [
    'l',
    'name',
    'ctype',
    'data',
    'args',
]
struct_pc_constrnt._fields_ = [
    ('l', struct_bu_list),
    ('name', struct_bu_vls),
    ('ctype', c_int),
    ('data', union_anon_46),
    ('args', POINTER(POINTER(c_char))),
]

# /home/kanzure/local/brlcad/brlcad/include/pc.h: 105
class struct_pc_pc_set(Structure):
    pass

struct_pc_pc_set.__slots__ = [
    'ps',
    'cs',
]
struct_pc_pc_set._fields_ = [
    ('ps', POINTER(struct_pc_param)),
    ('cs', POINTER(struct_pc_constrnt)),
]

# /home/kanzure/local/brlcad/brlcad/include/brep.h: 68
class struct__on_brep_placeholder(Structure):
    pass

struct__on_brep_placeholder.__slots__ = [
    'dummy',
]
struct__on_brep_placeholder._fields_ = [
    ('dummy', c_int),
]

ON_Brep = struct__on_brep_placeholder # /home/kanzure/local/brlcad/brlcad/include/brep.h: 68

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 156
class struct_rt_arb_internal(Structure):
    pass

struct_rt_arb_internal.__slots__ = [
    'magic',
    'pt',
]
struct_rt_arb_internal._fields_ = [
    ('magic', c_uint32),
    ('pt', point_t * 8),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 189
class struct_rt_db_internal(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 473
class struct_rt_curve(Structure):
    pass

struct_rt_curve.__slots__ = [
    'count',
    'reverse',
    'segment',
]
struct_rt_curve._fields_ = [
    ('count', c_size_t),
    ('reverse', POINTER(c_int)),
    ('segment', POINTER(genptr_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/rtgeom.h: 529
class struct_rt_sketch_internal(Structure):
    pass

struct_rt_sketch_internal.__slots__ = [
    'magic',
    'V',
    'u_vec',
    'v_vec',
    'vert_count',
    'verts',
    'curve',
]
struct_rt_sketch_internal._fields_ = [
    ('magic', c_uint32),
    ('V', point_t),
    ('u_vec', vect_t),
    ('v_vec', vect_t),
    ('vert_count', c_size_t),
    ('verts', POINTER(point2d_t)),
    ('curve', struct_rt_curve),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 831
class struct_db_i(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 175
class struct_rt_tess_tol(Structure):
    pass

struct_rt_tess_tol.__slots__ = [
    'magic',
    'abs',
    'rel',
    'norm',
]
struct_rt_tess_tol._fields_ = [
    ('magic', c_uint32),
    ('abs', c_double),
    ('rel', c_double),
    ('norm', c_double),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 2049
class struct_rt_functab(Structure):
    pass

struct_rt_db_internal.__slots__ = [
    'idb_magic',
    'idb_major_type',
    'idb_minor_type',
    'idb_meth',
    'idb_ptr',
    'idb_avs',
]
struct_rt_db_internal._fields_ = [
    ('idb_magic', c_uint32),
    ('idb_major_type', c_int),
    ('idb_minor_type', c_int),
    ('idb_meth', POINTER(struct_rt_functab)),
    ('idb_ptr', genptr_t),
    ('idb_avs', struct_bu_attribute_value_set),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 890
class struct_directory(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 219
class struct_db_full_path(Structure):
    pass

struct_db_full_path.__slots__ = [
    'magic',
    'fp_len',
    'fp_maxlen',
    'fp_names',
    'fp_bool',
]
struct_db_full_path._fields_ = [
    ('magic', c_uint32),
    ('fp_len', c_size_t),
    ('fp_maxlen', c_size_t),
    ('fp_names', POINTER(POINTER(struct_directory))),
    ('fp_bool', POINTER(c_int)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 244
class struct_xray(Structure):
    pass

struct_xray.__slots__ = [
    'magic',
    'index',
    'r_pt',
    'r_dir',
    'r_min',
    'r_max',
]
struct_xray._fields_ = [
    ('magic', c_uint32),
    ('index', c_int),
    ('r_pt', point_t),
    ('r_dir', vect_t),
    ('r_min', fastf_t),
    ('r_max', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 282
class struct_hit(Structure):
    pass

struct_hit.__slots__ = [
    'hit_magic',
    'hit_dist',
    'hit_point',
    'hit_normal',
    'hit_vpriv',
    'hit_private',
    'hit_surfno',
    'hit_rayp',
]
struct_hit._fields_ = [
    ('hit_magic', c_uint32),
    ('hit_dist', fastf_t),
    ('hit_point', point_t),
    ('hit_normal', vect_t),
    ('hit_vpriv', vect_t),
    ('hit_private', genptr_t),
    ('hit_surfno', c_int),
    ('hit_rayp', POINTER(struct_xray)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 340
class struct_curvature(Structure):
    pass

struct_curvature.__slots__ = [
    'crv_pdir',
    'crv_c1',
    'crv_c2',
]
struct_curvature._fields_ = [
    ('crv_pdir', vect_t),
    ('crv_c1', fastf_t),
    ('crv_c2', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 376
class struct_uvcoord(Structure):
    pass

struct_uvcoord.__slots__ = [
    'uv_u',
    'uv_v',
    'uv_du',
    'uv_dv',
]
struct_uvcoord._fields_ = [
    ('uv_u', fastf_t),
    ('uv_v', fastf_t),
    ('uv_du', fastf_t),
    ('uv_dv', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 464
class struct_soltab(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 406
class struct_seg(Structure):
    pass

struct_seg.__slots__ = [
    'l',
    'seg_in',
    'seg_out',
    'seg_stp',
]
struct_seg._fields_ = [
    ('l', struct_bu_list),
    ('seg_in', struct_hit),
    ('seg_out', struct_hit),
    ('seg_stp', POINTER(struct_soltab)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 452
class struct_bound_rpp(Structure):
    pass

struct_bound_rpp.__slots__ = [
    'min',
    'max',
]
struct_bound_rpp._fields_ = [
    ('min', point_t),
    ('max', point_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1835
class struct_rt_i(Structure):
    pass

struct_soltab.__slots__ = [
    'l',
    'l2',
    'st_meth',
    'st_rtip',
    'st_uses',
    'st_id',
    'st_center',
    'st_aradius',
    'st_bradius',
    'st_specific',
    'st_dp',
    'st_min',
    'st_max',
    'st_bit',
    'st_regions',
    'st_matp',
    'st_path',
    'st_npieces',
    'st_piecestate_num',
    'st_piece_rpps',
]
struct_soltab._fields_ = [
    ('l', struct_bu_list),
    ('l2', struct_bu_list),
    ('st_meth', POINTER(struct_rt_functab)),
    ('st_rtip', POINTER(struct_rt_i)),
    ('st_uses', c_long),
    ('st_id', c_int),
    ('st_center', point_t),
    ('st_aradius', fastf_t),
    ('st_bradius', fastf_t),
    ('st_specific', genptr_t),
    ('st_dp', POINTER(struct_directory)),
    ('st_min', point_t),
    ('st_max', point_t),
    ('st_bit', c_long),
    ('st_regions', struct_bu_ptbl),
    ('st_matp', matp_t),
    ('st_path', struct_db_full_path),
    ('st_npieces', c_long),
    ('st_piecestate_num', c_long),
    ('st_piece_rpps', POINTER(struct_bound_rpp)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 560
class struct_mater_info(Structure):
    pass

struct_mater_info.__slots__ = [
    'ma_color',
    'ma_temperature',
    'ma_color_valid',
    'ma_cinherit',
    'ma_minherit',
    'ma_shader',
]
struct_mater_info._fields_ = [
    ('ma_color', c_float * 3),
    ('ma_temperature', c_float),
    ('ma_color_valid', c_char),
    ('ma_cinherit', c_char),
    ('ma_minherit', c_char),
    ('ma_shader', String),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1198
class union_tree(Union):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 576
class struct_region(Structure):
    pass

struct_region.__slots__ = [
    'l',
    'reg_name',
    'reg_treetop',
    'reg_bit',
    'reg_regionid',
    'reg_aircode',
    'reg_gmater',
    'reg_los',
    'reg_mater',
    'reg_mfuncs',
    'reg_udata',
    'reg_transmit',
    'reg_instnum',
    'reg_all_unions',
    'reg_is_fastgen',
    'attr_values',
]
struct_region._fields_ = [
    ('l', struct_bu_list),
    ('reg_name', String),
    ('reg_treetop', POINTER(union_tree)),
    ('reg_bit', c_int),
    ('reg_regionid', c_int),
    ('reg_aircode', c_int),
    ('reg_gmater', c_int),
    ('reg_los', c_int),
    ('reg_mater', struct_mater_info),
    ('reg_mfuncs', genptr_t),
    ('reg_udata', genptr_t),
    ('reg_transmit', c_int),
    ('reg_instnum', c_long),
    ('reg_all_unions', c_short),
    ('reg_is_fastgen', c_short),
    ('attr_values', struct_bu_attribute_value_set),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 612
class struct_partition(Structure):
    pass

struct_partition.__slots__ = [
    'pt_magic',
    'pt_forw',
    'pt_back',
    'pt_inseg',
    'pt_inhit',
    'pt_outseg',
    'pt_outhit',
    'pt_regionp',
    'pt_inflip',
    'pt_outflip',
    'pt_overlap_reg',
    'pt_seglist',
]
struct_partition._fields_ = [
    ('pt_magic', c_uint32),
    ('pt_forw', POINTER(struct_partition)),
    ('pt_back', POINTER(struct_partition)),
    ('pt_inseg', POINTER(struct_seg)),
    ('pt_inhit', POINTER(struct_hit)),
    ('pt_outseg', POINTER(struct_seg)),
    ('pt_outhit', POINTER(struct_hit)),
    ('pt_regionp', POINTER(struct_region)),
    ('pt_inflip', c_char),
    ('pt_outflip', c_char),
    ('pt_overlap_reg', POINTER(POINTER(struct_region))),
    ('pt_seglist', struct_bu_ptbl),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1654
class struct_application(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 733
class union_cutter(Union):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 740
class struct_cutnode(Structure):
    pass

struct_cutnode.__slots__ = [
    'cn_type',
    'cn_axis',
    'cn_point',
    'cn_l',
    'cn_r',
]
struct_cutnode._fields_ = [
    ('cn_type', c_int),
    ('cn_axis', c_int),
    ('cn_point', fastf_t),
    ('cn_l', POINTER(union_cutter)),
    ('cn_r', POINTER(union_cutter)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1472
class struct_rt_piecelist(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 747
class struct_boxnode(Structure):
    pass

struct_boxnode.__slots__ = [
    'bn_type',
    'bn_min',
    'bn_max',
    'bn_list',
    'bn_len',
    'bn_maxlen',
    'bn_piecelist',
    'bn_piecelen',
    'bn_maxpiecelen',
]
struct_boxnode._fields_ = [
    ('bn_type', c_int),
    ('bn_min', fastf_t * 3),
    ('bn_max', fastf_t * 3),
    ('bn_list', POINTER(POINTER(struct_soltab))),
    ('bn_len', c_size_t),
    ('bn_maxlen', c_size_t),
    ('bn_piecelist', POINTER(struct_rt_piecelist)),
    ('bn_piecelen', c_size_t),
    ('bn_maxpiecelen', c_size_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 760
class struct_nu_axis(Structure):
    pass

struct_nu_axis.__slots__ = [
    'nu_spos',
    'nu_epos',
    'nu_width',
]
struct_nu_axis._fields_ = [
    ('nu_spos', fastf_t),
    ('nu_epos', fastf_t),
    ('nu_width', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 758
class struct_nugridnode(Structure):
    pass

struct_nugridnode.__slots__ = [
    'nu_type',
    'nu_axis',
    'nu_cells_per_axis',
    'nu_stepsize',
    'nu_grid',
]
struct_nugridnode._fields_ = [
    ('nu_type', c_int),
    ('nu_axis', POINTER(struct_nu_axis) * 3),
    ('nu_cells_per_axis', c_int * 3),
    ('nu_stepsize', c_int * 3),
    ('nu_grid', POINTER(union_cutter)),
]

union_cutter.__slots__ = [
    'cut_type',
    'cut_forw',
    'cn',
    'bn',
    'nugn',
]
union_cutter._fields_ = [
    ('cut_type', c_int),
    ('cut_forw', POINTER(union_cutter)),
    ('cn', struct_cutnode),
    ('bn', struct_boxnode),
    ('nugn', struct_nugridnode),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 780
class struct_mem_map(Structure):
    pass

struct_mem_map.__slots__ = [
    'm_nxtp',
    'm_size',
    'm_addr',
]
struct_mem_map._fields_ = [
    ('m_nxtp', POINTER(struct_mem_map)),
    ('m_size', c_size_t),
    ('m_addr', off_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1398
class struct_animate(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1323
class struct_rt_wdb(Structure):
    pass

struct_db_i.__slots__ = [
    'dbi_magic',
    'dbi_filename',
    'dbi_read_only',
    'dbi_local2base',
    'dbi_base2local',
    'dbi_title',
    'dbi_filepath',
    'dbi_Head',
    'dbi_fp',
    'dbi_eof',
    'dbi_nrec',
    'dbi_uses',
    'dbi_freep',
    'dbi_inmem',
    'dbi_anroot',
    'dbi_mf',
    'dbi_clients',
    'dbi_version',
    'dbi_wdbp',
]
struct_db_i._fields_ = [
    ('dbi_magic', c_uint32),
    ('dbi_filename', String),
    ('dbi_read_only', c_int),
    ('dbi_local2base', c_double),
    ('dbi_base2local', c_double),
    ('dbi_title', String),
    ('dbi_filepath', POINTER(POINTER(c_char))),
    ('dbi_Head', POINTER(struct_directory) * 8192),
    ('dbi_fp', POINTER(FILE)),
    ('dbi_eof', off_t),
    ('dbi_nrec', c_size_t),
    ('dbi_uses', c_int),
    ('dbi_freep', POINTER(struct_mem_map)),
    ('dbi_inmem', genptr_t),
    ('dbi_anroot', POINTER(struct_animate)),
    ('dbi_mf', POINTER(struct_bu_mapped_file)),
    ('dbi_clients', struct_bu_ptbl),
    ('dbi_version', c_int),
    ('dbi_wdbp', POINTER(struct_rt_wdb)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 893
class union_anon_48(Union):
    pass

union_anon_48.__slots__ = [
    'file_offset',
    'ptr',
]
union_anon_48._fields_ = [
    ('file_offset', off_t),
    ('ptr', genptr_t),
]

struct_directory.__slots__ = [
    'd_magic',
    'd_namep',
    'd_un',
    'd_forw',
    'd_animate',
    'd_uses',
    'd_len',
    'd_nref',
    'd_flags',
    'd_major_type',
    'd_minor_type',
    'd_use_hd',
    'd_shortname',
]
struct_directory._fields_ = [
    ('d_magic', c_uint32),
    ('d_namep', String),
    ('d_un', union_anon_48),
    ('d_forw', POINTER(struct_directory)),
    ('d_animate', POINTER(struct_animate)),
    ('d_uses', c_long),
    ('d_len', c_size_t),
    ('d_nref', c_long),
    ('d_flags', c_int),
    ('d_major_type', c_ubyte),
    ('d_minor_type', c_ubyte),
    ('d_use_hd', struct_bu_list),
    ('d_shortname', c_char * 16),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 981
class struct_rt_comb_internal(Structure):
    pass

struct_rt_comb_internal.__slots__ = [
    'magic',
    'tree',
    'region_flag',
    'is_fastgen',
    'region_id',
    'aircode',
    'GIFTmater',
    'los',
    'rgb_valid',
    'rgb',
    'temperature',
    'shader',
    'material',
    'inherit',
]
struct_rt_comb_internal._fields_ = [
    ('magic', c_uint32),
    ('tree', POINTER(union_tree)),
    ('region_flag', c_char),
    ('is_fastgen', c_char),
    ('region_id', c_long),
    ('aircode', c_long),
    ('GIFTmater', c_long),
    ('los', c_long),
    ('rgb_valid', c_char),
    ('rgb', c_ubyte * 3),
    ('temperature', c_float),
    ('shader', struct_bu_vls),
    ('material', struct_bu_vls),
    ('inherit', c_char),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1089
class struct_db_tree_state(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1509
class struct_resource(Structure):
    pass

struct_db_tree_state.__slots__ = [
    'magic',
    'ts_dbip',
    'ts_sofar',
    'ts_regionid',
    'ts_aircode',
    'ts_gmater',
    'ts_los',
    'ts_mater',
    'ts_mat',
    'ts_is_fastgen',
    'ts_attrs',
    'ts_stop_at_regions',
    'ts_region_start_func',
    'ts_region_end_func',
    'ts_leaf_func',
    'ts_ttol',
    'ts_tol',
    'ts_m',
    'ts_rtip',
    'ts_resp',
]
struct_db_tree_state._fields_ = [
    ('magic', c_uint32),
    ('ts_dbip', POINTER(struct_db_i)),
    ('ts_sofar', c_int),
    ('ts_regionid', c_int),
    ('ts_aircode', c_int),
    ('ts_gmater', c_int),
    ('ts_los', c_int),
    ('ts_mater', struct_mater_info),
    ('ts_mat', mat_t),
    ('ts_is_fastgen', c_int),
    ('ts_attrs', struct_bu_attribute_value_set),
    ('ts_stop_at_regions', c_int),
    ('ts_region_start_func', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_db_tree_state), POINTER(struct_db_full_path), POINTER(struct_rt_comb_internal), genptr_t)),
    ('ts_region_end_func', CFUNCTYPE(UNCHECKED(POINTER(union_tree)), POINTER(struct_db_tree_state), POINTER(struct_db_full_path), POINTER(union_tree), genptr_t)),
    ('ts_leaf_func', CFUNCTYPE(UNCHECKED(POINTER(union_tree)), POINTER(struct_db_tree_state), POINTER(struct_db_full_path), POINTER(struct_rt_db_internal), genptr_t)),
    ('ts_ttol', POINTER(struct_rt_tess_tol)),
    ('ts_tol', POINTER(struct_bn_tol)),
    ('ts_m', POINTER(POINTER(struct_model))),
    ('ts_rtip', POINTER(struct_rt_i)),
    ('ts_resp', POINTER(struct_resource)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1168
class struct_combined_tree_state(Structure):
    pass

struct_combined_tree_state.__slots__ = [
    'magic',
    'cts_s',
    'cts_p',
]
struct_combined_tree_state._fields_ = [
    ('magic', c_uint32),
    ('cts_s', struct_db_tree_state),
    ('cts_p', struct_db_full_path),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1201
class struct_tree_node(Structure):
    pass

struct_tree_node.__slots__ = [
    'magic',
    'tb_op',
    'tb_regionp',
    'tb_left',
    'tb_right',
]
struct_tree_node._fields_ = [
    ('magic', c_uint32),
    ('tb_op', c_int),
    ('tb_regionp', POINTER(struct_region)),
    ('tb_left', POINTER(union_tree)),
    ('tb_right', POINTER(union_tree)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1208
class struct_tree_leaf(Structure):
    pass

struct_tree_leaf.__slots__ = [
    'magic',
    'tu_op',
    'tu_regionp',
    'tu_stp',
]
struct_tree_leaf._fields_ = [
    ('magic', c_uint32),
    ('tu_op', c_int),
    ('tu_regionp', POINTER(struct_region)),
    ('tu_stp', POINTER(struct_soltab)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1214
class struct_tree_cts(Structure):
    pass

struct_tree_cts.__slots__ = [
    'magic',
    'tc_op',
    'tc_pad',
    'tc_ctsp',
]
struct_tree_cts._fields_ = [
    ('magic', c_uint32),
    ('tc_op', c_int),
    ('tc_pad', POINTER(struct_region)),
    ('tc_ctsp', POINTER(struct_combined_tree_state)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1220
class struct_tree_nmgregion(Structure):
    pass

struct_tree_nmgregion.__slots__ = [
    'magic',
    'td_op',
    'td_name',
    'td_r',
]
struct_tree_nmgregion._fields_ = [
    ('magic', c_uint32),
    ('td_op', c_int),
    ('td_name', String),
    ('td_r', POINTER(struct_nmgregion)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1226
class struct_tree_db_leaf(Structure):
    pass

struct_tree_db_leaf.__slots__ = [
    'magic',
    'tl_op',
    'tl_mat',
    'tl_name',
]
struct_tree_db_leaf._fields_ = [
    ('magic', c_uint32),
    ('tl_op', c_int),
    ('tl_mat', matp_t),
    ('tl_name', String),
]

union_tree.__slots__ = [
    'magic',
    'tr_b',
    'tr_a',
    'tr_c',
    'tr_d',
    'tr_l',
]
union_tree._fields_ = [
    ('magic', c_uint32),
    ('tr_b', struct_tree_node),
    ('tr_a', struct_tree_leaf),
    ('tr_c', struct_tree_cts),
    ('tr_d', struct_tree_nmgregion),
    ('tr_l', struct_tree_db_leaf),
]

struct_rt_wdb.__slots__ = [
    'l',
    'type',
    'dbip',
    'wdb_initial_tree_state',
    'wdb_ttol',
    'wdb_tol',
    'wdb_resp',
    'wdb_prestr',
    'wdb_ncharadd',
    'wdb_num_dups',
    'wdb_item_default',
    'wdb_air_default',
    'wdb_mat_default',
    'wdb_los_default',
    'wdb_name',
    'wdb_observers',
    'wdb_interp',
]
struct_rt_wdb._fields_ = [
    ('l', struct_bu_list),
    ('type', c_int),
    ('dbip', POINTER(struct_db_i)),
    ('wdb_initial_tree_state', struct_db_tree_state),
    ('wdb_ttol', struct_rt_tess_tol),
    ('wdb_tol', struct_bn_tol),
    ('wdb_resp', POINTER(struct_resource)),
    ('wdb_prestr', struct_bu_vls),
    ('wdb_ncharadd', c_int),
    ('wdb_num_dups', c_int),
    ('wdb_item_default', c_int),
    ('wdb_air_default', c_int),
    ('wdb_mat_default', c_int),
    ('wdb_los_default', c_int),
    ('wdb_name', struct_bu_vls),
    ('wdb_observers', struct_bu_observer),
    ('wdb_interp', POINTER(Tcl_Interp)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1374
class struct_anim_mat(Structure):
    pass

struct_anim_mat.__slots__ = [
    'anm_op',
    'anm_mat',
]
struct_anim_mat._fields_ = [
    ('anm_op', c_int),
    ('anm_mat', mat_t),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1384
class struct_rt_anim_property(Structure):
    pass

struct_rt_anim_property.__slots__ = [
    'magic',
    'anp_op',
    'anp_shader',
]
struct_rt_anim_property._fields_ = [
    ('magic', c_uint32),
    ('anp_op', c_int),
    ('anp_shader', struct_bu_vls),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1393
class struct_rt_anim_color(Structure):
    pass

struct_rt_anim_color.__slots__ = [
    'anc_rgb',
]
struct_rt_anim_color._fields_ = [
    ('anc_rgb', c_int * 3),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1403
class union_animate_specific(Union):
    pass

union_animate_specific.__slots__ = [
    'anu_m',
    'anu_p',
    'anu_c',
    'anu_t',
]
union_animate_specific._fields_ = [
    ('anu_m', struct_anim_mat),
    ('anu_p', struct_rt_anim_property),
    ('anu_c', struct_rt_anim_color),
    ('anu_t', c_float),
]

struct_animate.__slots__ = [
    'magic',
    'an_forw',
    'an_path',
    'an_type',
    'an_u',
]
struct_animate._fields_ = [
    ('magic', c_uint32),
    ('an_forw', POINTER(struct_animate)),
    ('an_path', struct_db_full_path),
    ('an_type', c_int),
    ('an_u', union_animate_specific),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1425
class struct_rt_htbl(Structure):
    pass

struct_rt_htbl.__slots__ = [
    'l',
    'end',
    'blen',
    'hits',
]
struct_rt_htbl._fields_ = [
    ('l', struct_bu_list),
    ('end', c_size_t),
    ('blen', c_size_t),
    ('hits', POINTER(struct_hit)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1443
class struct_rt_piecestate(Structure):
    pass

struct_rt_piecestate.__slots__ = [
    'magic',
    'ray_seqno',
    'stp',
    'shot',
    'mindist',
    'maxdist',
    'htab',
    'cutp',
]
struct_rt_piecestate._fields_ = [
    ('magic', c_uint32),
    ('ray_seqno', c_long),
    ('stp', POINTER(struct_soltab)),
    ('shot', POINTER(struct_bu_bitv)),
    ('mindist', fastf_t),
    ('maxdist', fastf_t),
    ('htab', struct_rt_htbl),
    ('cutp', POINTER(union_cutter)),
]

struct_rt_piecelist.__slots__ = [
    'magic',
    'npieces',
    'pieces',
    'stp',
]
struct_rt_piecelist._fields_ = [
    ('magic', c_uint32),
    ('npieces', c_size_t),
    ('pieces', POINTER(c_long)),
    ('stp', POINTER(struct_soltab)),
]

struct_resource.__slots__ = [
    're_magic',
    're_cpu',
    're_seg',
    're_seg_blocks',
    're_seglen',
    're_segget',
    're_segfree',
    're_parthead',
    're_partlen',
    're_partget',
    're_partfree',
    're_solid_bitv',
    're_region_ptbl',
    're_nmgfree',
    're_boolstack',
    're_boolslen',
    're_randptr',
    're_nshootray',
    're_nmiss_model',
    're_shots',
    're_shot_hit',
    're_shot_miss',
    're_prune_solrpp',
    're_ndup',
    're_nempty_cells',
    're_pieces',
    're_piece_ndup',
    're_piece_shots',
    're_piece_shot_hit',
    're_piece_shot_miss',
    're_pieces_pending',
    're_tree_hd',
    're_tree_get',
    're_tree_malloc',
    're_tree_free',
    're_directory_hd',
    're_directory_blocks',
]
struct_resource._fields_ = [
    ('re_magic', c_uint32),
    ('re_cpu', c_int),
    ('re_seg', struct_bu_list),
    ('re_seg_blocks', struct_bu_ptbl),
    ('re_seglen', c_long),
    ('re_segget', c_long),
    ('re_segfree', c_long),
    ('re_parthead', struct_bu_list),
    ('re_partlen', c_long),
    ('re_partget', c_long),
    ('re_partfree', c_long),
    ('re_solid_bitv', struct_bu_list),
    ('re_region_ptbl', struct_bu_list),
    ('re_nmgfree', struct_bu_list),
    ('re_boolstack', POINTER(POINTER(union_tree))),
    ('re_boolslen', c_long),
    ('re_randptr', POINTER(c_float)),
    ('re_nshootray', c_long),
    ('re_nmiss_model', c_long),
    ('re_shots', c_long),
    ('re_shot_hit', c_long),
    ('re_shot_miss', c_long),
    ('re_prune_solrpp', c_long),
    ('re_ndup', c_long),
    ('re_nempty_cells', c_long),
    ('re_pieces', POINTER(struct_rt_piecestate)),
    ('re_piece_ndup', c_long),
    ('re_piece_shots', c_long),
    ('re_piece_shot_hit', c_long),
    ('re_piece_shot_miss', c_long),
    ('re_pieces_pending', struct_bu_ptbl),
    ('re_tree_hd', POINTER(union_tree)),
    ('re_tree_get', c_long),
    ('re_tree_malloc', c_long),
    ('re_tree_free', c_long),
    ('re_directory_hd', POINTER(struct_directory)),
    ('re_directory_blocks', struct_bu_ptbl),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 1598
class struct_pixel_ext(Structure):
    pass

struct_pixel_ext.__slots__ = [
    'magic',
    'corner',
]
struct_pixel_ext._fields_ = [
    ('magic', c_uint32),
    ('corner', struct_xray * 4),
]

struct_application.__slots__ = [
    'a_magic',
    'a_ray',
    'a_hit',
    'a_miss',
    'a_onehit',
    'a_ray_length',
    'a_rt_i',
    'a_zero1',
    'a_resource',
    'a_overlap',
    'a_multioverlap',
    'a_logoverlap',
    'a_level',
    'a_x',
    'a_y',
    'a_purpose',
    'a_rbeam',
    'a_diverge',
    'a_return',
    'a_no_booleans',
    'attrs',
    'a_bot_reverse_normal_disabled',
    'a_pixelext',
    'a_finished_segs_hdp',
    'a_Final_Part_hdp',
    'a_inv_dir',
    'a_user',
    'a_uptr',
    'a_spectrum',
    'a_color',
    'a_dist',
    'a_uvec',
    'a_vvec',
    'a_refrac_index',
    'a_cumlen',
    'a_flag',
    'a_zero2',
]
struct_application._fields_ = [
    ('a_magic', c_uint32),
    ('a_ray', struct_xray),
    ('a_hit', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_application), POINTER(struct_partition), POINTER(struct_seg))),
    ('a_miss', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_application))),
    ('a_onehit', c_int),
    ('a_ray_length', fastf_t),
    ('a_rt_i', POINTER(struct_rt_i)),
    ('a_zero1', c_int),
    ('a_resource', POINTER(struct_resource)),
    ('a_overlap', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_application), POINTER(struct_partition), POINTER(struct_region), POINTER(struct_region), POINTER(struct_partition))),
    ('a_multioverlap', CFUNCTYPE(UNCHECKED(None), POINTER(struct_application), POINTER(struct_partition), POINTER(struct_bu_ptbl), POINTER(struct_partition))),
    ('a_logoverlap', CFUNCTYPE(UNCHECKED(None), POINTER(struct_application), POINTER(struct_partition), POINTER(struct_bu_ptbl), POINTER(struct_partition))),
    ('a_level', c_int),
    ('a_x', c_int),
    ('a_y', c_int),
    ('a_purpose', String),
    ('a_rbeam', fastf_t),
    ('a_diverge', fastf_t),
    ('a_return', c_int),
    ('a_no_booleans', c_int),
    ('attrs', POINTER(POINTER(c_char))),
    ('a_bot_reverse_normal_disabled', c_int),
    ('a_pixelext', POINTER(struct_pixel_ext)),
    ('a_finished_segs_hdp', POINTER(struct_seg)),
    ('a_Final_Part_hdp', POINTER(struct_partition)),
    ('a_inv_dir', vect_t),
    ('a_user', c_int),
    ('a_uptr', genptr_t),
    ('a_spectrum', POINTER(struct_bn_tabdata)),
    ('a_color', fastf_t * 3),
    ('a_dist', fastf_t),
    ('a_uvec', vect_t),
    ('a_vvec', vect_t),
    ('a_refrac_index', fastf_t),
    ('a_cumlen', fastf_t),
    ('a_flag', c_int),
    ('a_zero2', c_int),
]

struct_rt_i.__slots__ = [
    'rti_magic',
    'useair',
    'rti_save_overlaps',
    'rti_dont_instance',
    'rti_hasty_prep',
    'rti_nlights',
    'rti_prismtrace',
    'rti_region_fix_file',
    'rti_space_partition',
    'rti_nugrid_dimlimit',
    'rti_tol',
    'rti_ttol',
    'rti_max_beam_radius',
    'mdl_min',
    'mdl_max',
    'rti_pmin',
    'rti_pmax',
    'rti_radius',
    'rti_dbip',
    'needprep',
    'Regions',
    'HeadRegion',
    'Orca_hash_tbl',
    'delete_regs',
    'nregions',
    'nsolids',
    'rti_nrays',
    'nmiss_model',
    'nshots',
    'nmiss',
    'nhits',
    'nmiss_tree',
    'nmiss_solid',
    'ndup',
    'nempty_cells',
    'rti_CutHead',
    'rti_inf_box',
    'rti_CutFree',
    'rti_busy_cutter_nodes',
    'rti_cuts_waiting',
    'rti_cut_maxlen',
    'rti_ncut_by_type',
    'rti_cut_totobj',
    'rti_cut_maxdepth',
    'rti_sol_by_type',
    'rti_nsol_by_type',
    'rti_maxsol_by_type',
    'rti_air_discards',
    'rti_hist_cellsize',
    'rti_hist_cell_pieces',
    'rti_hist_cutdepth',
    'rti_Solids',
    'rti_solidheads',
    'rti_resources',
    'rti_nu_gfactor',
    'rti_cutlen',
    'rti_cutdepth',
    'rti_treetop',
    'rti_uses',
    'rti_nsolids_with_pieces',
    'rti_add_to_new_solids_list',
    'rti_new_solids',
]
struct_rt_i._fields_ = [
    ('rti_magic', c_uint32),
    ('useair', c_int),
    ('rti_save_overlaps', c_int),
    ('rti_dont_instance', c_int),
    ('rti_hasty_prep', c_int),
    ('rti_nlights', c_int),
    ('rti_prismtrace', c_int),
    ('rti_region_fix_file', String),
    ('rti_space_partition', c_int),
    ('rti_nugrid_dimlimit', c_int),
    ('rti_tol', struct_bn_tol),
    ('rti_ttol', struct_rt_tess_tol),
    ('rti_max_beam_radius', fastf_t),
    ('mdl_min', point_t),
    ('mdl_max', point_t),
    ('rti_pmin', point_t),
    ('rti_pmax', point_t),
    ('rti_radius', c_double),
    ('rti_dbip', POINTER(struct_db_i)),
    ('needprep', c_int),
    ('Regions', POINTER(POINTER(struct_region))),
    ('HeadRegion', struct_bu_list),
    ('Orca_hash_tbl', genptr_t),
    ('delete_regs', struct_bu_ptbl),
    ('nregions', c_size_t),
    ('nsolids', c_size_t),
    ('rti_nrays', c_size_t),
    ('nmiss_model', c_size_t),
    ('nshots', c_size_t),
    ('nmiss', c_size_t),
    ('nhits', c_size_t),
    ('nmiss_tree', c_size_t),
    ('nmiss_solid', c_size_t),
    ('ndup', c_size_t),
    ('nempty_cells', c_size_t),
    ('rti_CutHead', union_cutter),
    ('rti_inf_box', union_cutter),
    ('rti_CutFree', POINTER(union_cutter)),
    ('rti_busy_cutter_nodes', struct_bu_ptbl),
    ('rti_cuts_waiting', struct_bu_ptbl),
    ('rti_cut_maxlen', c_int),
    ('rti_ncut_by_type', c_int * (3 + 1)),
    ('rti_cut_totobj', c_int),
    ('rti_cut_maxdepth', c_int),
    ('rti_sol_by_type', POINTER(POINTER(struct_soltab)) * (44 + 1)),
    ('rti_nsol_by_type', c_int * (44 + 1)),
    ('rti_maxsol_by_type', c_int),
    ('rti_air_discards', c_int),
    ('rti_hist_cellsize', struct_bu_hist),
    ('rti_hist_cell_pieces', struct_bu_hist),
    ('rti_hist_cutdepth', struct_bu_hist),
    ('rti_Solids', POINTER(POINTER(struct_soltab))),
    ('rti_solidheads', struct_bu_list * 8192),
    ('rti_resources', struct_bu_ptbl),
    ('rti_nu_gfactor', c_double),
    ('rti_cutlen', c_size_t),
    ('rti_cutdepth', c_size_t),
    ('rti_treetop', String),
    ('rti_uses', c_size_t),
    ('rti_nsolids_with_pieces', c_size_t),
    ('rti_add_to_new_solids_list', c_int),
    ('rti_new_solids', struct_bu_ptbl),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 2014
class struct_rt_view_info(Structure):
    pass

struct_rt_view_info.__slots__ = [
    'vhead',
    'tol',
    'point_spacing',
    'curve_spacing',
]
struct_rt_view_info._fields_ = [
    ('vhead', POINTER(struct_bu_list)),
    ('tol', POINTER(struct_bn_tol)),
    ('point_spacing', fastf_t),
    ('curve_spacing', fastf_t),
]

struct_rt_functab.__slots__ = [
    'magic',
    'ft_name',
    'ft_label',
    'ft_use_rpp',
    'ft_prep',
    'ft_shot',
    'ft_print',
    'ft_norm',
    'ft_piece_shot',
    'ft_piece_hitsegs',
    'ft_uv',
    'ft_curve',
    'ft_classify',
    'ft_free',
    'ft_plot',
    'ft_adaptive_plot',
    'ft_vshot',
    'ft_tessellate',
    'ft_tnurb',
    'ft_brep',
    'ft_import5',
    'ft_export5',
    'ft_import4',
    'ft_export4',
    'ft_ifree',
    'ft_describe',
    'ft_xform',
    'ft_parsetab',
    'ft_internal_size',
    'ft_internal_magic',
    'ft_get',
    'ft_adjust',
    'ft_form',
    'ft_make',
    'ft_params',
    'ft_bbox',
    'ft_volume',
    'ft_surf_area',
    'ft_centroid',
    'ft_oriented_bbox',
]
struct_rt_functab._fields_ = [
    ('magic', c_uint32),
    ('ft_name', c_char * 16),
    ('ft_label', c_char * 8),
    ('ft_use_rpp', c_int),
    ('ft_prep', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_soltab), POINTER(struct_rt_db_internal), POINTER(struct_rt_i))),
    ('ft_shot', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_soltab), POINTER(struct_xray), POINTER(struct_application), POINTER(struct_seg))),
    ('ft_print', CFUNCTYPE(UNCHECKED(None), POINTER(struct_soltab))),
    ('ft_norm', CFUNCTYPE(UNCHECKED(None), POINTER(struct_hit), POINTER(struct_soltab), POINTER(struct_xray))),
    ('ft_piece_shot', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_piecestate), POINTER(struct_rt_piecelist), c_double, POINTER(struct_xray), POINTER(struct_application), POINTER(struct_seg))),
    ('ft_piece_hitsegs', CFUNCTYPE(UNCHECKED(None), POINTER(struct_rt_piecestate), POINTER(struct_seg), POINTER(struct_application))),
    ('ft_uv', CFUNCTYPE(UNCHECKED(None), POINTER(struct_application), POINTER(struct_soltab), POINTER(struct_hit), POINTER(struct_uvcoord))),
    ('ft_curve', CFUNCTYPE(UNCHECKED(None), POINTER(struct_curvature), POINTER(struct_hit), POINTER(struct_soltab))),
    ('ft_classify', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_soltab), vect_t, vect_t, POINTER(struct_bn_tol))),
    ('ft_free', CFUNCTYPE(UNCHECKED(None), POINTER(struct_soltab))),
    ('ft_plot', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_list), POINTER(struct_rt_db_internal), POINTER(struct_rt_tess_tol), POINTER(struct_bn_tol), POINTER(struct_rt_view_info))),
    ('ft_adaptive_plot', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_db_internal), POINTER(struct_rt_view_info))),
    ('ft_vshot', CFUNCTYPE(UNCHECKED(None), POINTER(POINTER(struct_soltab)), POINTER(POINTER(struct_xray)), POINTER(struct_seg), c_int, POINTER(struct_application))),
    ('ft_tessellate', CFUNCTYPE(UNCHECKED(c_int), POINTER(POINTER(struct_nmgregion)), POINTER(struct_model), POINTER(struct_rt_db_internal), POINTER(struct_rt_tess_tol), POINTER(struct_bn_tol))),
    ('ft_tnurb', CFUNCTYPE(UNCHECKED(c_int), POINTER(POINTER(struct_nmgregion)), POINTER(struct_model), POINTER(struct_rt_db_internal), POINTER(struct_bn_tol))),
    ('ft_brep', CFUNCTYPE(UNCHECKED(None), POINTER(POINTER(ON_Brep)), POINTER(struct_rt_db_internal), POINTER(struct_bn_tol))),
    ('ft_import5', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_db_internal), POINTER(struct_bu_external), mat_t, POINTER(struct_db_i), POINTER(struct_resource))),
    ('ft_export5', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_external), POINTER(struct_rt_db_internal), c_double, POINTER(struct_db_i), POINTER(struct_resource))),
    ('ft_import4', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_db_internal), POINTER(struct_bu_external), mat_t, POINTER(struct_db_i), POINTER(struct_resource))),
    ('ft_export4', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_external), POINTER(struct_rt_db_internal), c_double, POINTER(struct_db_i), POINTER(struct_resource))),
    ('ft_ifree', CFUNCTYPE(UNCHECKED(None), POINTER(struct_rt_db_internal))),
    ('ft_describe', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_vls), POINTER(struct_rt_db_internal), c_int, c_double, POINTER(struct_resource), POINTER(struct_db_i))),
    ('ft_xform', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_db_internal), mat_t, POINTER(struct_rt_db_internal), c_int, POINTER(struct_db_i), POINTER(struct_resource))),
    ('ft_parsetab', POINTER(struct_bu_structparse)),
    ('ft_internal_size', c_size_t),
    ('ft_internal_magic', c_uint32),
    ('ft_get', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_vls), POINTER(struct_rt_db_internal), String)),
    ('ft_adjust', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_vls), POINTER(struct_rt_db_internal), c_int, POINTER(POINTER(c_char)))),
    ('ft_form', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_bu_vls), POINTER(struct_rt_functab))),
    ('ft_make', CFUNCTYPE(UNCHECKED(None), POINTER(struct_rt_functab), POINTER(struct_rt_db_internal))),
    ('ft_params', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_pc_pc_set), POINTER(struct_rt_db_internal))),
    ('ft_bbox', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_db_internal), POINTER(point_t), POINTER(point_t), POINTER(struct_bn_tol))),
    ('ft_volume', CFUNCTYPE(UNCHECKED(None), POINTER(fastf_t), POINTER(struct_rt_db_internal))),
    ('ft_surf_area', CFUNCTYPE(UNCHECKED(None), POINTER(fastf_t), POINTER(struct_rt_db_internal))),
    ('ft_centroid', CFUNCTYPE(UNCHECKED(None), POINTER(point_t), POINTER(struct_rt_db_internal))),
    ('ft_oriented_bbox', CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_rt_arb_internal), POINTER(struct_rt_db_internal), fastf_t)),
]

# /home/kanzure/local/brlcad/brlcad/include/raytrace.h: 3359
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'wdb_export'):
    wdb_export = _libs['/usr/brlcad/lib/libwdb.so'].wdb_export
    wdb_export.argtypes = [POINTER(struct_rt_wdb), String, genptr_t, c_int, c_double]
    wdb_export.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 44
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'wdb_fopen'):
    wdb_fopen = _libs['/usr/brlcad/lib/libwdb.so'].wdb_fopen
    wdb_fopen.argtypes = [String]
    wdb_fopen.restype = POINTER(struct_rt_wdb)

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 62
class struct_wmember(Structure):
    pass

struct_wmember.__slots__ = [
    'l',
    'wm_op',
    'wm_mat',
    'wm_name',
]
struct_wmember._fields_ = [
    ('l', struct_bu_list),
    ('wm_op', c_int),
    ('wm_mat', mat_t),
    ('wm_name', String),
]

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 79
class struct_wdb_pipept(Structure):
    pass

struct_wdb_pipept.__slots__ = [
    'l',
    'pp_coord',
    'pp_id',
    'pp_od',
    'pp_bendradius',
]
struct_wdb_pipept._fields_ = [
    ('l', struct_bu_list),
    ('pp_coord', point_t),
    ('pp_id', fastf_t),
    ('pp_od', fastf_t),
    ('pp_bendradius', fastf_t),
]

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 89
class struct_wdb_metaballpt(Structure):
    pass

struct_wdb_metaballpt.__slots__ = [
    'l',
    'type',
    'fldstr',
    'sweat',
    'coord',
    'coord2',
]
struct_wdb_metaballpt._fields_ = [
    ('l', struct_bu_list),
    ('type', c_int),
    ('fldstr', fastf_t),
    ('sweat', fastf_t),
    ('coord', point_t),
    ('coord2', point_t),
]

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 105
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_id'):
    mk_id = _libs['/usr/brlcad/lib/libwdb.so'].mk_id
    mk_id.argtypes = [POINTER(struct_rt_wdb), String]
    mk_id.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 116
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_id_units'):
    mk_id_units = _libs['/usr/brlcad/lib/libwdb.so'].mk_id_units
    mk_id_units.argtypes = [POINTER(struct_rt_wdb), String, String]
    mk_id_units.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 138
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_id_editunits'):
    mk_id_editunits = _libs['/usr/brlcad/lib/libwdb.so'].mk_id_editunits
    mk_id_editunits.argtypes = [POINTER(struct_rt_wdb), String, c_double]
    mk_id_editunits.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 177
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_half'):
    mk_half = _libs['/usr/brlcad/lib/libwdb.so'].mk_half
    mk_half.argtypes = [POINTER(struct_rt_wdb), String, vect_t, fastf_t]
    mk_half.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 185
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_grip'):
    mk_grip = _libs['/usr/brlcad/lib/libwdb.so'].mk_grip
    mk_grip.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, fastf_t]
    mk_grip.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 197
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_rpp'):
    mk_rpp = _libs['/usr/brlcad/lib/libwdb.so'].mk_rpp
    mk_rpp.argtypes = [POINTER(struct_rt_wdb), String, point_t, point_t]
    mk_rpp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 207
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_wedge'):
    mk_wedge = _libs['/usr/brlcad/lib/libwdb.so'].mk_wedge
    mk_wedge.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, fastf_t, fastf_t, fastf_t, fastf_t]
    mk_wedge.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 212
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_arb4'):
    mk_arb4 = _libs['/usr/brlcad/lib/libwdb.so'].mk_arb4
    mk_arb4.argtypes = [POINTER(struct_rt_wdb), String, POINTER(fastf_t)]
    mk_arb4.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 214
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_arb5'):
    mk_arb5 = _libs['/usr/brlcad/lib/libwdb.so'].mk_arb5
    mk_arb5.argtypes = [POINTER(struct_rt_wdb), String, POINTER(fastf_t)]
    mk_arb5.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 216
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_arb6'):
    mk_arb6 = _libs['/usr/brlcad/lib/libwdb.so'].mk_arb6
    mk_arb6.argtypes = [POINTER(struct_rt_wdb), String, POINTER(fastf_t)]
    mk_arb6.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 218
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_arb7'):
    mk_arb7 = _libs['/usr/brlcad/lib/libwdb.so'].mk_arb7
    mk_arb7.argtypes = [POINTER(struct_rt_wdb), String, POINTER(fastf_t)]
    mk_arb7.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 230
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_arb8'):
    mk_arb8 = _libs['/usr/brlcad/lib/libwdb.so'].mk_arb8
    mk_arb8.argtypes = [POINTER(struct_rt_wdb), String, POINTER(fastf_t)]
    mk_arb8.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 237
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_sph'):
    mk_sph = _libs['/usr/brlcad/lib/libwdb.so'].mk_sph
    mk_sph.argtypes = [POINTER(struct_rt_wdb), String, point_t, fastf_t]
    mk_sph.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 247
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_ell'):
    mk_ell = _libs['/usr/brlcad/lib/libwdb.so'].mk_ell
    mk_ell.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, vect_t]
    mk_ell.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 256
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_tor'):
    mk_tor = _libs['/usr/brlcad/lib/libwdb.so'].mk_tor
    mk_tor.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, c_double, c_double]
    mk_tor.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 264
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_rcc'):
    mk_rcc = _libs['/usr/brlcad/lib/libwdb.so'].mk_rcc
    mk_rcc.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, fastf_t]
    mk_rcc.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 272
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_tgc'):
    mk_tgc = _libs['/usr/brlcad/lib/libwdb.so'].mk_tgc
    mk_tgc.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, vect_t, vect_t, vect_t]
    mk_tgc.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 283
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_cone'):
    mk_cone = _libs['/usr/brlcad/lib/libwdb.so'].mk_cone
    mk_cone.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, fastf_t, fastf_t, fastf_t]
    mk_cone.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 294
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_trc_h'):
    mk_trc_h = _libs['/usr/brlcad/lib/libwdb.so'].mk_trc_h
    mk_trc_h.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, fastf_t, fastf_t]
    mk_trc_h.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 302
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_trc_top'):
    mk_trc_top = _libs['/usr/brlcad/lib/libwdb.so'].mk_trc_top
    mk_trc_top.argtypes = [POINTER(struct_rt_wdb), String, point_t, point_t, fastf_t, fastf_t]
    mk_trc_top.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 312
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_rpc'):
    mk_rpc = _libs['/usr/brlcad/lib/libwdb.so'].mk_rpc
    mk_rpc.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, c_double]
    mk_rpc.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 329
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_rhc'):
    mk_rhc = _libs['/usr/brlcad/lib/libwdb.so'].mk_rhc
    mk_rhc.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, fastf_t, fastf_t]
    mk_rhc.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 345
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_epa'):
    mk_epa = _libs['/usr/brlcad/lib/libwdb.so'].mk_epa
    mk_epa.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, fastf_t, fastf_t]
    mk_epa.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 363
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_ehy'):
    mk_ehy = _libs['/usr/brlcad/lib/libwdb.so'].mk_ehy
    mk_ehy.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, fastf_t, fastf_t, fastf_t]
    mk_ehy.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 380
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_hyp'):
    mk_hyp = _libs['/usr/brlcad/lib/libwdb.so'].mk_hyp
    mk_hyp.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, fastf_t, fastf_t]
    mk_hyp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 398
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_eto'):
    mk_eto = _libs['/usr/brlcad/lib/libwdb.so'].mk_eto
    mk_eto.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, fastf_t, fastf_t]
    mk_eto.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 407
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_metaball'):
    mk_metaball = _libs['/usr/brlcad/lib/libwdb.so'].mk_metaball
    mk_metaball.argtypes = [POINTER(struct_rt_wdb), String, c_size_t, c_int, fastf_t, POINTER(fastf_t) * 5]
    mk_metaball.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 415
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_arbn'):
    mk_arbn = _libs['/usr/brlcad/lib/libwdb.so'].mk_arbn
    mk_arbn.argtypes = [POINTER(struct_rt_wdb), String, c_size_t, POINTER(plane_t)]
    mk_arbn.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 417
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_ars'):
    mk_ars = _libs['/usr/brlcad/lib/libwdb.so'].mk_ars
    mk_ars.argtypes = [POINTER(struct_rt_wdb), String, c_size_t, c_size_t, POINTER(POINTER(fastf_t))]
    mk_ars.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 426
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_constraint'):
    mk_constraint = _libs['/usr/brlcad/lib/libwdb.so'].mk_constraint
    mk_constraint.argtypes = [POINTER(struct_rt_wdb), String, String]
    mk_constraint.restype = c_int

enum_anon_52 = c_int # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FLOAT = 0 # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_DOUBLE = (WDB_BINUNIF_FLOAT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_CHAR = (WDB_BINUNIF_DOUBLE + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_UCHAR = (WDB_BINUNIF_CHAR + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_SHORT = (WDB_BINUNIF_UCHAR + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_USHORT = (WDB_BINUNIF_SHORT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_INT = (WDB_BINUNIF_USHORT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_UINT = (WDB_BINUNIF_INT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_LONG = (WDB_BINUNIF_UINT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_ULONG = (WDB_BINUNIF_LONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_LONGLONG = (WDB_BINUNIF_ULONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_ULONGLONG = (WDB_BINUNIF_LONGLONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_INT8 = (WDB_BINUNIF_ULONGLONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_UINT8 = (WDB_BINUNIF_INT8 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_INT16 = (WDB_BINUNIF_UINT8 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_UINT16 = (WDB_BINUNIF_INT16 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_INT32 = (WDB_BINUNIF_UINT16 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_UINT32 = (WDB_BINUNIF_INT32 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_INT64 = (WDB_BINUNIF_UINT32 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_UINT64 = (WDB_BINUNIF_INT64 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_FLOAT = (WDB_BINUNIF_UINT64 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_DOUBLE = (WDB_BINUNIF_FILE_FLOAT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_CHAR = (WDB_BINUNIF_FILE_DOUBLE + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_UCHAR = (WDB_BINUNIF_FILE_CHAR + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_SHORT = (WDB_BINUNIF_FILE_UCHAR + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_USHORT = (WDB_BINUNIF_FILE_SHORT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_INT = (WDB_BINUNIF_FILE_USHORT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_UINT = (WDB_BINUNIF_FILE_INT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_LONG = (WDB_BINUNIF_FILE_UINT + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_ULONG = (WDB_BINUNIF_FILE_LONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_LONGLONG = (WDB_BINUNIF_FILE_ULONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_ULONGLONG = (WDB_BINUNIF_FILE_LONGLONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_INT8 = (WDB_BINUNIF_FILE_ULONGLONG + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_UINT8 = (WDB_BINUNIF_FILE_INT8 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_INT16 = (WDB_BINUNIF_FILE_UINT8 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_UINT16 = (WDB_BINUNIF_FILE_INT16 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_INT32 = (WDB_BINUNIF_FILE_UINT16 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_UINT32 = (WDB_BINUNIF_FILE_INT32 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_INT64 = (WDB_BINUNIF_FILE_UINT32 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

WDB_BINUNIF_FILE_UINT64 = (WDB_BINUNIF_FILE_INT64 + 1) # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

wdb_binunif = enum_anon_52 # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 470

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 486
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_binunif'):
    mk_binunif = _libs['/usr/brlcad/lib/libwdb.so'].mk_binunif
    mk_binunif.argtypes = [POINTER(struct_rt_wdb), String, genptr_t, wdb_binunif, c_long]
    mk_binunif.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 502
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_bot'):
    mk_bot = _libs['/usr/brlcad/lib/libwdb.so'].mk_bot
    mk_bot.argtypes = [POINTER(struct_rt_wdb), String, c_ubyte, c_ubyte, c_ubyte, c_size_t, c_size_t, POINTER(fastf_t), POINTER(c_int), POINTER(fastf_t), POINTER(struct_bu_bitv)]
    mk_bot.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 527
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_bot_w_normals'):
    mk_bot_w_normals = _libs['/usr/brlcad/lib/libwdb.so'].mk_bot_w_normals
    mk_bot_w_normals.argtypes = [POINTER(struct_rt_wdb), String, c_ubyte, c_ubyte, c_ubyte, c_size_t, c_size_t, POINTER(fastf_t), POINTER(c_int), POINTER(fastf_t), POINTER(struct_bu_bitv), c_size_t, POINTER(fastf_t), POINTER(c_int)]
    mk_bot_w_normals.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 576
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_brep'):
    mk_brep = _libs['/usr/brlcad/lib/libwdb.so'].mk_brep
    mk_brep.argtypes = [POINTER(struct_rt_wdb), String, POINTER(ON_Brep)]
    mk_brep.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 598
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_bspline'):
    mk_bspline = _libs['/usr/brlcad/lib/libwdb.so'].mk_bspline
    mk_bspline.argtypes = [POINTER(struct_rt_wdb), String, POINTER(POINTER(struct_face_g_snurb))]
    mk_bspline.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 622
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_nmg'):
    mk_nmg = _libs['/usr/brlcad/lib/libwdb.so'].mk_nmg
    mk_nmg.argtypes = [POINTER(struct_rt_wdb), String, POINTER(struct_model)]
    mk_nmg.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 632
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_bot_from_nmg'):
    mk_bot_from_nmg = _libs['/usr/brlcad/lib/libwdb.so'].mk_bot_from_nmg
    mk_bot_from_nmg.argtypes = [POINTER(struct_rt_wdb), String, POINTER(struct_shell)]
    mk_bot_from_nmg.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 647
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_sketch'):
    mk_sketch = _libs['/usr/brlcad/lib/libwdb.so'].mk_sketch
    mk_sketch.argtypes = [POINTER(struct_rt_wdb), String, POINTER(struct_rt_sketch_internal)]
    mk_sketch.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 665
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_extrusion'):
    mk_extrusion = _libs['/usr/brlcad/lib/libwdb.so'].mk_extrusion
    mk_extrusion.argtypes = [POINTER(struct_rt_wdb), String, String, point_t, vect_t, vect_t, vect_t, c_int]
    mk_extrusion.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 688
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_cline'):
    mk_cline = _libs['/usr/brlcad/lib/libwdb.so'].mk_cline
    mk_cline.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, fastf_t, fastf_t]
    mk_cline.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 724
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_particle'):
    mk_particle = _libs['/usr/brlcad/lib/libwdb.so'].mk_particle
    mk_particle.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, c_double, c_double]
    mk_particle.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 737
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_pipe'):
    mk_pipe = _libs['/usr/brlcad/lib/libwdb.so'].mk_pipe
    mk_pipe.argtypes = [POINTER(struct_rt_wdb), String, POINTER(struct_bu_list)]
    mk_pipe.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 744
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_pipe_free'):
    mk_pipe_free = _libs['/usr/brlcad/lib/libwdb.so'].mk_pipe_free
    mk_pipe_free.argtypes = [POINTER(struct_bu_list)]
    mk_pipe_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 751
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_add_pipe_pt'):
    mk_add_pipe_pt = _libs['/usr/brlcad/lib/libwdb.so'].mk_add_pipe_pt
    mk_add_pipe_pt.argtypes = [POINTER(struct_bu_list), point_t, c_double, c_double, c_double]
    mk_add_pipe_pt.restype = None

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 763
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_pipe_init'):
    mk_pipe_init = _libs['/usr/brlcad/lib/libwdb.so'].mk_pipe_init
    mk_pipe_init.argtypes = [POINTER(struct_bu_list)]
    mk_pipe_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 768
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_dsp'):
    mk_dsp = _libs['/usr/brlcad/lib/libwdb.so'].mk_dsp
    mk_dsp.argtypes = [POINTER(struct_rt_wdb), String, String, c_size_t, c_size_t, matp_t]
    mk_dsp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 771
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_ebm'):
    mk_ebm = _libs['/usr/brlcad/lib/libwdb.so'].mk_ebm
    mk_ebm.argtypes = [POINTER(struct_rt_wdb), String, String, c_size_t, c_size_t, fastf_t, matp_t]
    mk_ebm.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 774
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'mk_hrt'):
        continue
    mk_hrt = _lib.mk_hrt
    mk_hrt.argtypes = [POINTER(struct_rt_wdb), String, point_t, vect_t, vect_t, vect_t, fastf_t]
    mk_hrt.restype = c_int
    break

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 780
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_vol'):
    mk_vol = _libs['/usr/brlcad/lib/libwdb.so'].mk_vol
    mk_vol.argtypes = [POINTER(struct_rt_wdb), String, String, c_size_t, c_size_t, c_size_t, c_size_t, c_size_t, vect_t, matp_t]
    mk_vol.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 792
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_submodel'):
    mk_submodel = _libs['/usr/brlcad/lib/libwdb.so'].mk_submodel
    mk_submodel.argtypes = [POINTER(struct_rt_wdb), String, String, String, c_int]
    mk_submodel.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 814
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_write_color_table'):
    mk_write_color_table = _libs['/usr/brlcad/lib/libwdb.so'].mk_write_color_table
    mk_write_color_table.argtypes = [POINTER(struct_rt_wdb)]
    mk_write_color_table.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 835
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_addmember'):
    mk_addmember = _libs['/usr/brlcad/lib/libwdb.so'].mk_addmember
    #mk_addmember.argtypes = [String, POINTER(struct_bu_list), mat_t, c_int] # modified by kanzure
    mk_addmember.restype = POINTER(struct_wmember)

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 863
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_comb'):
    mk_comb = _libs['/usr/brlcad/lib/libwdb.so'].mk_comb
    mk_comb.argtypes = [POINTER(struct_rt_wdb), String, POINTER(struct_bu_list), c_int, String, String, POINTER(c_ubyte), c_int, c_int, c_int, c_int, c_int, c_int, c_int]
    mk_comb.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 885
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_comb1'):
    mk_comb1 = _libs['/usr/brlcad/lib/libwdb.so'].mk_comb1
    mk_comb1.argtypes = [POINTER(struct_rt_wdb), String, String, c_int]
    mk_comb1.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 896
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_region1'):
    mk_region1 = _libs['/usr/brlcad/lib/libwdb.so'].mk_region1
    mk_region1.argtypes = [POINTER(struct_rt_wdb), String, String, String, String, POINTER(c_ubyte)]
    mk_region1.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 926
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_conversion'):
    mk_conversion = _libs['/usr/brlcad/lib/libwdb.so'].mk_conversion
    mk_conversion.argtypes = [String]
    mk_conversion.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 937
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_set_conversion'):
    mk_set_conversion = _libs['/usr/brlcad/lib/libwdb.so'].mk_set_conversion
    mk_set_conversion.argtypes = [c_double]
    mk_set_conversion.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 943
try:
    mk_conv2mm = (c_double).in_dll(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_conv2mm')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 949
try:
    mk_version = (c_int).in_dll(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_version')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 958
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'mk_freemembers'):
    mk_freemembers = _libs['/usr/brlcad/lib/libwdb.so'].mk_freemembers
    mk_freemembers.argtypes = [POINTER(struct_bu_list)]
    mk_freemembers.restype = None

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 998
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'make_hole'):
    make_hole = _libs['/usr/brlcad/lib/libwdb.so'].make_hole
    make_hole.argtypes = [POINTER(struct_rt_wdb), point_t, vect_t, fastf_t, c_int, POINTER(POINTER(struct_directory))]
    make_hole.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 1027
if hasattr(_libs['/usr/brlcad/lib/libwdb.so'], 'make_hole_in_prepped_regions'):
    make_hole_in_prepped_regions = _libs['/usr/brlcad/lib/libwdb.so'].make_hole_in_prepped_regions
    make_hole_in_prepped_regions.argtypes = [POINTER(struct_rt_wdb), POINTER(struct_rt_i), point_t, vect_t, fastf_t, POINTER(struct_bu_ptbl)]
    make_hole_in_prepped_regions.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 71
try:
    WMEMBER_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 87
try:
    WDB_PIPESEG_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 97
try:
    WDB_METABALLPT_TYPE_POINT = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 98
try:
    WDB_METABALLPT_TYPE_LINE = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 99
try:
    WDB_METABALLPT_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 840
def mk_lcomb(_fp, _name, _headp, _rf, _shadername, _shaderargs, _rgb, _inh):
    return (mk_comb (_fp, _name, pointer((_headp.contents.l)), _rf, _shadername, _shaderargs, _rgb, 0, 0, 0, 0, _inh, 0, 0))

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 846
def mk_lrcomb(fp, name, _headp, region_flag, shadername, shaderargs, rgb, id, air, material, los, inherit_flag):
    return (mk_comb (fp, name, pointer((_headp.contents.l)), region_flag, shadername, shaderargs, rgb, id, air, material, los, inherit_flag, 0, 0))

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 905
try:
    WMOP_INTERSECT = '+'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 906
try:
    WMOP_SUBTRACT = '-'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 907
try:
    WMOP_UNION = 'u'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/wdb.h: 960
def mk_export_fwrite(wdbp, name, gp, id):
    return (wdb_export (wdbp, name, gp, id, mk_conv2mm))

wmember = struct_wmember # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 62

wdb_pipept = struct_wdb_pipept # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 79

wdb_metaballpt = struct_wdb_metaballpt # /home/kanzure/local/brlcad/brlcad/include/wdb.h: 89

# No inserted files

