'''Wrapper for bu.h

Generated with:
ctypesgen.py -l/usr/brlcad/lib/libbu.so -mwdb /home/kanzure/local/brlcad/brlcad/include/bu.h -o bu.py

Do not modify this file.
'''

__docformat__ =  'restructuredtext'

# Begin preamble

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, 'c_int64'):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types

class c_void(Structure):
    # c_void_p is a buggy return type, converting to int, so
    # POINTER(None) == c_void_p is actually written as
    # POINTER(c_void), so it can be treated as a real pointer.
    _fields_ = [('dummy', c_int)]

def POINTER(obj):
    p = ctypes.POINTER(obj)

    # Convert None to a real NULL pointer to work around bugs
    # in how ctypes handles None on 64-bit platforms
    if not isinstance(p.from_param, classmethod):
        def from_param(cls, x):
            if x is None:
                return cls()
            else:
                return x
        p.from_param = classmethod(from_param)

    return p

class UserString:
    def __init__(self, seq):
        if isinstance(seq, basestring):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq)
    def __str__(self): return str(self.data)
    def __repr__(self): return repr(self.data)
    def __int__(self): return int(self.data)
    def __long__(self): return long(self.data)
    def __float__(self): return float(self.data)
    def __complex__(self): return complex(self.data)
    def __hash__(self): return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)
    def __contains__(self, char):
        return char in self.data

    def __len__(self): return len(self.data)
    def __getitem__(self, index): return self.__class__(self.data[index])
    def __getslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, basestring):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other))
    def __radd__(self, other):
        if isinstance(other, basestring):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other) + self.data)
    def __mul__(self, n):
        return self.__class__(self.data*n)
    __rmul__ = __mul__
    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self): return self.__class__(self.data.capitalize())
    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))
    def count(self, sub, start=0, end=sys.maxint):
        return self.data.count(sub, start, end)
    def decode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())
    def encode(self, encoding=None, errors=None): # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())
    def endswith(self, suffix, start=0, end=sys.maxint):
        return self.data.endswith(suffix, start, end)
    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))
    def find(self, sub, start=0, end=sys.maxint):
        return self.data.find(sub, start, end)
    def index(self, sub, start=0, end=sys.maxint):
        return self.data.index(sub, start, end)
    def isalpha(self): return self.data.isalpha()
    def isalnum(self): return self.data.isalnum()
    def isdecimal(self): return self.data.isdecimal()
    def isdigit(self): return self.data.isdigit()
    def islower(self): return self.data.islower()
    def isnumeric(self): return self.data.isnumeric()
    def isspace(self): return self.data.isspace()
    def istitle(self): return self.data.istitle()
    def isupper(self): return self.data.isupper()
    def join(self, seq): return self.data.join(seq)
    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))
    def lower(self): return self.__class__(self.data.lower())
    def lstrip(self, chars=None): return self.__class__(self.data.lstrip(chars))
    def partition(self, sep):
        return self.data.partition(sep)
    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))
    def rfind(self, sub, start=0, end=sys.maxint):
        return self.data.rfind(sub, start, end)
    def rindex(self, sub, start=0, end=sys.maxint):
        return self.data.rindex(sub, start, end)
    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))
    def rpartition(self, sep):
        return self.data.rpartition(sep)
    def rstrip(self, chars=None): return self.__class__(self.data.rstrip(chars))
    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)
    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)
    def splitlines(self, keepends=0): return self.data.splitlines(keepends)
    def startswith(self, prefix, start=0, end=sys.maxint):
        return self.data.startswith(prefix, start, end)
    def strip(self, chars=None): return self.__class__(self.data.strip(chars))
    def swapcase(self): return self.__class__(self.data.swapcase())
    def title(self): return self.__class__(self.data.title())
    def translate(self, *args):
        return self.__class__(self.data.translate(*args))
    def upper(self): return self.__class__(self.data.upper())
    def zfill(self, width): return self.__class__(self.data.zfill(width))

class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""
    def __init__(self, string=""):
        self.data = string
    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")
    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + sub + self.data[index+1:]
    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data): raise IndexError
        self.data = self.data[:index] + self.data[index+1:]
    def __setslice__(self, start, end, sub):
        start = max(start, 0); end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start]+sub.data+self.data[end:]
        elif isinstance(sub, basestring):
            self.data = self.data[:start]+sub+self.data[end:]
        else:
            self.data =  self.data[:start]+str(sub)+self.data[end:]
    def __delslice__(self, start, end):
        start = max(start, 0); end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]
    def immutable(self):
        return UserString(self.data)
    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, basestring):
            self.data += other
        else:
            self.data += str(other)
        return self
    def __imul__(self, n):
        self.data *= n
        return self

class String(MutableString, Union):

    _fields_ = [('raw', POINTER(c_char)),
                ('data', c_char_p)]

    def __init__(self, obj=""):
        if isinstance(obj, (str, unicode, UserString)):
            self.data = str(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj)

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)
    from_param = classmethod(from_param)

def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)

# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if (hasattr(type, "_type_") and isinstance(type._type_, str)
        and type._type_ != "P"):
        return type
    else:
        return c_void_p

# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self,func,restype,argtypes):
        self.func=func
        self.func.restype=restype
        self.argtypes=argtypes
    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func
    def __call__(self,*args):
        fixed_args=[]
        i=0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i+=1
        return self.func(*fixed_args+list(args[i:]))

# End preamble

_libs = {}
_libdirs = []

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import platform
import ctypes
import ctypes.util

def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []

class LibraryLoader(object):
    def __init__(self):
        self.other_dirs=[]

    def load_library(self,libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            if os.path.exists(path):
                return self.load(path)

        raise ImportError("%s not found." % libname)

    def load(self,path):
        """Given a path to a library, load it."""
        try:
            # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
            # of the default RTLD_LOCAL.  Without this, you end up with
            # libraries not being loadable, resulting in "Symbol not found"
            # errors
            if sys.platform == 'darwin':
                return ctypes.CDLL(path, ctypes.RTLD_GLOBAL)
            else:
                return ctypes.cdll.LoadLibrary(path)
        except OSError,e:
            raise ImportError(e)

    def getpaths(self,libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname
        else:
            # FIXME / TODO return '.' and os.path.dirname(__file__)
            for path in self.getplatformpaths(libname):
                yield path

            path = ctypes.util.find_library(libname)
            if path: yield path

    def getplatformpaths(self, libname):
        return []

# Darwin (Mac OS X)

class DarwinLibraryLoader(LibraryLoader):
    name_formats = ["lib%s.dylib", "lib%s.so", "lib%s.bundle", "%s.dylib",
                "%s.so", "%s.bundle", "%s"]

    def getplatformpaths(self,libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir,name)

    def getdirs(self,libname):
        '''Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        '''

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser('~/lib'),
                                          '/usr/local/lib', '/usr/lib']

        dirs = []

        if '/' in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        dirs.extend(self.other_dirs)
        dirs.append(".")
        dirs.append(os.path.dirname(__file__))

        if hasattr(sys, 'frozen') and sys.frozen == 'macosx_app':
            dirs.append(os.path.join(
                os.environ['RESOURCEPATH'],
                '..',
                'Frameworks'))

        dirs.extend(dyld_fallback_library_path)

        return dirs

# Posix

class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = []
        for name in ("LD_LIBRARY_PATH",
                     "SHLIB_PATH", # HPUX
                     "LIBPATH", # OS/2, AIX
                     "LIBRARY_PATH", # BE/OS
                    ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))
        directories.extend(self.other_dirs)
        directories.append(".")
        directories.append(os.path.dirname(__file__))

        try: directories.extend([dir.strip() for dir in open('/etc/ld.so.conf')])
        except IOError: pass

        unix_lib_dirs_list = ['/lib', '/usr/lib', '/lib64', '/usr/lib64']
        if sys.platform.startswith('linux'):
            # Try and support multiarch work in Ubuntu
            # https://wiki.ubuntu.com/MultiarchSpec
            bitage = platform.architecture()[0]
            if bitage.startswith('32'):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ['/lib/i386-linux-gnu', '/usr/lib/i386-linux-gnu']
            elif bitage.startswith('64'):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ['/lib/x86_64-linux-gnu', '/usr/lib/x86_64-linux-gnu']
            else:
                # guess...
                unix_lib_dirs_list += glob.glob('/lib/*linux-gnu')
        directories.extend(unix_lib_dirs_list)

        cache = {}
        lib_re = re.compile(r'lib(.*)\.s[ol]')
        ext_re = re.compile(r'\.s[ol]$')
        for dir in directories:
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    if file not in cache:
                        cache[file] = path

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        if library not in cache:
                            cache[library] = path
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname)
        if result: yield result

        path = ctypes.util.find_library(libname)
        if path: yield os.path.join("/lib",path)

# Windows

class _WindowsLibrary(object):
    def __init__(self, path):
        self.cdll = ctypes.cdll.LoadLibrary(path)
        self.windll = ctypes.windll.LoadLibrary(path)

    def __getattr__(self, name):
        try: return getattr(self.cdll,name)
        except AttributeError:
            try: return getattr(self.windll,name)
            except AttributeError:
                raise

class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll"]

    def load_library(self, libname):
        try:
            result = LibraryLoader.load_library(self, libname)
        except ImportError:
            result = None
            if os.path.sep not in libname:
                for name in self.name_formats:
                    try:
                        result = getattr(ctypes.cdll, name % libname)
                        if result:
                            break
                    except WindowsError:
                        result = None
            if result is None:
                try:
                    result = getattr(ctypes.cdll, libname)
                except WindowsError:
                    result = None
            if result is None:
                raise ImportError("%s not found." % libname)
        return result

    def load(self, path):
        return _WindowsLibrary(path)

    def getplatformpaths(self, libname):
        if os.path.sep not in libname:
            for name in self.name_formats:
                dll_in_current_dir = os.path.abspath(name % libname)
                if os.path.exists(dll_in_current_dir):
                    yield dll_in_current_dir
                path = ctypes.util.find_library(name % libname)
                if path:
                    yield path

# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin":   DarwinLibraryLoader,
    "cygwin":   WindowsLibraryLoader,
    "win32":    WindowsLibraryLoader
}

loader = loaderclass.get(sys.platform, PosixLibraryLoader)()

def add_library_search_dirs(other_dirs):
    loader.other_dirs = other_dirs

load_library = loader.load_library

del loaderclass

# End loader

add_library_search_dirs([])

# Begin libraries

_libs["/usr/brlcad/lib/libbu.so"] = load_library("/usr/brlcad/lib/libbu.so")

# 1 libraries
# End libraries

# Begin modules

from wdb import *

# 1 modules
# End modules

NULL = None # <built-in>

__off_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 140

__off64_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 141

__time_t = c_long # /usr/include/x86_64-linux-gnu/bits/types.h: 148

off_t = __off_t # /usr/include/x86_64-linux-gnu/sys/types.h: 86

time_t = __time_t # /usr/include/time.h: 75

# /usr/include/x86_64-linux-gnu/bits/sigset.h: 31
class struct_anon_7(Structure):
    pass

struct_anon_7.__slots__ = [
    '__val',
]
struct_anon_7._fields_ = [
    ('__val', c_ulong * (1024 / (8 * sizeof(c_ulong)))),
]

__sigset_t = struct_anon_7 # /usr/include/x86_64-linux-gnu/bits/sigset.h: 31

__jmp_buf = c_long * 8 # /usr/include/x86_64-linux-gnu/bits/setjmp.h: 31

# /usr/include/setjmp.h: 34
class struct___jmp_buf_tag(Structure):
    pass

struct___jmp_buf_tag.__slots__ = [
    '__jmpbuf',
    '__mask_was_saved',
    '__saved_mask',
]
struct___jmp_buf_tag._fields_ = [
    ('__jmpbuf', __jmp_buf),
    ('__mask_was_saved', c_int),
    ('__saved_mask', __sigset_t),
]

jmp_buf = struct___jmp_buf_tag * 1 # /usr/include/setjmp.h: 48

# /usr/include/setjmp.h: 52
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'setjmp'):
    setjmp = _libs['/usr/brlcad/lib/libbu.so'].setjmp
    setjmp.argtypes = [jmp_buf]
    setjmp.restype = c_int

# /usr/include/libio.h: 246
class struct__IO_FILE(Structure):
    pass

FILE = struct__IO_FILE # /usr/include/stdio.h: 48

_IO_lock_t = None # /usr/include/libio.h: 155

# /usr/include/libio.h: 161
class struct__IO_marker(Structure):
    pass

struct__IO_marker.__slots__ = [
    '_next',
    '_sbuf',
    '_pos',
]
struct__IO_marker._fields_ = [
    ('_next', POINTER(struct__IO_marker)),
    ('_sbuf', POINTER(struct__IO_FILE)),
    ('_pos', c_int),
]

struct__IO_FILE.__slots__ = [
    '_flags',
    '_IO_read_ptr',
    '_IO_read_end',
    '_IO_read_base',
    '_IO_write_base',
    '_IO_write_ptr',
    '_IO_write_end',
    '_IO_buf_base',
    '_IO_buf_end',
    '_IO_save_base',
    '_IO_backup_base',
    '_IO_save_end',
    '_markers',
    '_chain',
    '_fileno',
    '_flags2',
    '_old_offset',
    '_cur_column',
    '_vtable_offset',
    '_shortbuf',
    '_lock',
    '_offset',
    '__pad1',
    '__pad2',
    '__pad3',
    '__pad4',
    '__pad5',
    '_mode',
    '_unused2',
]
struct__IO_FILE._fields_ = [
    ('_flags', c_int),
    ('_IO_read_ptr', String),
    ('_IO_read_end', String),
    ('_IO_read_base', String),
    ('_IO_write_base', String),
    ('_IO_write_ptr', String),
    ('_IO_write_end', String),
    ('_IO_buf_base', String),
    ('_IO_buf_end', String),
    ('_IO_save_base', String),
    ('_IO_backup_base', String),
    ('_IO_save_end', String),
    ('_markers', POINTER(struct__IO_marker)),
    ('_chain', POINTER(struct__IO_FILE)),
    ('_fileno', c_int),
    ('_flags2', c_int),
    ('_old_offset', __off_t),
    ('_cur_column', c_ushort),
    ('_vtable_offset', c_char),
    ('_shortbuf', c_char * 1),
    ('_lock', POINTER(_IO_lock_t)),
    ('_offset', __off64_t),
    ('__pad1', POINTER(None)),
    ('__pad2', POINTER(None)),
    ('__pad3', POINTER(None)),
    ('__pad4', POINTER(None)),
    ('__pad5', c_size_t),
    ('_mode', c_int),
    ('_unused2', c_char * (((15 * sizeof(c_int)) - (4 * sizeof(POINTER(None)))) - sizeof(c_size_t))),
]

# /usr/include/tcl/tcl.h: 478
class struct_Tcl_Interp(Structure):
    pass

struct_Tcl_Interp.__slots__ = [
    'result',
    'freeProc',
    'errorLine',
]
struct_Tcl_Interp._fields_ = [
    ('result', String),
    ('freeProc', CFUNCTYPE(UNCHECKED(None), String)),
    ('errorLine', c_int),
]

Tcl_Interp = struct_Tcl_Interp # /usr/include/tcl/tcl.h: 478

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 227
try:
    brlcad_interp = (POINTER(Tcl_Interp)).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'brlcad_interp')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 387
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_version'):
    bu_version = _libs['/usr/brlcad/lib/libbu.so'].bu_version
    bu_version.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        bu_version.restype = ReturnString
    else:
        bu_version.restype = String
        bu_version.errcheck = ReturnString

genptr_t = POINTER(None) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 400

const_genptr_t = POINTER(None) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 401

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 507
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv'):
    bu_cv = _libs['/usr/brlcad/lib/libbu.so'].bu_cv
    bu_cv.argtypes = [genptr_t, String, c_size_t, genptr_t, String, c_int]
    bu_cv.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 527
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_cookie'):
    bu_cv_cookie = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_cookie
    bu_cv_cookie.argtypes = [String]
    bu_cv_cookie.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 534
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_optimize'):
    bu_cv_optimize = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_optimize
    bu_cv_optimize.argtypes = [c_int]
    bu_cv_optimize.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 539
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_itemlen'):
    bu_cv_itemlen = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_itemlen
    bu_cv_itemlen.argtypes = [c_int]
    bu_cv_itemlen.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 631
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_w_cookie'):
    bu_cv_w_cookie = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_w_cookie
    bu_cv_w_cookie.argtypes = [genptr_t, c_int, c_size_t, genptr_t, c_int, c_size_t]
    bu_cv_w_cookie.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 650
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_ntohss'):
    bu_cv_ntohss = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_ntohss
    bu_cv_ntohss.argtypes = [POINTER(c_short), c_size_t, genptr_t, c_size_t]
    bu_cv_ntohss.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 654
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_ntohus'):
    bu_cv_ntohus = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_ntohus
    bu_cv_ntohus.argtypes = [POINTER(c_ushort), c_size_t, genptr_t, c_size_t]
    bu_cv_ntohus.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 658
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_ntohsl'):
    bu_cv_ntohsl = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_ntohsl
    bu_cv_ntohsl.argtypes = [POINTER(c_long), c_size_t, genptr_t, c_size_t]
    bu_cv_ntohsl.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 662
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_ntohul'):
    bu_cv_ntohul = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_ntohul
    bu_cv_ntohul.argtypes = [POINTER(c_ulong), c_size_t, genptr_t, c_size_t]
    bu_cv_ntohul.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 666
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_htonss'):
    bu_cv_htonss = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_htonss
    bu_cv_htonss.argtypes = [genptr_t, c_size_t, POINTER(c_short), c_size_t]
    bu_cv_htonss.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 670
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_htonus'):
    bu_cv_htonus = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_htonus
    bu_cv_htonus.argtypes = [genptr_t, c_size_t, POINTER(c_ushort), c_size_t]
    bu_cv_htonus.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 674
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_htonsl'):
    bu_cv_htonsl = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_htonsl
    bu_cv_htonsl.argtypes = [genptr_t, c_size_t, POINTER(c_long), c_size_t]
    bu_cv_htonsl.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 678
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_cv_htonul'):
    bu_cv_htonul = _libs['/usr/brlcad/lib/libbu.so'].bu_cv_htonul
    bu_cv_htonul.argtypes = [genptr_t, c_size_t, POINTER(c_ulong), c_size_t]
    bu_cv_htonul.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 723
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_cv_htond'):
        continue
    bu_cv_htond = _lib.bu_cv_htond
    bu_cv_htond.argtypes = [POINTER(c_ubyte), POINTER(c_ubyte), c_size_t]
    bu_cv_htond.restype = None
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 730
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_cv_ntohd'):
        continue
    bu_cv_ntohd = _lib.bu_cv_ntohd
    bu_cv_ntohd.argtypes = [POINTER(c_ubyte), POINTER(c_ubyte), c_size_t]
    bu_cv_ntohd.restype = None
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 745
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_cv_htonf'):
        continue
    bu_cv_htonf = _lib.bu_cv_htonf
    bu_cv_htonf.argtypes = [POINTER(c_ubyte), POINTER(c_ubyte), c_size_t]
    bu_cv_htonf.restype = None
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 752
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_cv_ntohf'):
        continue
    bu_cv_ntohf = _lib.bu_cv_ntohf
    bu_cv_ntohf.argtypes = [POINTER(c_ubyte), POINTER(c_ubyte), c_size_t]
    bu_cv_ntohf.restype = None
    break

enum_anon_30 = c_int # /home/kanzure/local/brlcad/brlcad/include/bu.h: 768

BU_LITTLE_ENDIAN = 1234 # /home/kanzure/local/brlcad/brlcad/include/bu.h: 768

BU_BIG_ENDIAN = 4321 # /home/kanzure/local/brlcad/brlcad/include/bu.h: 768

BU_PDP_ENDIAN = 3412 # /home/kanzure/local/brlcad/brlcad/include/bu.h: 768

bu_endian_t = enum_anon_30 # /home/kanzure/local/brlcad/brlcad/include/bu.h: 768

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 774
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_byteorder'):
    bu_byteorder = _libs['/usr/brlcad/lib/libbu.so'].bu_byteorder
    bu_byteorder.argtypes = []
    bu_byteorder.restype = bu_endian_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 812
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_badmagic'):
    bu_badmagic = _libs['/usr/brlcad/lib/libbu.so'].bu_badmagic
    bu_badmagic.argtypes = [POINTER(c_uint32), c_uint32, String, String, c_int]
    bu_badmagic.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 824
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_identify_magic'):
    bu_identify_magic = _libs['/usr/brlcad/lib/libbu.so'].bu_identify_magic
    bu_identify_magic.argtypes = [c_uint32]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_identify_magic.restype = ReturnString
    else:
        bu_identify_magic.restype = String
        bu_identify_magic.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 912
class struct_bu_list(Structure):
    pass

struct_bu_list.__slots__ = [
    'magic',
    'forw',
    'back',
]
struct_bu_list._fields_ = [
    ('magic', c_uint32),
    ('forw', POINTER(struct_bu_list)),
    ('back', POINTER(struct_bu_list)),
]

bu_list_t = struct_bu_list # /home/kanzure/local/brlcad/brlcad/include/bu.h: 917

fastf_t = c_double # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1281

bitv_t = c_ubyte # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1391

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1437
class struct_bu_bitv(Structure):
    pass

struct_bu_bitv.__slots__ = [
    'l',
    'nbits',
    'bits',
]
struct_bu_bitv._fields_ = [
    ('l', struct_bu_list),
    ('nbits', c_size_t),
    ('bits', bitv_t * 2),
]

bu_bitv_t = struct_bu_bitv # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1442

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1478
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_shift'):
    bu_bitv_shift = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_shift
    bu_bitv_shift.argtypes = []
    bu_bitv_shift.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1607
class struct_bu_hist(Structure):
    pass

struct_bu_hist.__slots__ = [
    'magic',
    'hg_min',
    'hg_max',
    'hg_clumpsize',
    'hg_nsamples',
    'hg_nbins',
    'hg_bins',
]
struct_bu_hist._fields_ = [
    ('magic', c_uint32),
    ('hg_min', fastf_t),
    ('hg_max', fastf_t),
    ('hg_clumpsize', fastf_t),
    ('hg_nsamples', c_long),
    ('hg_nbins', c_long),
    ('hg_bins', POINTER(c_long)),
]

bu_hist_t = struct_bu_hist # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1616

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1691
class struct_bu_ptbl(Structure):
    pass

struct_bu_ptbl.__slots__ = [
    'l',
    'end',
    'blen',
    'buffer',
]
struct_bu_ptbl._fields_ = [
    ('l', struct_bu_list),
    ('end', off_t),
    ('blen', c_size_t),
    ('buffer', POINTER(POINTER(c_long))),
]

bu_ptbl_t = struct_bu_ptbl # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1697

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1807
class struct_bu_mapped_file(Structure):
    pass

struct_bu_mapped_file.__slots__ = [
    'l',
    'name',
    'buf',
    'buflen',
    'is_mapped',
    'appl',
    'apbuf',
    'apbuflen',
    'modtime',
    'uses',
    'dont_restat',
]
struct_bu_mapped_file._fields_ = [
    ('l', struct_bu_list),
    ('name', String),
    ('buf', genptr_t),
    ('buflen', c_size_t),
    ('is_mapped', c_int),
    ('appl', String),
    ('apbuf', genptr_t),
    ('apbuflen', c_size_t),
    ('modtime', time_t),
    ('uses', c_int),
    ('dont_restat', c_int),
]

bu_mapped_file_t = struct_bu_mapped_file # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1820

bu_hook_t = CFUNCTYPE(UNCHECKED(c_int), genptr_t, genptr_t) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1856

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1858
class struct_bu_hook_list(Structure):
    pass

struct_bu_hook_list.__slots__ = [
    'l',
    'hookfunc',
    'clientdata',
]
struct_bu_hook_list._fields_ = [
    ('l', struct_bu_list),
    ('hookfunc', bu_hook_t),
    ('clientdata', genptr_t),
]

bu_hook_list_t = struct_bu_hook_list # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1863

enum_anon_31 = c_int # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1908

BU_ATTR_CREATED = 0 # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1908

BU_ATTR_MODIFIED = (BU_ATTR_CREATED + 1) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1908

bu_attr_time_t = enum_anon_31 # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1908

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1914
class struct_bu_attribute_value_pair(Structure):
    pass

struct_bu_attribute_value_pair.__slots__ = [
    'name',
    'value',
]
struct_bu_attribute_value_pair._fields_ = [
    ('name', String),
    ('value', String),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1932
class struct_bu_attribute_value_set(Structure):
    pass

struct_bu_attribute_value_set.__slots__ = [
    'magic',
    'count',
    'max',
    'readonly_min',
    'readonly_max',
    'avp',
]
struct_bu_attribute_value_set._fields_ = [
    ('magic', c_uint32),
    ('count', c_uint),
    ('max', c_uint),
    ('readonly_min', genptr_t),
    ('readonly_max', genptr_t),
    ('avp', POINTER(struct_bu_attribute_value_pair)),
]

bu_avs_t = struct_bu_attribute_value_set # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1940

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2026
class struct_bu_vls(Structure):
    pass

struct_bu_vls.__slots__ = [
    'vls_magic',
    'vls_str',
    'vls_offset',
    'vls_len',
    'vls_max',
]
struct_bu_vls._fields_ = [
    ('vls_magic', c_uint32),
    ('vls_str', String),
    ('vls_offset', c_size_t),
    ('vls_len', c_size_t),
    ('vls_max', c_size_t),
]

bu_vls_t = struct_bu_vls # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2033

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2082
class struct_bu_vlb(Structure):
    pass

struct_bu_vlb.__slots__ = [
    'magic',
    'buf',
    'bufCapacity',
    'nextByte',
]
struct_bu_vlb._fields_ = [
    ('magic', c_uint32),
    ('buf', POINTER(c_ubyte)),
    ('bufCapacity', c_size_t),
    ('nextByte', c_size_t),
]

bu_vlb_t = struct_bu_vlb # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2088

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2131
try:
    bu_debug = (c_int).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_debug')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2278
class struct_bu_structparse(Structure):
    pass

struct_bu_structparse.__slots__ = [
    'sp_fmt',
    'sp_count',
    'sp_name',
    'sp_offset',
    'sp_hook',
    'sp_desc',
    'sp_default',
]
struct_bu_structparse._fields_ = [
    ('sp_fmt', c_char * 4),
    ('sp_count', c_size_t),
    ('sp_name', String),
    ('sp_offset', c_size_t),
    ('sp_hook', CFUNCTYPE(UNCHECKED(None), )),
    ('sp_desc', String),
    ('sp_default', POINTER(None)),
]

bu_structparse_t = struct_bu_structparse # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2287

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2335
class struct_bu_external(Structure):
    pass

struct_bu_external.__slots__ = [
    'ext_magic',
    'ext_nbytes',
    'ext_buf',
]
struct_bu_external._fields_ = [
    ('ext_magic', c_uint32),
    ('ext_nbytes', c_size_t),
    ('ext_buf', POINTER(c_uint8)),
]

bu_external_t = struct_bu_external # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2340

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2385
class struct_bu_color(Structure):
    pass

struct_bu_color.__slots__ = [
    'buc_magic',
    'buc_rgb',
]
struct_bu_color._fields_ = [
    ('buc_magic', c_uint32),
    ('buc_rgb', fastf_t * 3),
]

bu_color_t = struct_bu_color # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2390

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2584
class struct_bu_rb_node(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2568
class struct_bu_rb_package(Structure):
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2463
class union_anon_32(Union):
    pass

union_anon_32.__slots__ = [
    'rbl_n',
    'rbl_p',
]
union_anon_32._fields_ = [
    ('rbl_n', POINTER(struct_bu_rb_node)),
    ('rbl_p', POINTER(struct_bu_rb_package)),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2460
class struct_bu_rb_list(Structure):
    pass

struct_bu_rb_list.__slots__ = [
    'l',
    'rbl_u',
]
struct_bu_rb_list._fields_ = [
    ('l', struct_bu_list),
    ('rbl_u', union_anon_32),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2489
class struct_bu_rb_tree(Structure):
    pass

struct_bu_rb_tree.__slots__ = [
    'rbt_magic',
    'rbt_nm_nodes',
    'rbt_print',
    'rbt_debug',
    'rbt_description',
    'rbt_nm_orders',
    'rbt_order',
    'rbt_root',
    'rbt_unique',
    'rbt_current',
    'rbt_nodes',
    'rbt_packages',
    'rbt_empty_node',
]
struct_bu_rb_tree._fields_ = [
    ('rbt_magic', c_uint32),
    ('rbt_nm_nodes', c_int),
    ('rbt_print', CFUNCTYPE(UNCHECKED(None), POINTER(None))),
    ('rbt_debug', c_int),
    ('rbt_description', String),
    ('rbt_nm_orders', c_int),
    ('rbt_order', POINTER(CFUNCTYPE(UNCHECKED(c_int), ))),
    ('rbt_root', POINTER(POINTER(struct_bu_rb_node))),
    ('rbt_unique', String),
    ('rbt_current', POINTER(struct_bu_rb_node)),
    ('rbt_nodes', struct_bu_rb_list),
    ('rbt_packages', struct_bu_rb_list),
    ('rbt_empty_node', POINTER(struct_bu_rb_node)),
]

bu_rb_tree_t = struct_bu_rb_tree # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2509

struct_bu_rb_package.__slots__ = [
    'rbp_magic',
    'rbp_node',
    'rbp_list_pos',
    'rbp_data',
]
struct_bu_rb_package._fields_ = [
    ('rbp_magic', c_uint32),
    ('rbp_node', POINTER(POINTER(struct_bu_rb_node))),
    ('rbp_list_pos', POINTER(struct_bu_rb_list)),
    ('rbp_data', POINTER(None)),
]

struct_bu_rb_node.__slots__ = [
    'rbn_magic',
    'rbn_tree',
    'rbn_parent',
    'rbn_left',
    'rbn_right',
    'rbn_color',
    'rbn_size',
    'rbn_package',
    'rbn_pkg_refs',
    'rbn_list_pos',
]
struct_bu_rb_node._fields_ = [
    ('rbn_magic', c_uint32),
    ('rbn_tree', POINTER(struct_bu_rb_tree)),
    ('rbn_parent', POINTER(POINTER(struct_bu_rb_node))),
    ('rbn_left', POINTER(POINTER(struct_bu_rb_node))),
    ('rbn_right', POINTER(POINTER(struct_bu_rb_node))),
    ('rbn_color', String),
    ('rbn_size', POINTER(c_int)),
    ('rbn_package', POINTER(POINTER(struct_bu_rb_package))),
    ('rbn_pkg_refs', c_int),
    ('rbn_list_pos', POINTER(struct_bu_rb_list)),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2620
class struct_bu_observer(Structure):
    pass

struct_bu_observer.__slots__ = [
    'l',
    'observer',
    'cmd',
]
struct_bu_observer._fields_ = [
    ('l', struct_bu_list),
    ('observer', struct_bu_vls),
    ('cmd', struct_bu_vls),
]

bu_observer_t = struct_bu_observer # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2625

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2660
class struct_bu_cmdtab(Structure):
    pass

struct_bu_cmdtab.__slots__ = [
    'ct_name',
    'ct_func',
]
struct_bu_cmdtab._fields_ = [
    ('ct_name', String),
    ('ct_func', CFUNCTYPE(UNCHECKED(c_int), POINTER(None), c_int, POINTER(POINTER(c_char)))),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2677
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_init'):
    bu_avs_init = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_init
    bu_avs_init.argtypes = [POINTER(struct_bu_attribute_value_set), c_int, String]
    bu_avs_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2684
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_init_empty'):
    bu_avs_init_empty = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_init_empty
    bu_avs_init_empty.argtypes = [POINTER(struct_bu_attribute_value_set)]
    bu_avs_init_empty.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2690
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_new'):
    bu_avs_new = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_new
    bu_avs_new.argtypes = [c_int, String]
    bu_avs_new.restype = POINTER(struct_bu_attribute_value_set)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2703
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_add'):
    bu_avs_add = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_add
    bu_avs_add.argtypes = [POINTER(struct_bu_attribute_value_set), String, String]
    bu_avs_add.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2710
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_add_vls'):
    bu_avs_add_vls = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_add_vls
    bu_avs_add_vls.argtypes = [POINTER(struct_bu_attribute_value_set), String, POINTER(struct_bu_vls)]
    bu_avs_add_vls.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2718
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_merge'):
    bu_avs_merge = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_merge
    bu_avs_merge.argtypes = [POINTER(struct_bu_attribute_value_set), POINTER(struct_bu_attribute_value_set)]
    bu_avs_merge.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2724
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_get'):
    bu_avs_get = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_get
    bu_avs_get.argtypes = [POINTER(struct_bu_attribute_value_set), String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_avs_get.restype = ReturnString
    else:
        bu_avs_get.restype = String
        bu_avs_get.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2735
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_remove'):
    bu_avs_remove = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_remove
    bu_avs_remove.argtypes = [POINTER(struct_bu_attribute_value_set), String]
    bu_avs_remove.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2741
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_free'):
    bu_avs_free = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_free
    bu_avs_free.argtypes = [POINTER(struct_bu_attribute_value_set)]
    bu_avs_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2747
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_print'):
    bu_avs_print = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_print
    bu_avs_print.argtypes = [POINTER(struct_bu_attribute_value_set), String]
    bu_avs_print.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2753
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avs_add_nonunique'):
    bu_avs_add_nonunique = _libs['/usr/brlcad/lib/libbu.so'].bu_avs_add_nonunique
    bu_avs_add_nonunique.argtypes = [POINTER(struct_bu_attribute_value_set), String, String]
    bu_avs_add_nonunique.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2767
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_new'):
    bu_bitv_new = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_new
    bu_bitv_new.argtypes = [c_size_t]
    bu_bitv_new.restype = POINTER(struct_bu_bitv)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2776
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_free'):
    bu_bitv_free = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_free
    bu_bitv_free.argtypes = [POINTER(struct_bu_bitv)]
    bu_bitv_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2784
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_clear'):
    bu_bitv_clear = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_clear
    bu_bitv_clear.argtypes = [POINTER(struct_bu_bitv)]
    bu_bitv_clear.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2789
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_or'):
    bu_bitv_or = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_or
    bu_bitv_or.argtypes = [POINTER(struct_bu_bitv), POINTER(struct_bu_bitv)]
    bu_bitv_or.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2794
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_and'):
    bu_bitv_and = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_and
    bu_bitv_and.argtypes = [POINTER(struct_bu_bitv), POINTER(struct_bu_bitv)]
    bu_bitv_and.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2799
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_vls'):
    bu_bitv_vls = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_vls
    bu_bitv_vls.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_bitv)]
    bu_bitv_vls.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2805
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_pr_bitv'):
    bu_pr_bitv = _libs['/usr/brlcad/lib/libbu.so'].bu_pr_bitv
    bu_pr_bitv.argtypes = [String, POINTER(struct_bu_bitv)]
    bu_pr_bitv.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2811
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_to_hex'):
    bu_bitv_to_hex = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_to_hex
    bu_bitv_to_hex.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_bitv)]
    bu_bitv_to_hex.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2817
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hex_to_bitv'):
    bu_hex_to_bitv = _libs['/usr/brlcad/lib/libbu.so'].bu_hex_to_bitv
    bu_hex_to_bitv.argtypes = [String]
    bu_hex_to_bitv.restype = POINTER(struct_bu_bitv)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2822
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bitv_dup'):
    bu_bitv_dup = _libs['/usr/brlcad/lib/libbu.so'].bu_bitv_dup
    bu_bitv_dup.argtypes = [POINTER(struct_bu_bitv)]
    bu_bitv_dup.restype = POINTER(struct_bu_bitv)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2851
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_backtrace'):
    bu_backtrace = _libs['/usr/brlcad/lib/libbu.so'].bu_backtrace
    bu_backtrace.argtypes = [POINTER(FILE)]
    bu_backtrace.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2861
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bomb_add_hook'):
    bu_bomb_add_hook = _libs['/usr/brlcad/lib/libbu.so'].bu_bomb_add_hook
    bu_bomb_add_hook.argtypes = [bu_hook_t, genptr_t]
    bu_bomb_add_hook.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2897
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_bomb'):
    bu_bomb = _libs['/usr/brlcad/lib/libbu.so'].bu_bomb
    bu_bomb.argtypes = [String]
    bu_bomb.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2911
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_exit'):
    _func = _libs['/usr/brlcad/lib/libbu.so'].bu_exit
    _restype = None
    _argtypes = [c_int, String]
    bu_exit = _variadic_function(_func,_restype,_argtypes)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2930
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_crashreport'):
    bu_crashreport = _libs['/usr/brlcad/lib/libbu.so'].bu_crashreport
    bu_crashreport.argtypes = [String]
    bu_crashreport.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2947
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_fgets'):
    bu_fgets = _libs['/usr/brlcad/lib/libbu.so'].bu_fgets
    bu_fgets.argtypes = [String, c_int, POINTER(FILE)]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_fgets.restype = ReturnString
    else:
        bu_fgets.restype = String
        bu_fgets.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2970
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rgb_to_hsv'):
    bu_rgb_to_hsv = _libs['/usr/brlcad/lib/libbu.so'].bu_rgb_to_hsv
    bu_rgb_to_hsv.argtypes = [POINTER(c_ubyte), POINTER(fastf_t)]
    bu_rgb_to_hsv.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2971
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hsv_to_rgb'):
    bu_hsv_to_rgb = _libs['/usr/brlcad/lib/libbu.so'].bu_hsv_to_rgb
    bu_hsv_to_rgb.argtypes = [POINTER(fastf_t), POINTER(c_ubyte)]
    bu_hsv_to_rgb.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2972
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_str_to_rgb'):
    bu_str_to_rgb = _libs['/usr/brlcad/lib/libbu.so'].bu_str_to_rgb
    bu_str_to_rgb.argtypes = [String, POINTER(c_ubyte)]
    bu_str_to_rgb.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2973
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_color_from_rgb_floats'):
    bu_color_from_rgb_floats = _libs['/usr/brlcad/lib/libbu.so'].bu_color_from_rgb_floats
    bu_color_from_rgb_floats.argtypes = [POINTER(struct_bu_color), POINTER(fastf_t)]
    bu_color_from_rgb_floats.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2974
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_color_to_rgb_floats'):
    bu_color_to_rgb_floats = _libs['/usr/brlcad/lib/libbu.so'].bu_color_to_rgb_floats
    bu_color_to_rgb_floats.argtypes = [POINTER(struct_bu_color), POINTER(fastf_t)]
    bu_color_to_rgb_floats.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3007
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_exists'):
    bu_file_exists = _libs['/usr/brlcad/lib/libbu.so'].bu_file_exists
    bu_file_exists.argtypes = [String, POINTER(c_int)]
    bu_file_exists.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3015
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_same_file'):
    bu_same_file = _libs['/usr/brlcad/lib/libbu.so'].bu_same_file
    bu_same_file.argtypes = [String, String]
    bu_same_file.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3022
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_same_fd'):
    bu_same_fd = _libs['/usr/brlcad/lib/libbu.so'].bu_same_fd
    bu_same_fd.argtypes = [c_int, c_int]
    bu_same_fd.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3028
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_readable'):
    bu_file_readable = _libs['/usr/brlcad/lib/libbu.so'].bu_file_readable
    bu_file_readable.argtypes = [String]
    bu_file_readable.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3034
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_writable'):
    bu_file_writable = _libs['/usr/brlcad/lib/libbu.so'].bu_file_writable
    bu_file_writable.argtypes = [String]
    bu_file_writable.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3040
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_executable'):
    bu_file_executable = _libs['/usr/brlcad/lib/libbu.so'].bu_file_executable
    bu_file_executable.argtypes = [String]
    bu_file_executable.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3050
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_directory'):
    bu_file_directory = _libs['/usr/brlcad/lib/libbu.so'].bu_file_directory
    bu_file_directory.argtypes = [String]
    bu_file_directory.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3060
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_symbolic'):
    bu_file_symbolic = _libs['/usr/brlcad/lib/libbu.so'].bu_file_symbolic
    bu_file_symbolic.argtypes = [String]
    bu_file_symbolic.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3069
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_file_delete'):
    bu_file_delete = _libs['/usr/brlcad/lib/libbu.so'].bu_file_delete
    bu_file_delete.argtypes = [String]
    bu_file_delete.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3095
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_file_glob'):
        continue
    bu_file_glob = _lib.bu_file_glob
    bu_file_glob.argtypes = [String, POINTER(POINTER(POINTER(c_char)))]
    bu_file_glob.restype = c_size_t
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3104
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_file_path_canonicalize'):
        continue
    bu_file_path_canonicalize = _lib.bu_file_path_canonicalize
    bu_file_path_canonicalize.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_file_path_canonicalize.restype = ReturnString
    else:
        bu_file_path_canonicalize.restype = String
        bu_file_path_canonicalize.errcheck = ReturnString
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3128
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_fnmatch'):
    bu_fnmatch = _libs['/usr/brlcad/lib/libbu.so'].bu_fnmatch
    bu_fnmatch.argtypes = [String, String, c_int]
    bu_fnmatch.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3146
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dir_list'):
    bu_dir_list = _libs['/usr/brlcad/lib/libbu.so'].bu_dir_list
    bu_dir_list.argtypes = [String, String, POINTER(POINTER(POINTER(c_char)))]
    bu_dir_list.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3162
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_realpath'):
    bu_realpath = _libs['/usr/brlcad/lib/libbu.so'].bu_realpath
    bu_realpath.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_realpath.restype = ReturnString
    else:
        bu_realpath.restype = String
        bu_realpath.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3185
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_argv0'):
    bu_argv0 = _libs['/usr/brlcad/lib/libbu.so'].bu_argv0
    bu_argv0.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        bu_argv0.restype = ReturnString
    else:
        bu_argv0.restype = String
        bu_argv0.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3198
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_argv0_full_path'):
    bu_argv0_full_path = _libs['/usr/brlcad/lib/libbu.so'].bu_argv0_full_path
    bu_argv0_full_path.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        bu_argv0_full_path.restype = ReturnString
    else:
        bu_argv0_full_path.restype = String
        bu_argv0_full_path.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3205
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_getprogname'):
    bu_getprogname = _libs['/usr/brlcad/lib/libbu.so'].bu_getprogname
    bu_getprogname.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        bu_getprogname.restype = ReturnString
    else:
        bu_getprogname.restype = String
        bu_getprogname.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3212
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_setprogname'):
    bu_setprogname = _libs['/usr/brlcad/lib/libbu.so'].bu_setprogname
    bu_setprogname.argtypes = [String]
    bu_setprogname.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3218
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_getcwd'):
    bu_getcwd = _libs['/usr/brlcad/lib/libbu.so'].bu_getcwd
    bu_getcwd.argtypes = [String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_getcwd.restype = ReturnString
    else:
        bu_getcwd.restype = String
        bu_getcwd.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3239
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_brlcad_dir'):
    bu_brlcad_dir = _libs['/usr/brlcad/lib/libbu.so'].bu_brlcad_dir
    bu_brlcad_dir.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_brlcad_dir.restype = ReturnString
    else:
        bu_brlcad_dir.restype = String
        bu_brlcad_dir.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3259
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_brlcad_root'):
    bu_brlcad_root = _libs['/usr/brlcad/lib/libbu.so'].bu_brlcad_root
    bu_brlcad_root.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_brlcad_root.restype = ReturnString
    else:
        bu_brlcad_root.restype = String
        bu_brlcad_root.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3278
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_brlcad_data'):
    bu_brlcad_data = _libs['/usr/brlcad/lib/libbu.so'].bu_brlcad_data
    bu_brlcad_data.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_brlcad_data.restype = ReturnString
    else:
        bu_brlcad_data.restype = String
        bu_brlcad_data.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3293
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_which'):
    bu_which = _libs['/usr/brlcad/lib/libbu.so'].bu_which
    bu_which.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_which.restype = ReturnString
    else:
        bu_which.restype = String
        bu_which.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3308
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_whereis'):
    bu_whereis = _libs['/usr/brlcad/lib/libbu.so'].bu_whereis
    bu_whereis.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_whereis.restype = ReturnString
    else:
        bu_whereis.restype = String
        bu_whereis.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3350
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_temp_file'):
    bu_temp_file = _libs['/usr/brlcad/lib/libbu.so'].bu_temp_file
    bu_temp_file.argtypes = [String, c_size_t]
    bu_temp_file.restype = POINTER(FILE)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3374
try:
    bu_opterr = (c_int).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_opterr')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3379
try:
    bu_optind = (c_int).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_optind')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3384
try:
    bu_optopt = (c_int).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_optopt')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3389
try:
    bu_optarg = (String).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_optarg')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3402
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_getopt'):
    bu_getopt = _libs['/usr/brlcad/lib/libbu.so'].bu_getopt
    bu_getopt.argtypes = [c_int, POINTER(POINTER(c_char)), String]
    bu_getopt.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3414
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hist_free'):
    bu_hist_free = _libs['/usr/brlcad/lib/libbu.so'].bu_hist_free
    bu_hist_free.argtypes = [POINTER(struct_bu_hist)]
    bu_hist_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3421
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hist_init'):
    bu_hist_init = _libs['/usr/brlcad/lib/libbu.so'].bu_hist_init
    bu_hist_init.argtypes = [POINTER(struct_bu_hist), fastf_t, fastf_t, c_uint]
    bu_hist_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3425
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hist_range'):
    bu_hist_range = _libs['/usr/brlcad/lib/libbu.so'].bu_hist_range
    bu_hist_range.argtypes = [POINTER(struct_bu_hist), fastf_t, fastf_t]
    bu_hist_range.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3430
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hist_pr'):
    bu_hist_pr = _libs['/usr/brlcad/lib/libbu.so'].bu_hist_pr
    bu_hist_pr.argtypes = [POINTER(struct_bu_hist), String]
    bu_hist_pr.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3454
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_is_parallel'):
    bu_is_parallel = _libs['/usr/brlcad/lib/libbu.so'].bu_is_parallel
    bu_is_parallel.argtypes = []
    bu_is_parallel.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3460
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_kill_parallel'):
    bu_kill_parallel = _libs['/usr/brlcad/lib/libbu.so'].bu_kill_parallel
    bu_kill_parallel.argtypes = []
    bu_kill_parallel.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3465
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_parallel_id'):
    bu_parallel_id = _libs['/usr/brlcad/lib/libbu.so'].bu_parallel_id
    bu_parallel_id.argtypes = []
    bu_parallel_id.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3479
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_setlinebuf'):
    bu_setlinebuf = _libs['/usr/brlcad/lib/libbu.so'].bu_setlinebuf
    bu_setlinebuf.argtypes = [POINTER(FILE)]
    bu_setlinebuf.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3490
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_new'):
    bu_list_new = _libs['/usr/brlcad/lib/libbu.so'].bu_list_new
    bu_list_new.argtypes = []
    bu_list_new.restype = POINTER(struct_bu_list)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3495
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_pop'):
    bu_list_pop = _libs['/usr/brlcad/lib/libbu.so'].bu_list_pop
    bu_list_pop.argtypes = [POINTER(struct_bu_list)]
    bu_list_pop.restype = POINTER(struct_bu_list)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3500
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_len'):
    bu_list_len = _libs['/usr/brlcad/lib/libbu.so'].bu_list_len
    bu_list_len.argtypes = [POINTER(struct_bu_list)]
    bu_list_len.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3505
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_reverse'):
    bu_list_reverse = _libs['/usr/brlcad/lib/libbu.so'].bu_list_reverse
    bu_list_reverse.argtypes = [POINTER(struct_bu_list)]
    bu_list_reverse.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3513
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_free'):
    bu_list_free = _libs['/usr/brlcad/lib/libbu.so'].bu_list_free
    bu_list_free.argtypes = [POINTER(struct_bu_list)]
    bu_list_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3523
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_parallel_append'):
    bu_list_parallel_append = _libs['/usr/brlcad/lib/libbu.so'].bu_list_parallel_append
    bu_list_parallel_append.argtypes = [POINTER(struct_bu_list), POINTER(struct_bu_list)]
    bu_list_parallel_append.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3536
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_list_parallel_dequeue'):
    bu_list_parallel_dequeue = _libs['/usr/brlcad/lib/libbu.so'].bu_list_parallel_dequeue
    bu_list_parallel_dequeue.argtypes = [POINTER(struct_bu_list)]
    bu_list_parallel_dequeue.restype = POINTER(struct_bu_list)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3541
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ck_list'):
    bu_ck_list = _libs['/usr/brlcad/lib/libbu.so'].bu_ck_list
    bu_ck_list.argtypes = [POINTER(struct_bu_list), String]
    bu_ck_list.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3548
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ck_list_magic'):
    bu_ck_list_magic = _libs['/usr/brlcad/lib/libbu.so'].bu_ck_list_magic
    bu_ck_list_magic.argtypes = [POINTER(struct_bu_list), String, c_uint32]
    bu_ck_list_magic.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3563
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_list_init'):
    bu_hook_list_init = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_list_init
    bu_hook_list_init.argtypes = [POINTER(struct_bu_hook_list)]
    bu_hook_list_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3564
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_add'):
    bu_hook_add = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_add
    bu_hook_add.argtypes = [POINTER(struct_bu_hook_list), bu_hook_t, genptr_t]
    bu_hook_add.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3567
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_delete'):
    bu_hook_delete = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_delete
    bu_hook_delete.argtypes = [POINTER(struct_bu_hook_list), bu_hook_t, genptr_t]
    bu_hook_delete.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3570
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_call'):
    bu_hook_call = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_call
    bu_hook_call.argtypes = [POINTER(struct_bu_hook_list), genptr_t]
    bu_hook_call.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3572
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_save_all'):
    bu_hook_save_all = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_save_all
    bu_hook_save_all.argtypes = [POINTER(struct_bu_hook_list), POINTER(struct_bu_hook_list)]
    bu_hook_save_all.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3574
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_delete_all'):
    bu_hook_delete_all = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_delete_all
    bu_hook_delete_all.argtypes = [POINTER(struct_bu_hook_list)]
    bu_hook_delete_all.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3575
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hook_restore_all'):
    bu_hook_restore_all = _libs['/usr/brlcad/lib/libbu.so'].bu_hook_restore_all
    bu_hook_restore_all.argtypes = [POINTER(struct_bu_hook_list), POINTER(struct_bu_hook_list)]
    bu_hook_restore_all.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3628
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_indent_delta'):
    bu_log_indent_delta = _libs['/usr/brlcad/lib/libbu.so'].bu_log_indent_delta
    bu_log_indent_delta.argtypes = [c_int]
    bu_log_indent_delta.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3635
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_indent_vls'):
    bu_log_indent_vls = _libs['/usr/brlcad/lib/libbu.so'].bu_log_indent_vls
    bu_log_indent_vls.argtypes = [POINTER(struct_bu_vls)]
    bu_log_indent_vls.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3645
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_add_hook'):
    bu_log_add_hook = _libs['/usr/brlcad/lib/libbu.so'].bu_log_add_hook
    bu_log_add_hook.argtypes = [bu_hook_t, genptr_t]
    bu_log_add_hook.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3651
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_delete_hook'):
    bu_log_delete_hook = _libs['/usr/brlcad/lib/libbu.so'].bu_log_delete_hook
    bu_log_delete_hook.argtypes = [bu_hook_t, genptr_t]
    bu_log_delete_hook.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3653
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_hook_save_all'):
    bu_log_hook_save_all = _libs['/usr/brlcad/lib/libbu.so'].bu_log_hook_save_all
    bu_log_hook_save_all.argtypes = [POINTER(struct_bu_hook_list)]
    bu_log_hook_save_all.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3654
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_hook_delete_all'):
    bu_log_hook_delete_all = _libs['/usr/brlcad/lib/libbu.so'].bu_log_hook_delete_all
    bu_log_hook_delete_all.argtypes = []
    bu_log_hook_delete_all.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3655
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log_hook_restore_all'):
    bu_log_hook_restore_all = _libs['/usr/brlcad/lib/libbu.so'].bu_log_hook_restore_all
    bu_log_hook_restore_all.argtypes = [POINTER(struct_bu_hook_list)]
    bu_log_hook_restore_all.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3660
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_putchar'):
    bu_putchar = _libs['/usr/brlcad/lib/libbu.so'].bu_putchar
    bu_putchar.argtypes = [c_int]
    bu_putchar.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3673
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_log'):
    _func = _libs['/usr/brlcad/lib/libbu.so'].bu_log
    _restype = None
    _argtypes = [String]
    bu_log = _variadic_function(_func,_restype,_argtypes)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3679
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_flog'):
    _func = _libs['/usr/brlcad/lib/libbu.so'].bu_flog
    _restype = None
    _argtypes = [POINTER(FILE), String]
    bu_flog = _variadic_function(_func,_restype,_argtypes)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3715
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vsscanf'):
    bu_vsscanf = _libs['/usr/brlcad/lib/libbu.so'].bu_vsscanf
    bu_vsscanf.argtypes = [String, String, c_void_p]
    bu_vsscanf.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3723
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_sscanf'):
    _func = _libs['/usr/brlcad/lib/libbu.so'].bu_sscanf
    _restype = c_int
    _argtypes = [String, String]
    bu_sscanf = _variadic_function(_func,_restype,_argtypes)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3745
try:
    bu_n_malloc = (c_long).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_n_malloc')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3746
try:
    bu_n_free = (c_long).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_n_free')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3747
try:
    bu_n_realloc = (c_long).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_n_realloc')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3754
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_malloc'):
    bu_malloc = _libs['/usr/brlcad/lib/libbu.so'].bu_malloc
    bu_malloc.argtypes = [c_size_t, String]
    bu_malloc.restype = genptr_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3762
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_calloc'):
    bu_calloc = _libs['/usr/brlcad/lib/libbu.so'].bu_calloc
    bu_calloc.argtypes = [c_size_t, c_size_t, String]
    bu_calloc.restype = genptr_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3768
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_free'):
    bu_free = _libs['/usr/brlcad/lib/libbu.so'].bu_free
    bu_free.argtypes = [genptr_t, String]
    bu_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3783
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_realloc'):
    bu_realloc = _libs['/usr/brlcad/lib/libbu.so'].bu_realloc
    bu_realloc.argtypes = [genptr_t, c_size_t, String]
    bu_realloc.restype = genptr_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3790
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_prmem'):
    bu_prmem = _libs['/usr/brlcad/lib/libbu.so'].bu_prmem
    bu_prmem.argtypes = [String]
    bu_prmem.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3807
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_malloc_len_roundup'):
    bu_malloc_len_roundup = _libs['/usr/brlcad/lib/libbu.so'].bu_malloc_len_roundup
    bu_malloc_len_roundup.argtypes = [c_int]
    bu_malloc_len_roundup.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3819
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ck_malloc_ptr'):
    bu_ck_malloc_ptr = _libs['/usr/brlcad/lib/libbu.so'].bu_ck_malloc_ptr
    bu_ck_malloc_ptr.argtypes = [genptr_t, String]
    bu_ck_malloc_ptr.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3833
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_mem_barriercheck'):
    bu_mem_barriercheck = _libs['/usr/brlcad/lib/libbu.so'].bu_mem_barriercheck
    bu_mem_barriercheck.argtypes = []
    bu_mem_barriercheck.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3846
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_heap_get'):
    bu_heap_get = _libs['/usr/brlcad/lib/libbu.so'].bu_heap_get
    bu_heap_get.argtypes = [c_size_t]
    bu_heap_get.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3856
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_heap_put'):
    bu_heap_put = _libs['/usr/brlcad/lib/libbu.so'].bu_heap_put
    bu_heap_put.argtypes = [POINTER(None), c_size_t]
    bu_heap_put.restype = None

bu_heap_func_t = CFUNCTYPE(UNCHECKED(c_int), String) # /home/kanzure/local/brlcad/brlcad/include/bu.h: 3862

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3872
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_heap_log'):
        continue
    bu_heap_log = _lib.bu_heap_log
    bu_heap_log.argtypes = [bu_heap_func_t]
    bu_heap_log.restype = bu_heap_func_t
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3921
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dirname'):
    bu_dirname = _libs['/usr/brlcad/lib/libbu.so'].bu_dirname
    bu_dirname.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_dirname.restype = ReturnString
    else:
        bu_dirname.restype = String
        bu_dirname.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3953
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_basename'):
    bu_basename = _libs['/usr/brlcad/lib/libbu.so'].bu_basename
    bu_basename.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_basename.restype = ReturnString
    else:
        bu_basename.restype = String
        bu_basename.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3976
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_open_mapped_file'):
    bu_open_mapped_file = _libs['/usr/brlcad/lib/libbu.so'].bu_open_mapped_file
    bu_open_mapped_file.argtypes = [String, String]
    bu_open_mapped_file.restype = POINTER(struct_bu_mapped_file)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3989
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_close_mapped_file'):
    bu_close_mapped_file = _libs['/usr/brlcad/lib/libbu.so'].bu_close_mapped_file
    bu_close_mapped_file.argtypes = [POINTER(struct_bu_mapped_file)]
    bu_close_mapped_file.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3993
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_pr_mapped_file'):
    bu_pr_mapped_file = _libs['/usr/brlcad/lib/libbu.so'].bu_pr_mapped_file
    bu_pr_mapped_file.argtypes = [String, POINTER(struct_bu_mapped_file)]
    bu_pr_mapped_file.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4003
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_free_mapped_files'):
    bu_free_mapped_files = _libs['/usr/brlcad/lib/libbu.so'].bu_free_mapped_files
    bu_free_mapped_files.argtypes = [c_int]
    bu_free_mapped_files.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4013
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_open_mapped_file_with_path'):
    bu_open_mapped_file_with_path = _libs['/usr/brlcad/lib/libbu.so'].bu_open_mapped_file_with_path
    bu_open_mapped_file_with_path.argtypes = [POINTER(POINTER(c_char)), String, String]
    bu_open_mapped_file_with_path.restype = POINTER(struct_bu_mapped_file)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4034
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_terminate'):
    bu_terminate = _libs['/usr/brlcad/lib/libbu.so'].bu_terminate
    bu_terminate.argtypes = [c_int]
    bu_terminate.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4045
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_process_id'):
    bu_process_id = _libs['/usr/brlcad/lib/libbu.so'].bu_process_id
    bu_process_id.argtypes = []
    bu_process_id.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4060
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_nice_set'):
    bu_nice_set = _libs['/usr/brlcad/lib/libbu.so'].bu_nice_set
    bu_nice_set.argtypes = [c_int]
    bu_nice_set.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4066
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_avail_cpus'):
    bu_avail_cpus = _libs['/usr/brlcad/lib/libbu.so'].bu_avail_cpus
    bu_avail_cpus.argtypes = []
    bu_avail_cpus.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4085
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_parallel'):
    bu_parallel = _libs['/usr/brlcad/lib/libbu.so'].bu_parallel
    bu_parallel.argtypes = [CFUNCTYPE(UNCHECKED(None), c_int, genptr_t), c_int, genptr_t]
    bu_parallel.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4113
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_parse'):
    bu_struct_parse = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_parse
    bu_struct_parse.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_structparse), String]
    bu_struct_parse.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4120
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_print'):
    bu_struct_print = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_print
    bu_struct_print.argtypes = [String, POINTER(struct_bu_structparse), String]
    bu_struct_print.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4129
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_export'):
    bu_struct_export = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_export
    bu_struct_export.argtypes = [POINTER(struct_bu_external), genptr_t, POINTER(struct_bu_structparse)]
    bu_struct_export.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4138
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_import'):
    bu_struct_import = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_import
    bu_struct_import.argtypes = [genptr_t, POINTER(struct_bu_structparse), POINTER(struct_bu_external)]
    bu_struct_import.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4150
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_put'):
    bu_struct_put = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_put
    bu_struct_put.argtypes = [POINTER(FILE), POINTER(struct_bu_external)]
    bu_struct_put.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4159
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_get'):
    bu_struct_get = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_get
    bu_struct_get.argtypes = [POINTER(struct_bu_external), POINTER(FILE)]
    bu_struct_get.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4168
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_struct_wrap_buf'):
    bu_struct_wrap_buf = _libs['/usr/brlcad/lib/libbu.so'].bu_struct_wrap_buf
    bu_struct_wrap_buf.argtypes = [POINTER(struct_bu_external), genptr_t]
    bu_struct_wrap_buf.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4175
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_struct_print'):
    bu_vls_struct_print = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_struct_print
    bu_vls_struct_print.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_structparse), String]
    bu_vls_struct_print.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4182
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_struct_print2'):
    bu_vls_struct_print2 = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_struct_print2
    bu_vls_struct_print2.argtypes = [POINTER(struct_bu_vls), String, POINTER(struct_bu_structparse), String]
    bu_vls_struct_print2.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4191
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_struct_item'):
    bu_vls_struct_item = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_struct_item
    bu_vls_struct_item.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_structparse), String, c_int]
    bu_vls_struct_item.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4200
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_struct_item_named'):
    bu_vls_struct_item_named = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_struct_item_named
    bu_vls_struct_item_named.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_structparse), String, String, c_int]
    bu_vls_struct_item_named.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4210
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_parse_mm'):
    bu_parse_mm = _libs['/usr/brlcad/lib/libbu.so'].bu_parse_mm
    bu_parse_mm.argtypes = [POINTER(struct_bu_structparse), String, String, String]
    bu_parse_mm.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4217
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_key_eq_to_key_val'):
    bu_key_eq_to_key_val = _libs['/usr/brlcad/lib/libbu.so'].bu_key_eq_to_key_val
    bu_key_eq_to_key_val.argtypes = [String, POINTER(POINTER(c_char)), POINTER(struct_bu_vls)]
    bu_key_eq_to_key_val.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4238
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_shader_to_list'):
    bu_shader_to_list = _libs['/usr/brlcad/lib/libbu.so'].bu_shader_to_list
    bu_shader_to_list.argtypes = [String, POINTER(struct_bu_vls)]
    bu_shader_to_list.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4243
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_shader_to_key_eq'):
    bu_shader_to_key_eq = _libs['/usr/brlcad/lib/libbu.so'].bu_shader_to_key_eq
    bu_shader_to_key_eq.argtypes = [String, POINTER(struct_bu_vls)]
    bu_shader_to_key_eq.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4254
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_fwrite_external'):
    bu_fwrite_external = _libs['/usr/brlcad/lib/libbu.so'].bu_fwrite_external
    bu_fwrite_external.argtypes = [POINTER(FILE), POINTER(struct_bu_external)]
    bu_fwrite_external.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4259
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hexdump_external'):
    bu_hexdump_external = _libs['/usr/brlcad/lib/libbu.so'].bu_hexdump_external
    bu_hexdump_external.argtypes = [POINTER(FILE), POINTER(struct_bu_external), String]
    bu_hexdump_external.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4264
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_free_external'):
    bu_free_external = _libs['/usr/brlcad/lib/libbu.so'].bu_free_external
    bu_free_external.argtypes = [POINTER(struct_bu_external)]
    bu_free_external.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4268
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_copy_external'):
    bu_copy_external = _libs['/usr/brlcad/lib/libbu.so'].bu_copy_external
    bu_copy_external.argtypes = [POINTER(struct_bu_external), POINTER(struct_bu_external)]
    bu_copy_external.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4275
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_next_token'):
    bu_next_token = _libs['/usr/brlcad/lib/libbu.so'].bu_next_token
    bu_next_token.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_next_token.restype = ReturnString
    else:
        bu_next_token.restype = String
        bu_next_token.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4280
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_structparse_get_terse_form'):
    bu_structparse_get_terse_form = _libs['/usr/brlcad/lib/libbu.so'].bu_structparse_get_terse_form
    bu_structparse_get_terse_form.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_structparse)]
    bu_structparse_get_terse_form.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4300
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_structparse_argv'):
    bu_structparse_argv = _libs['/usr/brlcad/lib/libbu.so'].bu_structparse_argv
    bu_structparse_argv.argtypes = [POINTER(struct_bu_vls), c_int, POINTER(POINTER(c_char)), POINTER(struct_bu_structparse), String]
    bu_structparse_argv.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4331
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_str_true'):
    bu_str_true = _libs['/usr/brlcad/lib/libbu.so'].bu_str_true
    bu_str_true.argtypes = [String]
    bu_str_true.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4341
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_str_false'):
    bu_str_false = _libs['/usr/brlcad/lib/libbu.so'].bu_str_false
    bu_str_false.argtypes = [String]
    bu_str_false.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4367
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_printb'):
    bu_vls_printb = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_printb
    bu_vls_printb.argtypes = [POINTER(struct_bu_vls), String, c_ulong, String]
    bu_vls_printb.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4374
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_printb'):
    bu_printb = _libs['/usr/brlcad/lib/libbu.so'].bu_printb
    bu_printb.argtypes = [String, c_ulong, String]
    bu_printb.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4400
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_init'):
    bu_ptbl_init = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_init
    bu_ptbl_init.argtypes = [POINTER(struct_bu_ptbl), c_size_t, String]
    bu_ptbl_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4408
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_reset'):
    bu_ptbl_reset = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_reset
    bu_ptbl_reset.argtypes = [POINTER(struct_bu_ptbl)]
    bu_ptbl_reset.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4413
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_ins'):
    bu_ptbl_ins = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_ins
    bu_ptbl_ins.argtypes = [POINTER(struct_bu_ptbl), POINTER(c_long)]
    bu_ptbl_ins.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4427
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_locate'):
    bu_ptbl_locate = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_locate
    bu_ptbl_locate.argtypes = [POINTER(struct_bu_ptbl), POINTER(c_long)]
    bu_ptbl_locate.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4434
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_zero'):
    bu_ptbl_zero = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_zero
    bu_ptbl_zero.argtypes = [POINTER(struct_bu_ptbl), POINTER(c_long)]
    bu_ptbl_zero.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4447
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_ins_unique'):
    bu_ptbl_ins_unique = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_ins_unique
    bu_ptbl_ins_unique.argtypes = [POINTER(struct_bu_ptbl), POINTER(c_long)]
    bu_ptbl_ins_unique.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4460
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_rm'):
    bu_ptbl_rm = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_rm
    bu_ptbl_rm.argtypes = [POINTER(struct_bu_ptbl), POINTER(c_long)]
    bu_ptbl_rm.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4467
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_cat'):
    bu_ptbl_cat = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_cat
    bu_ptbl_cat.argtypes = [POINTER(struct_bu_ptbl), POINTER(struct_bu_ptbl)]
    bu_ptbl_cat.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4476
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_cat_uniq'):
    bu_ptbl_cat_uniq = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_cat_uniq
    bu_ptbl_cat_uniq.argtypes = [POINTER(struct_bu_ptbl), POINTER(struct_bu_ptbl)]
    bu_ptbl_cat_uniq.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4483
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_free'):
    bu_ptbl_free = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_free
    bu_ptbl_free.argtypes = [POINTER(struct_bu_ptbl)]
    bu_ptbl_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4488
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_pr_ptbl'):
    bu_pr_ptbl = _libs['/usr/brlcad/lib/libbu.so'].bu_pr_ptbl
    bu_pr_ptbl.argtypes = [String, POINTER(struct_bu_ptbl), c_int]
    bu_pr_ptbl.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4495
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ptbl_trunc'):
    bu_ptbl_trunc = _libs['/usr/brlcad/lib/libbu.so'].bu_ptbl_trunc
    bu_ptbl_trunc.argtypes = [POINTER(struct_bu_ptbl), c_int]
    bu_ptbl_trunc.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4517
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_create'):
    bu_rb_create = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_create
    bu_rb_create.argtypes = [String, c_int, POINTER(CFUNCTYPE(UNCHECKED(c_int), ))]
    bu_rb_create.restype = POINTER(struct_bu_rb_tree)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4532
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_create1'):
    bu_rb_create1 = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_create1
    bu_rb_create1.argtypes = [String, CFUNCTYPE(UNCHECKED(c_int), )]
    bu_rb_create1.restype = POINTER(struct_bu_rb_tree)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4548
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_delete'):
    bu_rb_delete = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_delete
    bu_rb_delete.argtypes = [POINTER(struct_bu_rb_tree), c_int]
    bu_rb_delete.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4565
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_diagnose_tree'):
    bu_rb_diagnose_tree = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_diagnose_tree
    bu_rb_diagnose_tree.argtypes = [POINTER(struct_bu_rb_tree), c_int, c_int]
    bu_rb_diagnose_tree.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4576
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_summarize_tree'):
    bu_rb_summarize_tree = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_summarize_tree
    bu_rb_summarize_tree.argtypes = [POINTER(struct_bu_rb_tree)]
    bu_rb_summarize_tree.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4594
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_extreme'):
    bu_rb_extreme = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_extreme
    bu_rb_extreme.argtypes = [POINTER(struct_bu_rb_tree), c_int, c_int]
    bu_rb_extreme.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4608
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_neighbor'):
    bu_rb_neighbor = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_neighbor
    bu_rb_neighbor.argtypes = [POINTER(struct_bu_rb_tree), c_int, c_int]
    bu_rb_neighbor.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4619
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_curr'):
    bu_rb_curr = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_curr
    bu_rb_curr.argtypes = [POINTER(struct_bu_rb_tree), c_int]
    bu_rb_curr.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4640
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_free'):
    bu_rb_free = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_free
    bu_rb_free.argtypes = [POINTER(struct_bu_rb_tree), CFUNCTYPE(UNCHECKED(None), )]
    bu_rb_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4667
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_insert'):
    bu_rb_insert = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_insert
    bu_rb_insert.argtypes = [POINTER(struct_bu_rb_tree), POINTER(None)]
    bu_rb_insert.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4676
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_is_uniq'):
    bu_rb_is_uniq = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_is_uniq
    bu_rb_is_uniq.argtypes = [POINTER(struct_bu_rb_tree), c_int]
    bu_rb_is_uniq.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4690
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_set_uniqv'):
    bu_rb_set_uniqv = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_set_uniqv
    bu_rb_set_uniqv.argtypes = [POINTER(struct_bu_rb_tree), bitv_t]
    bu_rb_set_uniqv.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4697
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_uniq_all_off'):
    bu_rb_uniq_all_off = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_uniq_all_off
    bu_rb_uniq_all_off.argtypes = [POINTER(struct_bu_rb_tree)]
    bu_rb_uniq_all_off.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4703
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_uniq_all_on'):
    bu_rb_uniq_all_on = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_uniq_all_on
    bu_rb_uniq_all_on.argtypes = [POINTER(struct_bu_rb_tree)]
    bu_rb_uniq_all_on.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4710
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_uniq_on'):
    bu_rb_uniq_on = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_uniq_on
    bu_rb_uniq_on.argtypes = [POINTER(struct_bu_rb_tree), c_int]
    bu_rb_uniq_on.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4719
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_uniq_off'):
    bu_rb_uniq_off = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_uniq_off
    bu_rb_uniq_off.argtypes = [POINTER(struct_bu_rb_tree), c_int]
    bu_rb_uniq_off.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4738
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_rank'):
    bu_rb_rank = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_rank
    bu_rb_rank.argtypes = [POINTER(struct_bu_rb_tree), c_int]
    bu_rb_rank.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4748
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_select'):
    bu_rb_select = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_select
    bu_rb_select.argtypes = [POINTER(struct_bu_rb_tree), c_int, c_int]
    bu_rb_select.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4766
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_search'):
    bu_rb_search = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_search
    bu_rb_search.argtypes = [POINTER(struct_bu_rb_tree), c_int, POINTER(None)]
    bu_rb_search.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4798
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_rb_walk'):
    bu_rb_walk = _libs['/usr/brlcad/lib/libbu.so'].bu_rb_walk
    bu_rb_walk.argtypes = [POINTER(struct_bu_rb_tree), c_int, CFUNCTYPE(UNCHECKED(None), ), c_int]
    bu_rb_walk.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4841
try:
    bu_setjmp_valid = (c_int).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_setjmp_valid')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4842
try:
    bu_jmpbuf = (jmp_buf).in_dll(_libs['/usr/brlcad/lib/libbu.so'], 'bu_jmpbuf')
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4854
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_semaphore_init'):
    bu_semaphore_init = _libs['/usr/brlcad/lib/libbu.so'].bu_semaphore_init
    bu_semaphore_init.argtypes = [c_uint]
    bu_semaphore_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4859
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_semaphore_free'):
    bu_semaphore_free = _libs['/usr/brlcad/lib/libbu.so'].bu_semaphore_free
    bu_semaphore_free.argtypes = []
    bu_semaphore_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4865
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_semaphore_reinit'):
    bu_semaphore_reinit = _libs['/usr/brlcad/lib/libbu.so'].bu_semaphore_reinit
    bu_semaphore_reinit.argtypes = [c_uint]
    bu_semaphore_reinit.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4869
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_semaphore_acquire'):
    bu_semaphore_acquire = _libs['/usr/brlcad/lib/libbu.so'].bu_semaphore_acquire
    bu_semaphore_acquire.argtypes = [c_uint]
    bu_semaphore_acquire.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4873
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_semaphore_release'):
    bu_semaphore_release = _libs['/usr/brlcad/lib/libbu.so'].bu_semaphore_release
    bu_semaphore_release.argtypes = [c_uint]
    bu_semaphore_release.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4884
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_init'):
    bu_vls_init = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_init
    bu_vls_init.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4892
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_init_if_uninit'):
    bu_vls_init_if_uninit = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_init_if_uninit
    bu_vls_init_if_uninit.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_init_if_uninit.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4899
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_vlsinit'):
    bu_vls_vlsinit = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_vlsinit
    bu_vls_vlsinit.argtypes = []
    bu_vls_vlsinit.restype = POINTER(struct_bu_vls)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4905
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_addr'):
    bu_vls_addr = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_addr
    bu_vls_addr.argtypes = [POINTER(struct_bu_vls)]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_vls_addr.restype = ReturnString
    else:
        bu_vls_addr.restype = String
        bu_vls_addr.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4912
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_extend'):
    bu_vls_extend = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_extend
    bu_vls_extend.argtypes = [POINTER(struct_bu_vls), c_uint]
    bu_vls_extend.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4925
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_setlen'):
    bu_vls_setlen = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_setlen
    bu_vls_setlen.argtypes = [POINTER(struct_bu_vls), c_size_t]
    bu_vls_setlen.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4931
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strlen'):
    bu_vls_strlen = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strlen
    bu_vls_strlen.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_strlen.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4939
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_trunc'):
    bu_vls_trunc = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_trunc
    bu_vls_trunc.argtypes = [POINTER(struct_bu_vls), c_int]
    bu_vls_trunc.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4946
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_trunc2'):
    bu_vls_trunc2 = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_trunc2
    bu_vls_trunc2.argtypes = [POINTER(struct_bu_vls), c_int]
    bu_vls_trunc2.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4956
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_nibble'):
    bu_vls_nibble = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_nibble
    bu_vls_nibble.argtypes = [POINTER(struct_bu_vls), c_int]
    bu_vls_nibble.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4962
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_free'):
    bu_vls_free = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_free
    bu_vls_free.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4968
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_vlsfree'):
    bu_vls_vlsfree = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_vlsfree
    bu_vls_vlsfree.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_vlsfree.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4974
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strdup'):
    bu_vls_strdup = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strdup
    bu_vls_strdup.argtypes = [POINTER(struct_bu_vls)]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_vls_strdup.restype = ReturnString
    else:
        bu_vls_strdup.restype = String
        bu_vls_strdup.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4985
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strgrab'):
    bu_vls_strgrab = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strgrab
    bu_vls_strgrab.argtypes = [POINTER(struct_bu_vls)]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_vls_strgrab.restype = ReturnString
    else:
        bu_vls_strgrab.restype = String
        bu_vls_strgrab.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4990
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strcpy'):
    bu_vls_strcpy = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strcpy
    bu_vls_strcpy.argtypes = [POINTER(struct_bu_vls), String]
    bu_vls_strcpy.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4997
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strncpy'):
    bu_vls_strncpy = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strncpy
    bu_vls_strncpy.argtypes = [POINTER(struct_bu_vls), String, c_size_t]
    bu_vls_strncpy.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5004
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strcat'):
    bu_vls_strcat = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strcat
    bu_vls_strcat.argtypes = [POINTER(struct_bu_vls), String]
    bu_vls_strcat.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5010
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strncat'):
    bu_vls_strncat = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strncat
    bu_vls_strncat.argtypes = [POINTER(struct_bu_vls), String, c_size_t]
    bu_vls_strncat.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5018
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_vlscat'):
    bu_vls_vlscat = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_vlscat
    bu_vls_vlscat.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_vls)]
    bu_vls_vlscat.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5025
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_vlscatzap'):
    bu_vls_vlscatzap = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_vlscatzap
    bu_vls_vlscatzap.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_vls)]
    bu_vls_vlscatzap.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5033
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strcmp'):
    bu_vls_strcmp = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strcmp
    bu_vls_strcmp.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_vls)]
    bu_vls_strcmp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5042
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_strncmp'):
    bu_vls_strncmp = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_strncmp
    bu_vls_strncmp.argtypes = [POINTER(struct_bu_vls), POINTER(struct_bu_vls), c_size_t]
    bu_vls_strncmp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5050
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_from_argv'):
    bu_vls_from_argv = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_from_argv
    bu_vls_from_argv.argtypes = [POINTER(struct_bu_vls), c_int, POINTER(POINTER(c_char))]
    bu_vls_from_argv.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5057
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_fwrite'):
    bu_vls_fwrite = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_fwrite
    bu_vls_fwrite.argtypes = [POINTER(FILE), POINTER(struct_bu_vls)]
    bu_vls_fwrite.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5063
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_write'):
    bu_vls_write = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_write
    bu_vls_write.argtypes = [c_int, POINTER(struct_bu_vls)]
    bu_vls_write.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5074
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_read'):
    bu_vls_read = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_read
    bu_vls_read.argtypes = [POINTER(struct_bu_vls), c_int]
    bu_vls_read.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5089
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_gets'):
    bu_vls_gets = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_gets
    bu_vls_gets.argtypes = [POINTER(struct_bu_vls), POINTER(FILE)]
    bu_vls_gets.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5095
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_putc'):
    bu_vls_putc = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_putc
    bu_vls_putc.argtypes = [POINTER(struct_bu_vls), c_int]
    bu_vls_putc.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5101
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_trimspace'):
    bu_vls_trimspace = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_trimspace
    bu_vls_trimspace.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_trimspace.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5115
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_vprintf'):
    bu_vls_vprintf = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_vprintf
    bu_vls_vprintf.argtypes = [POINTER(struct_bu_vls), String, c_void_p]
    bu_vls_vprintf.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5131
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_printf'):
    _func = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_printf
    _restype = None
    _argtypes = [POINTER(struct_bu_vls), String]
    bu_vls_printf = _variadic_function(_func,_restype,_argtypes)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5143
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_sprintf'):
    _func = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_sprintf
    _restype = None
    _argtypes = [POINTER(struct_bu_vls), String]
    bu_vls_sprintf = _variadic_function(_func,_restype,_argtypes)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5149
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_spaces'):
    bu_vls_spaces = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_spaces
    bu_vls_spaces.argtypes = [POINTER(struct_bu_vls), c_int]
    bu_vls_spaces.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5164
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_print_positions_used'):
    bu_vls_print_positions_used = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_print_positions_used
    bu_vls_print_positions_used.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_print_positions_used.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5171
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_detab'):
    bu_vls_detab = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_detab
    bu_vls_detab.argtypes = [POINTER(struct_bu_vls)]
    bu_vls_detab.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5176
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_prepend'):
    bu_vls_prepend = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_prepend
    bu_vls_prepend.argtypes = [POINTER(struct_bu_vls), String]
    bu_vls_prepend.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5197
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_encode'):
    bu_vls_encode = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_encode
    bu_vls_encode.argtypes = [POINTER(struct_bu_vls), String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_vls_encode.restype = ReturnString
    else:
        bu_vls_encode.restype = String
        bu_vls_encode.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5210
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vls_decode'):
    bu_vls_decode = _libs['/usr/brlcad/lib/libbu.so'].bu_vls_decode
    bu_vls_decode.argtypes = [POINTER(struct_bu_vls), String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_vls_decode.restype = ReturnString
    else:
        bu_vls_decode.restype = String
        bu_vls_decode.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5224
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_init'):
    bu_vlb_init = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_init
    bu_vlb_init.argtypes = [POINTER(struct_bu_vlb)]
    bu_vlb_init.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5233
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_initialize'):
    bu_vlb_initialize = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_initialize
    bu_vlb_initialize.argtypes = [POINTER(struct_bu_vlb), c_size_t]
    bu_vlb_initialize.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5244
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_write'):
    bu_vlb_write = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_write
    bu_vlb_write.argtypes = [POINTER(struct_bu_vlb), POINTER(c_ubyte), c_size_t]
    bu_vlb_write.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5255
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_reset'):
    bu_vlb_reset = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_reset
    bu_vlb_reset.argtypes = [POINTER(struct_bu_vlb)]
    bu_vlb_reset.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5263
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_addr'):
    bu_vlb_addr = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_addr
    bu_vlb_addr.argtypes = [POINTER(struct_bu_vlb)]
    bu_vlb_addr.restype = POINTER(c_ubyte)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5271
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_buflen'):
    bu_vlb_buflen = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_buflen
    bu_vlb_buflen.argtypes = [POINTER(struct_bu_vlb)]
    bu_vlb_buflen.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5279
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_free'):
    bu_vlb_free = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_free
    bu_vlb_free.argtypes = [POINTER(struct_bu_vlb)]
    bu_vlb_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5286
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_vlb_print'):
    bu_vlb_print = _libs['/usr/brlcad/lib/libbu.so'].bu_vlb_print
    bu_vlb_print.argtypes = [POINTER(struct_bu_vlb), POINTER(FILE)]
    bu_vlb_print.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5292
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_pr_vlb'):
    bu_pr_vlb = _libs['/usr/brlcad/lib/libbu.so'].bu_pr_vlb
    bu_pr_vlb.argtypes = [String, POINTER(struct_bu_vlb)]
    bu_pr_vlb.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5309
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strlcatm'):
    bu_strlcatm = _libs['/usr/brlcad/lib/libbu.so'].bu_strlcatm
    bu_strlcatm.argtypes = [String, String, c_size_t, String]
    bu_strlcatm.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5319
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strlcpym'):
    bu_strlcpym = _libs['/usr/brlcad/lib/libbu.so'].bu_strlcpym
    bu_strlcpym.argtypes = [String, String, c_size_t, String]
    bu_strlcpym.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5330
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strdupm'):
    bu_strdupm = _libs['/usr/brlcad/lib/libbu.so'].bu_strdupm
    bu_strdupm.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_strdupm.restype = ReturnString
    else:
        bu_strdupm.restype = String
        bu_strdupm.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5340
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strcmp'):
    bu_strcmp = _libs['/usr/brlcad/lib/libbu.so'].bu_strcmp
    bu_strcmp.argtypes = [String, String]
    bu_strcmp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5350
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strncmp'):
    bu_strncmp = _libs['/usr/brlcad/lib/libbu.so'].bu_strncmp
    bu_strncmp.argtypes = [String, String, c_size_t]
    bu_strncmp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5360
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strcasecmp'):
    bu_strcasecmp = _libs['/usr/brlcad/lib/libbu.so'].bu_strcasecmp
    bu_strcasecmp.argtypes = [String, String]
    bu_strcasecmp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5371
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_strncasecmp'):
    bu_strncasecmp = _libs['/usr/brlcad/lib/libbu.so'].bu_strncasecmp
    bu_strncasecmp.argtypes = [String, String, c_size_t]
    bu_strncasecmp.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5471
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_str_escape'):
    bu_str_escape = _libs['/usr/brlcad/lib/libbu.so'].bu_str_escape
    bu_str_escape.argtypes = [String, String, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_str_escape.restype = ReturnString
    else:
        bu_str_escape.restype = String
        bu_str_escape.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5501
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_str_unescape'):
    bu_str_unescape = _libs['/usr/brlcad/lib/libbu.so'].bu_str_unescape
    bu_str_unescape.argtypes = [String, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_str_unescape.restype = ReturnString
    else:
        bu_str_unescape.restype = String
        bu_str_unescape.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5524
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_units_conversion'):
    bu_units_conversion = _libs['/usr/brlcad/lib/libbu.so'].bu_units_conversion
    bu_units_conversion.argtypes = [String]
    bu_units_conversion.restype = c_double

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5537
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_units_string'):
    bu_units_string = _libs['/usr/brlcad/lib/libbu.so'].bu_units_string
    bu_units_string.argtypes = [c_double]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_units_string.restype = ReturnString
    else:
        bu_units_string.restype = String
        bu_units_string.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5538
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_units_strings_vls'):
    bu_units_strings_vls = _libs['/usr/brlcad/lib/libbu.so'].bu_units_strings_vls
    bu_units_strings_vls.argtypes = []
    bu_units_strings_vls.restype = POINTER(struct_bu_vls)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5548
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_nearest_units_string'):
    bu_nearest_units_string = _libs['/usr/brlcad/lib/libbu.so'].bu_nearest_units_string
    bu_nearest_units_string.argtypes = [c_double]
    if sizeof(c_int) == sizeof(c_void_p):
        bu_nearest_units_string.restype = ReturnString
    else:
        bu_nearest_units_string.restype = String
        bu_nearest_units_string.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5558
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_mm_value'):
    bu_mm_value = _libs['/usr/brlcad/lib/libbu.so'].bu_mm_value
    bu_mm_value.argtypes = [String]
    bu_mm_value.restype = c_double

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5564
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_mm_cvt'):
    bu_mm_cvt = _libs['/usr/brlcad/lib/libbu.so'].bu_mm_cvt
    bu_mm_cvt.argtypes = [POINTER(struct_bu_structparse), String, String, String]
    bu_mm_cvt.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5635
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_gshort'):
    bu_gshort = _libs['/usr/brlcad/lib/libbu.so'].bu_gshort
    bu_gshort.argtypes = [POINTER(c_ubyte)]
    bu_gshort.restype = c_uint16

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5640
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_glong'):
    bu_glong = _libs['/usr/brlcad/lib/libbu.so'].bu_glong
    bu_glong.argtypes = [POINTER(c_ubyte)]
    bu_glong.restype = c_uint32

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5645
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_pshort'):
    bu_pshort = _libs['/usr/brlcad/lib/libbu.so'].bu_pshort
    bu_pshort.argtypes = [POINTER(c_ubyte), c_uint16]
    bu_pshort.restype = POINTER(c_ubyte)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5650
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_plong'):
    bu_plong = _libs['/usr/brlcad/lib/libbu.so'].bu_plong
    bu_plong.argtypes = [POINTER(c_ubyte), c_uint32]
    bu_plong.restype = POINTER(c_ubyte)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5655
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_plonglong'):
    bu_plonglong = _libs['/usr/brlcad/lib/libbu.so'].bu_plonglong
    bu_plonglong.argtypes = [POINTER(c_ubyte), c_uint64]
    bu_plonglong.restype = POINTER(c_ubyte)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5673
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_observer_cmd'):
    bu_observer_cmd = _libs['/usr/brlcad/lib/libbu.so'].bu_observer_cmd
    bu_observer_cmd.argtypes = [POINTER(None), c_int, POINTER(POINTER(c_char))]
    bu_observer_cmd.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5678
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_observer_notify'):
    bu_observer_notify = _libs['/usr/brlcad/lib/libbu.so'].bu_observer_notify
    bu_observer_notify.argtypes = [POINTER(Tcl_Interp), POINTER(struct_bu_observer), String]
    bu_observer_notify.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5683
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_observer_free'):
    bu_observer_free = _libs['/usr/brlcad/lib/libbu.so'].bu_observer_free
    bu_observer_free.argtypes = [POINTER(struct_bu_observer)]
    bu_observer_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5695
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'Bu_Init'):
    Bu_Init = _libs['/usr/brlcad/lib/libbu.so'].Bu_Init
    Bu_Init.argtypes = [POINTER(None)]
    Bu_Init.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5708
class struct_bu_lex_t_int(Structure):
    pass

struct_bu_lex_t_int.__slots__ = [
    'type',
    'value',
]
struct_bu_lex_t_int._fields_ = [
    ('type', c_int),
    ('value', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5713
class struct_bu_lex_t_dbl(Structure):
    pass

struct_bu_lex_t_dbl.__slots__ = [
    'type',
    'value',
]
struct_bu_lex_t_dbl._fields_ = [
    ('type', c_int),
    ('value', c_double),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5718
class struct_bu_lex_t_key(Structure):
    pass

struct_bu_lex_t_key.__slots__ = [
    'type',
    'value',
]
struct_bu_lex_t_key._fields_ = [
    ('type', c_int),
    ('value', c_int),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5724
class struct_bu_lex_t_id(Structure):
    pass

struct_bu_lex_t_id.__slots__ = [
    'type',
    'value',
]
struct_bu_lex_t_id._fields_ = [
    ('type', c_int),
    ('value', String),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5730
class union_bu_lex_token(Union):
    pass

union_bu_lex_token.__slots__ = [
    'type',
    't_int',
    't_dbl',
    't_key',
    't_id',
]
union_bu_lex_token._fields_ = [
    ('type', c_int),
    ('t_int', struct_bu_lex_t_int),
    ('t_dbl', struct_bu_lex_t_dbl),
    ('t_key', struct_bu_lex_t_key),
    ('t_id', struct_bu_lex_t_id),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5737
class struct_bu_lex_key(Structure):
    pass

struct_bu_lex_key.__slots__ = [
    'tok_val',
    'string',
]
struct_bu_lex_key._fields_ = [
    ('tok_val', c_int),
    ('string', String),
]

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5746
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_lex'):
    bu_lex = _libs['/usr/brlcad/lib/libbu.so'].bu_lex
    bu_lex.argtypes = [POINTER(union_bu_lex_token), POINTER(struct_bu_vls), POINTER(struct_bu_lex_key), POINTER(struct_bu_lex_key)]
    bu_lex.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5771
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_mread'):
    bu_mread = _libs['/usr/brlcad/lib/libbu.so'].bu_mread
    bu_mread.argtypes = [c_int, POINTER(None), c_long]
    bu_mread.restype = c_long

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5787
class struct_bu_hash_entry(Structure):
    pass

struct_bu_hash_entry.__slots__ = [
    'magic',
    'key',
    'value',
    'key_len',
    'next',
]
struct_bu_hash_entry._fields_ = [
    ('magic', c_uint32),
    ('key', POINTER(c_ubyte)),
    ('value', POINTER(c_ubyte)),
    ('key_len', c_int),
    ('next', POINTER(struct_bu_hash_entry)),
]

bu_hash_entry_t = struct_bu_hash_entry # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5794

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5827
class struct_bu_hash_tbl(Structure):
    pass

struct_bu_hash_tbl.__slots__ = [
    'magic',
    'mask',
    'num_lists',
    'num_entries',
    'lists',
]
struct_bu_hash_tbl._fields_ = [
    ('magic', c_uint32),
    ('mask', c_ulong),
    ('num_lists', c_ulong),
    ('num_entries', c_ulong),
    ('lists', POINTER(POINTER(struct_bu_hash_entry))),
]

bu_hash_tbl_t = struct_bu_hash_tbl # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5834

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5866
class struct_bu_hash_record(Structure):
    pass

struct_bu_hash_record.__slots__ = [
    'magic',
    'tbl',
    'index',
    'hsh_entry',
]
struct_bu_hash_record._fields_ = [
    ('magic', c_uint32),
    ('tbl', POINTER(struct_bu_hash_tbl)),
    ('index', c_ulong),
    ('hsh_entry', POINTER(struct_bu_hash_entry)),
]

bu_hash_record_t = struct_bu_hash_record # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5872

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5905
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hash'):
    bu_hash = _libs['/usr/brlcad/lib/libbu.so'].bu_hash
    bu_hash.argtypes = [POINTER(c_ubyte), c_int]
    bu_hash.restype = c_ulong

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5914
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_create_hash_tbl'):
    bu_create_hash_tbl = _libs['/usr/brlcad/lib/libbu.so'].bu_create_hash_tbl
    bu_create_hash_tbl.argtypes = [c_ulong]
    bu_create_hash_tbl.restype = POINTER(struct_bu_hash_tbl)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5931
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_find_hash_entry'):
    bu_find_hash_entry = _libs['/usr/brlcad/lib/libbu.so'].bu_find_hash_entry
    bu_find_hash_entry.argtypes = [POINTER(struct_bu_hash_tbl), POINTER(c_ubyte), c_int, POINTER(POINTER(struct_bu_hash_entry)), POINTER(c_ulong)]
    bu_find_hash_entry.restype = POINTER(struct_bu_hash_entry)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5943
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_set_hash_value'):
    bu_set_hash_value = _libs['/usr/brlcad/lib/libbu.so'].bu_set_hash_value
    bu_set_hash_value.argtypes = [POINTER(struct_bu_hash_entry), POINTER(c_ubyte)]
    bu_set_hash_value.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5949
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_get_hash_value'):
    bu_get_hash_value = _libs['/usr/brlcad/lib/libbu.so'].bu_get_hash_value
    bu_get_hash_value.argtypes = [POINTER(struct_bu_hash_entry)]
    bu_get_hash_value.restype = POINTER(c_ubyte)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5954
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_get_hash_key'):
    bu_get_hash_key = _libs['/usr/brlcad/lib/libbu.so'].bu_get_hash_key
    bu_get_hash_key.argtypes = [POINTER(struct_bu_hash_entry)]
    bu_get_hash_key.restype = POINTER(c_ubyte)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5972
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hash_add_entry'):
    bu_hash_add_entry = _libs['/usr/brlcad/lib/libbu.so'].bu_hash_add_entry
    bu_hash_add_entry.argtypes = [POINTER(struct_bu_hash_tbl), POINTER(c_ubyte), c_int, POINTER(c_int)]
    bu_hash_add_entry.restype = POINTER(struct_bu_hash_entry)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5982
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hash_tbl_pr'):
    bu_hash_tbl_pr = _libs['/usr/brlcad/lib/libbu.so'].bu_hash_tbl_pr
    bu_hash_tbl_pr.argtypes = [POINTER(struct_bu_hash_tbl), String]
    bu_hash_tbl_pr.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5991
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hash_tbl_free'):
    bu_hash_tbl_free = _libs['/usr/brlcad/lib/libbu.so'].bu_hash_tbl_free
    bu_hash_tbl_free.argtypes = [POINTER(struct_bu_hash_tbl)]
    bu_hash_tbl_free.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6004
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hash_tbl_first'):
    bu_hash_tbl_first = _libs['/usr/brlcad/lib/libbu.so'].bu_hash_tbl_first
    bu_hash_tbl_first.argtypes = [POINTER(struct_bu_hash_tbl), POINTER(struct_bu_hash_record)]
    bu_hash_tbl_first.restype = POINTER(struct_bu_hash_entry)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6017
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_hash_tbl_next'):
    bu_hash_tbl_next = _libs['/usr/brlcad/lib/libbu.so'].bu_hash_tbl_next
    bu_hash_tbl_next.argtypes = [POINTER(struct_bu_hash_record)]
    bu_hash_tbl_next.restype = POINTER(struct_bu_hash_entry)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6035
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_fchmod'):
    bu_fchmod = _libs['/usr/brlcad/lib/libbu.so'].bu_fchmod
    bu_fchmod.argtypes = [c_int, c_ulong]
    bu_fchmod.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6063
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_argv_from_string'):
    bu_argv_from_string = _libs['/usr/brlcad/lib/libbu.so'].bu_argv_from_string
    bu_argv_from_string.argtypes = [POINTER(POINTER(c_char)), c_size_t, String]
    bu_argv_from_string.restype = c_size_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6073
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_free_argv'):
    bu_free_argv = _libs['/usr/brlcad/lib/libbu.so'].bu_free_argv
    bu_free_argv.argtypes = [c_int, POINTER(POINTER(c_char))]
    bu_free_argv.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6079
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_free_array'):
    bu_free_array = _libs['/usr/brlcad/lib/libbu.so'].bu_free_array
    bu_free_array.argtypes = [c_int, POINTER(POINTER(c_char)), String]
    bu_free_array.restype = None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6089
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dup_argv'):
    bu_dup_argv = _libs['/usr/brlcad/lib/libbu.so'].bu_dup_argv
    bu_dup_argv.argtypes = [c_int, POINTER(POINTER(c_char))]
    bu_dup_argv.restype = POINTER(POINTER(c_char))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6101
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dupinsert_argv'):
    bu_dupinsert_argv = _libs['/usr/brlcad/lib/libbu.so'].bu_dupinsert_argv
    bu_dupinsert_argv.argtypes = [c_int, c_int, POINTER(POINTER(c_char)), c_int, POINTER(POINTER(c_char))]
    bu_dupinsert_argv.restype = POINTER(POINTER(c_char))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6112
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_argv_from_path'):
    bu_argv_from_path = _libs['/usr/brlcad/lib/libbu.so'].bu_argv_from_path
    bu_argv_from_path.argtypes = [String, POINTER(c_int)]
    bu_argv_from_path.restype = POINTER(POINTER(c_char))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6136
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_suspend_interrupts'):
    bu_suspend_interrupts = _libs['/usr/brlcad/lib/libbu.so'].bu_suspend_interrupts
    bu_suspend_interrupts.argtypes = []
    bu_suspend_interrupts.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6148
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_restore_interrupts'):
    bu_restore_interrupts = _libs['/usr/brlcad/lib/libbu.so'].bu_restore_interrupts
    bu_restore_interrupts.argtypes = []
    bu_restore_interrupts.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6170
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_simd_level'):
    bu_simd_level = _libs['/usr/brlcad/lib/libbu.so'].bu_simd_level
    bu_simd_level.argtypes = []
    bu_simd_level.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6176
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_simd_supported'):
    bu_simd_supported = _libs['/usr/brlcad/lib/libbu.so'].bu_simd_supported
    bu_simd_supported.argtypes = [c_int]
    bu_simd_supported.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6186
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_gettime'):
    bu_gettime = _libs['/usr/brlcad/lib/libbu.so'].bu_gettime
    bu_gettime.argtypes = []
    bu_gettime.restype = c_int64

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6200
for _lib in _libs.itervalues():
    if not hasattr(_lib, 'bu_utctime'):
        continue
    bu_utctime = _lib.bu_utctime
    bu_utctime.argtypes = [POINTER(struct_bu_vls), c_int64]
    bu_utctime.restype = None
    break

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6221
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dlopen'):
    bu_dlopen = _libs['/usr/brlcad/lib/libbu.so'].bu_dlopen
    bu_dlopen.argtypes = [String, c_int]
    bu_dlopen.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6222
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dlsym'):
    bu_dlsym = _libs['/usr/brlcad/lib/libbu.so'].bu_dlsym
    bu_dlsym.argtypes = [POINTER(None), String]
    bu_dlsym.restype = POINTER(None)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6223
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dlclose'):
    bu_dlclose = _libs['/usr/brlcad/lib/libbu.so'].bu_dlclose
    bu_dlclose.argtypes = [POINTER(None)]
    bu_dlclose.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6224
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_dlerror'):
    bu_dlerror = _libs['/usr/brlcad/lib/libbu.so'].bu_dlerror
    bu_dlerror.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        bu_dlerror.restype = ReturnString
    else:
        bu_dlerror.restype = String
        bu_dlerror.errcheck = ReturnString

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6227
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_fseek'):
    bu_fseek = _libs['/usr/brlcad/lib/libbu.so'].bu_fseek
    bu_fseek.argtypes = [POINTER(FILE), off_t, c_int]
    bu_fseek.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6229
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_ftell'):
    bu_ftell = _libs['/usr/brlcad/lib/libbu.so'].bu_ftell
    bu_ftell.argtypes = [POINTER(FILE)]
    bu_ftell.restype = off_t

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6239
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_str_isprint'):
    bu_str_isprint = _libs['/usr/brlcad/lib/libbu.so'].bu_str_isprint
    bu_str_isprint.argtypes = [String]
    bu_str_isprint.restype = c_int

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6246
if hasattr(_libs['/usr/brlcad/lib/libbu.so'], 'bu_gethostname'):
    bu_gethostname = _libs['/usr/brlcad/lib/libbu.so'].bu_gethostname
    bu_gethostname.argtypes = [String, c_size_t]
    bu_gethostname.restype = c_int

# /usr/include/linux/limits.h: 12
try:
    PATH_MAX = 4096
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/common.h: 277
def LIKELY(expression):
    return expression

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 105
try:
    BRLCAD_OK = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 106
try:
    BRLCAD_ERROR = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 122
try:
    BU_DIR_SEPARATOR = '/'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 133
try:
    MAXPATHLEN = PATH_MAX
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 152
try:
    BU_PATH_SEPARATOR = ':'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 163
def bu_cpp_str(s):
    return s

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 164
def bu_cpp_xstr(s):
    return (bu_cpp_str (s))

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 62
try:
    BU_AVS_MAGIC = 1098273569
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 63
try:
    BU_BITV_MAGIC = 1651078262
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 64
try:
    BU_COLOR_MAGIC = 1651860332
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 65
try:
    BU_EXTERNAL_MAGIC = 1989000144
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 66
try:
    BU_HASH_ENTRY_MAGIC = 1212501588
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 67
try:
    BU_HASH_RECORD_MAGIC = 1751217000
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 68
try:
    BU_HASH_TBL_MAGIC = 1212240712
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 69
try:
    BU_HIST_MAGIC = 1214870388
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 70
try:
    BU_HOOK_LIST_MAGIC = 2429935277
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 73
try:
    BU_MAPPED_FILE_MAGIC = 1298231398
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 74
try:
    BU_OBSERVER_MAGIC = 1702454643
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 75
try:
    BU_PTBL_MAGIC = 1886675564
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 79
try:
    BU_RB_TREE_MAGIC = 1919054962
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 80
try:
    BU_VLB_MAGIC = 1599491138
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/magic.h: 81
try:
    BU_VLS_MAGIC = 2301836219
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 402
try:
    GENPTR_NULL = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 413
try:
    MAX_PSW = 1024
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 429
try:
    SIZEOF_NETWORK_SHORT = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 430
try:
    SIZEOF_NETWORK_LONG = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 431
try:
    SIZEOF_NETWORK_FLOAT = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 432
try:
    SIZEOF_NETWORK_DOUBLE = 8
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 447
try:
    CV_CHANNEL_MASK = 255
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 448
try:
    CV_HOST_MASK = 256
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 449
try:
    CV_SIGNED_MASK = 512
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 450
try:
    CV_TYPE_MASK = 7168
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 451
try:
    CV_CONVERT_MASK = 24576
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 453
try:
    CV_TYPE_SHIFT = 10
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 454
try:
    CV_CONVERT_SHIFT = 13
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 456
try:
    CV_8 = 1024
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 457
try:
    CV_16 = 2048
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 458
try:
    CV_32 = 3072
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 459
try:
    CV_64 = 4096
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 460
try:
    CV_D = 5120
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 462
try:
    CV_CLIP = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 463
try:
    CV_NORMAL = 8192
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 464
try:
    CV_LIT = 16384
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 467
try:
    END_NOTSET = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 468
try:
    END_BIG = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 469
try:
    END_LITTLE = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 470
try:
    END_ILL = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 471
try:
    END_CRAY = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 474
try:
    IND_NOTSET = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 475
try:
    IND_BIG = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 476
try:
    IND_LITTLE = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 477
try:
    IND_ILL = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 478
try:
    IND_CRAY = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 918
try:
    BU_LIST_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 929
def BU_LIST_MAGIC_EQUAL(_l, _magic):
    return (((_l.contents.magic).value) == _magic)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 969
def BU_LIST_IS_INITIALIZED(_hp):
    return ((_hp != BU_LIST_NULL) and (LIKELY ((((_hp.contents.forw).value) != BU_LIST_NULL))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1089
def BU_LIST_IS_EMPTY(hp):
    return (((hp.contents.forw).value) == hp)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1090
def BU_LIST_NON_EMPTY(hp):
    return (((hp.contents.forw).value) != hp)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1093
def BU_LIST_IS_CLEAR(hp):
    return (((((hp.contents.magic).value) == 0) and (((hp.contents.forw).value) == BU_LIST_NULL)) and (((hp.contents.back).value) == BU_LIST_NULL))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1116
def BU_LIST_IS_HEAD(p, hp):
    return (p == hp)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1118
def BU_LIST_NOT_HEAD(p, hp):
    return (not (BU_LIST_IS_HEAD (p, hp)))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1124
def BU_LIST_PREV_IS_HEAD(p, hp):
    return (((p.contents.back).value) == hp)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1126
def BU_LIST_PREV_NOT_HEAD(p, hp):
    return (not (BU_LIST_PREV_IS_HEAD (p, hp)))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1132
def BU_LIST_NEXT_IS_HEAD(p, hp):
    return (((p.contents.forw).value) == hp)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1134
def BU_LIST_NEXT_NOT_HEAD(p, hp):
    return (not (BU_LIST_NEXT_IS_HEAD (p, hp)))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1210
def BU_LIST_FIRST_MAGIC(hp):
    return ((hp.contents.forw).contents.magic)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1211
def BU_LIST_LAST_MAGIC(hp):
    return ((hp.contents.back).contents.magic)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1321
try:
    MAX_FASTF = 1e+73
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1322
try:
    SQRT_MAX_FASTF = 1e+36
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1323
try:
    SMALL_FASTF = 1e-77
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1327
try:
    SQRT_SMALL_FASTF = 1e-39
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1332
try:
    SMALL = SQRT_SMALL_FASTF
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1359
try:
    INFINITY = 1e+40
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1406
try:
    BU_BITV_SHIFT = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1419
try:
    BU_BITV_MASK = ((1 << BU_BITV_SHIFT) - 1)
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1443
try:
    BU_BITV_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1470
def BU_BITV_IS_INITIALIZED(_bp):
    return ((_bp != BU_BITV_NULL) and (LIKELY ((((((_bp.contents.l).value).magic).value) == BU_BITV_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1484
def BU_BITS2BYTES(_nb):
    return (((BU_BITS2WORDS (_nb)).value) * sizeof(bitv_t))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1485
def BU_BITS2WORDS(_nb):
    return ((_nb + BU_BITV_MASK) >> BU_BITV_SHIFT)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1486
def BU_WORDS2BITS(_nw):
    return ((_nw * sizeof(bitv_t)) * 8)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1490
def BU_BITTEST(_bv, bit):
    return (((((_bv.contents.bits).value) [(bit >> BU_BITV_SHIFT)]) & (1 << (bit & BU_BITV_MASK))) != 0)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1505
def BU_BITSET(_bv, bit):
    return (((_bv.contents.bits) [(bit >> BU_BITV_SHIFT)]) | (1 << (bit & BU_BITV_MASK)))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1507
def BU_BITCLR(_bv, bit):
    return (((_bv.contents.bits) [(bit >> BU_BITV_SHIFT)]) & (~(1 << (bit & BU_BITV_MASK))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1617
try:
    BU_HIST_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1644
def BU_HIST_IS_INITIALIZED(_hp):
    return ((_hp != BU_HIST_NULL) and (LIKELY ((((_hp.contents.magic).value) == BU_HIST_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1698
try:
    BU_PTBL_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1727
def BU_PTBL_IS_INITIALIZED(_p):
    return ((_p != BU_PTBL_NULL) and (LIKELY ((((((_p.contents.l).value).magic).value) == BU_PTBL_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1733
def BU_PTBL_BASEADDR(ptbl):
    return (ptbl.contents.buffer)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1734
def BU_PTBL_LASTADDR(ptbl):
    return ((((ptbl.contents.buffer).value) + ((ptbl.contents.end).value)) - 1)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1735
def BU_PTBL_END(ptbl):
    return (ptbl.contents.end)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1736
def BU_PTBL_LEN(ptbl):
    return (ptbl.contents.end)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1737
def BU_PTBL_GET(ptbl, i):
    return ((ptbl.contents.buffer) [i])

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1738
def BU_PTBL_SET(ptbl, i, val):
    return val

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1739
def BU_PTBL_TEST(ptbl):
    return (((((ptbl.contents.l).value).magic).value) == BU_PTBL_MAGIC)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1740
def BU_PTBL_CLEAR_I(_ptbl, _i):
    return None

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1821
try:
    BU_MAPPED_FILE_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1849
def BU_MAPPED_FILE_IS_INITIALIZED(_hp):
    return ((_hp != BU_MAPPED_FILE_NULL) and (LIKELY ((((((_hp.contents.l).value).magic).value) == BU_MAPPED_FILE_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1864
try:
    BU_HOOK_LIST_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1891
def BU_HOOK_LIST_IS_INITIALIZED(_p):
    return ((_p != BU_HOOK_LIST_NULL) and (LIKELY ((((((_p.contents.l).value).magic).value) == BU_HOOK_LIST_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1941
try:
    BU_AVS_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1967
def BU_AVS_IS_INITIALIZED(_ap):
    return ((_ap != BU_AVS_NULL) and (LIKELY ((((_ap.contents.magic).value) == BU_AVS_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 1999
def AVS_IS_FREEABLE(_avsp, _p):
    return (((((_avsp.contents.readonly_max).value) == NULL) or (_p < ((_avsp.contents.readonly_min).value))) or (_p > ((_avsp.contents.readonly_max).value)))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2034
try:
    BU_VLS_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2062
def BU_VLS_IS_INITIALIZED(_vp):
    return ((_vp != BU_VLS_NULL) and (((_vp.contents.vls_magic).value) == BU_VLS_MAGIC))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2089
try:
    BU_VLB_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2117
def BU_VLB_IS_INITIALIZED(_vp):
    return ((_vp != BU_VLB_NULL) and (((_vp.contents.magic).value) == BU_VLB_MAGIC))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2141
try:
    BU_DEBUG_OFF = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2143
try:
    BU_DEBUG_COREDUMP = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2144
try:
    BU_DEBUG_MEM_CHECK = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2145
try:
    BU_DEBUG_MEM_LOG = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2146
try:
    BU_DEBUG_UNUSED_0 = 8
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2148
try:
    BU_DEBUG_PARALLEL = 16
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2149
try:
    BU_DEBUG_MEM_QCHECK = 32
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2150
try:
    BU_DEBUG_BACKTRACE = 64
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2151
try:
    BU_DEBUG_ATTACH = 128
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2153
try:
    BU_DEBUG_MATH = 256
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2154
try:
    BU_DEBUG_PTBL = 512
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2155
try:
    BU_DEBUG_AVS = 1024
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2156
try:
    BU_DEBUG_MAPPED_FILE = 2048
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2158
try:
    BU_DEBUG_PATHS = 4096
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2159
try:
    BU_DEBUG_UNUSED_1 = 8192
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2160
try:
    BU_DEBUG_UNUSED_2 = 16384
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2161
try:
    BU_DEBUG_UNUSED_3 = 32768
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2163
try:
    BU_DEBUG_TABDATA = 65536
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2164
try:
    BU_DEBUG_UNUSED_4 = 131072
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2165
try:
    BU_DEBUG_UNUSED_5 = 262144
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2166
try:
    BU_DEBUG_UNUSED_6 = 524288
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2169
try:
    BU_DEBUG_FORMAT = '\x10\x15TABDATA\r?\x0cMAPPED_FILE\x0bAVS\nPTBL\tMATH\x08?\x07?\x06MEM_QCHECK\x05PARALLEL\x04?\x03MEM_LOG\x02MEM_CHECK\x01COREDUMP'
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2219
def bu_byteoffset(_i):
    return pointer(_i)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2288
try:
    BU_STRUCTPARSE_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2293
try:
    BU_STRUCTPARSE_FUNC_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2323
def BU_STRUCTPARSE_IS_INITIALIZED(_sp):
    return (_sp != BU_STRUCTPARSE_NULL)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2341
try:
    BU_EXTERNAL_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2368
def BU_EXTERNAL_IS_INITIALIZED(_p):
    return ((_p != BU_EXTERNAL_NULL) and (((_p.contents.ext_magic).value) == BU_EXTERNAL_MAGIC))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2375
try:
    RED = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2376
try:
    GRN = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2377
try:
    BLU = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2379
try:
    HUE = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2380
try:
    SAT = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2381
try:
    VAL = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2383
try:
    ACHROMATIC = (-1.0)
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2391
try:
    BU_COLOR_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2415
def BU_COLOR_IS_INITIALIZED(_c):
    return ((_c != BU_COLOR_NULL) and (LIKELY ((((_c.contents.magic).value) == BU_COLOR_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2472
try:
    BU_RB_LIST_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2510
try:
    BU_RB_TREE_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2546
def BU_RB_TREE_IS_INITIALIZED(_rb):
    return ((_rb != BU_RB_TREE_NULL) and (LIKELY ((((_rb.contents.rbt_magic).value) == BU_RB_TREE_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2552
try:
    BU_RB_DEBUG_INSERT = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2553
try:
    BU_RB_DEBUG_UNIQ = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2554
try:
    BU_RB_DEBUG_ROTATE = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2555
try:
    BU_RB_DEBUG_OS = 8
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2556
try:
    BU_RB_DEBUG_DELETE = 16
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2575
try:
    BU_RB_PKG_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2597
try:
    BU_RB_NODE_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2602
try:
    SENSE_MIN = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2603
try:
    SENSE_MAX = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2604
def bu_rb_min(t, o):
    return (bu_rb_extreme (t, o, SENSE_MIN))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2605
def bu_rb_max(t, o):
    return (bu_rb_extreme (t, o, SENSE_MAX))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2606
def bu_rb_pred(t, o):
    return (bu_rb_neighbor (t, o, SENSE_MIN))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2607
def bu_rb_succ(t, o):
    return (bu_rb_neighbor (t, o, SENSE_MAX))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2612
try:
    PREORDER = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2613
try:
    INORDER = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2614
try:
    POSTORDER = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2626
try:
    BU_OBSERVER_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 2651
def BU_OBSERVER_IS_INITIALIZED(_op):
    return ((_op != BU_OBSERVER_NULL) and (LIKELY ((((_op.contents.magic).value) == BU_OBSERVER_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3110
try:
    BU_FNMATCH_NOESCAPE = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3111
try:
    BU_FNMATCH_PATHNAME = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3112
try:
    BU_FNMATCH_PERIOD = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3113
try:
    BU_FNMATCH_LEADING_DIR = 8
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3114
try:
    BU_FNMATCH_CASEFOLD = 16
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 3119
try:
    BU_FNMATCH_NOMATCH = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4550
def bu_rb_delete1(t):
    return (bu_rb_delete (t, 0))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4621
def bu_rb_curr1(t):
    return (bu_rb_curr (t, 0))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4641
try:
    BU_RB_RETAIN_DATA = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4678
def bu_rb_is_uniq1(t):
    return (bu_rb_is_uniq (t, 0))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4712
def bu_rb_uniq_on1(t):
    return (bu_rb_uniq_on (t, 0))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4721
def bu_rb_uniq_off1(t):
    return (bu_rb_uniq_off (t, 0))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4740
def bu_rb_rank1(t):
    return (bu_rb_rank1 (t, 0))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4751
def bu_rb_select1(t, k):
    return (bu_rb_select (t, 0, k))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4769
def bu_rb_search1(t, d):
    return (bu_rb_search (t, 0, d))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4799
def bu_rb_walk1(t, v, d):
    return (bu_rb_walk (t, 0, v, d))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4824
try:
    BU_SEM_SYSCALL = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4825
try:
    BU_SEM_LISTS = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4826
try:
    BU_SEM_BN_NOISE = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4827
try:
    BU_SEM_MAPPEDFILE = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4828
try:
    BU_SEM_THREAD = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4829
try:
    BU_SEM_MALLOC = 5
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4830
try:
    BU_SEM_DATETIME = 6
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4831
try:
    BU_SEM_LAST = (BU_SEM_DATETIME + 1)
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4838
try:
    BU_SETJUMP = (setjmp (1))
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 4839
try:
    BU_UNSETJUMP = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5377
def BU_STR_EMPTY(s):
    return (((bu_strcmp (s, '')).value) == 0)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5386
def BU_STR_EQUAL(s1, s2):
    return (((bu_strcmp (s1, s2)).value) == 0)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5395
def BU_STR_EQUIV(s1, s2):
    return (((bu_strcasecmp (s1, s2)).value) == 0)

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5604
def BU_GLONGLONG(_cp):
    return (((((((((_cp [0]) << 56) | ((_cp [1]) << 48)) | ((_cp [2]) << 40)) | ((_cp [3]) << 32)) | ((_cp [4]) << 24)) | ((_cp [5]) << 16)) | ((_cp [6]) << 8)) | (_cp [7]))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5618
def BU_GLONG(_cp):
    return (((((_cp [0]) << 24) | ((_cp [1]) << 16)) | ((_cp [2]) << 8)) | (_cp [3]))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5628
def BU_GSHORT(_cp):
    return (((_cp [0]) << 8) | (_cp [1]))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5707
try:
    BU_LEX_ANY = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5712
try:
    BU_LEX_INT = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5717
try:
    BU_LEX_DOUBLE = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5722
try:
    BU_LEX_SYMBOL = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5723
try:
    BU_LEX_KEYWORD = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5728
try:
    BU_LEX_IDENT = 5
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5729
try:
    BU_LEX_NUMBER = 6
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5741
try:
    BU_LEX_NEED_MORE = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5795
try:
    BU_HASH_ENTRY_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5821
def BU_HASH_ENTRY_IS_INITIALIZED(_h):
    return ((_h != BU_HASH_ENTRY_NULL) and (LIKELY ((((_h.contents.magic).value) == BU_HASH_ENTRY_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5835
try:
    BU_HASH_TBL_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5860
def BU_HASH_TBL_IS_INITIALIZED(_h):
    return ((_h != BU_HASH_TBL_NULL) and (LIKELY ((((_h.contents.magic).value) == BU_HASH_TBL_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5873
try:
    BU_HASH_RECORD_NULL = None
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 5899
def BU_HASH_RECORD_IS_INITIALIZED(_h):
    return ((_h != BU_HASH_RECORD_NULL) and (LIKELY ((((_h.contents.magic).value) == BU_HASH_RECORD_MAGIC))))

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6159
try:
    BU_SIMD_SSE4_2 = 7
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6160
try:
    BU_SIMD_SSE4_1 = 6
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6161
try:
    BU_SIMD_SSE3 = 5
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6162
try:
    BU_SIMD_ALTIVEC = 4
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6163
try:
    BU_SIMD_SSE2 = 3
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6164
try:
    BU_SIMD_SSE = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6165
try:
    BU_SIMD_MMX = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6166
try:
    BU_SIMD_NONE = 0
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6216
try:
    BU_RTLD_LAZY = 1
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6217
try:
    BU_RTLD_NOW = 2
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6218
try:
    BU_RTLD_GLOBAL = 256
except:
    pass

# /home/kanzure/local/brlcad/brlcad/include/bu.h: 6219
try:
    BU_RTLD_LOCAL = 0
except:
    pass

bu_list = struct_bu_list # /home/kanzure/local/brlcad/brlcad/include/bu.h: 912

bu_bitv = struct_bu_bitv # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1437

bu_hist = struct_bu_hist # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1607

bu_ptbl = struct_bu_ptbl # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1691

bu_mapped_file = struct_bu_mapped_file # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1807

bu_hook_list = struct_bu_hook_list # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1858

bu_attribute_value_pair = struct_bu_attribute_value_pair # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1914

bu_attribute_value_set = struct_bu_attribute_value_set # /home/kanzure/local/brlcad/brlcad/include/bu.h: 1932

bu_vls = struct_bu_vls # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2026

bu_vlb = struct_bu_vlb # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2082

bu_structparse = struct_bu_structparse # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2278

bu_external = struct_bu_external # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2335

bu_color = struct_bu_color # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2385

bu_rb_node = struct_bu_rb_node # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2584

bu_rb_package = struct_bu_rb_package # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2568

bu_rb_list = struct_bu_rb_list # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2460

bu_rb_tree = struct_bu_rb_tree # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2489

bu_observer = struct_bu_observer # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2620

bu_cmdtab = struct_bu_cmdtab # /home/kanzure/local/brlcad/brlcad/include/bu.h: 2660

bu_lex_t_int = struct_bu_lex_t_int # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5708

bu_lex_t_dbl = struct_bu_lex_t_dbl # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5713

bu_lex_t_key = struct_bu_lex_t_key # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5718

bu_lex_t_id = struct_bu_lex_t_id # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5724

bu_lex_token = union_bu_lex_token # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5730

bu_lex_key = struct_bu_lex_key # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5737

bu_hash_entry = struct_bu_hash_entry # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5787

bu_hash_tbl = struct_bu_hash_tbl # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5827

bu_hash_record = struct_bu_hash_record # /home/kanzure/local/brlcad/brlcad/include/bu.h: 5866

# No inserted files

